unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, MMSystem, ComCtrls, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Panel1: TPanel;
    BtnmixerGetDevCaps: TButton;
    Memo1: TMemo;
    BtnVersion: TButton;
    TabSheet2: TTabSheet;
    Panel2: TPanel;
    Button1: TButton;
    Memo2: TMemo;
    Label1: TLabel;
    procedure BtnmixerGetDevCapsClick(Sender: TObject);
    procedure BtnVersionClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
    Info, MMReg, MMUtils;

//-----------------------------------------------------------------------------
procedure TForm1.BtnVersionClick(Sender: TObject);
begin
    OpenInfoForm();
end;

//-----------------------------------------------------------------------------
procedure TForm1.BtnmixerGetDevCapsClick(Sender: TObject);

    procedure Put(const AText: String);
    begin
        Memo1.Lines.Add(AText);
    end;

var
    LNumDevs: UINT;
    LMixerCaps: TMixerCaps;
    i: Integer;
    LResult: MMRESULT;
    LMixerDetail: TMixerCapsDetail;
    LError: String;
begin
    //  foCX̐擾
    LNumDevs := mixerGetNumDevs();
    Put(Format('mixerGetNumDevs() = %d', [LNumDevs]));

    //  foCX̏擾
    for i := 0 to LNumDevs - 1 do
    begin
        Put(StringOfChar('-', 10)
            + Format('   mixerGetDevCaps(%d)   ', [i])
            + StringOfChar('-', 10));

        LResult := mixerGetDevCaps(i, @LMixerCaps, SizeOf(LMixerCaps));
        LError := mixerGetDevCapsError(LResult);
        if (LError <> '') then
        begin
            Put(LError);
        end
        else
        begin
            LMixerDetail := GetMixerCapsDetail(LMixerCaps);
            Put(Format('MixerCaps.wMid = %d(%s)', [LMixerCaps.wMid, LMixerDetail.Manufacturer]));
            Put(Format('MixerCaps.wPid = %d(%s)', [LMixerCaps.wPid, LMixerDetail.Product]));
            Put(Format('MixerCaps.vDriverVersion = %d(%s)', [LMixerCaps.vDriverVersion, LMixerDetail.DriverVersion]));
            Put(Format('MixerCaps.szPname = %s', [LMixerDetail.ProductName]));
            Put(Format('MixerCaps.fdwSupport = %d', [LMixerCaps.fdwSupport]));
            Put(Format('MixerCaps.cDestinations = %d', [LMixerCaps.cDestinations]));
        end;
    end;
end;


//-----------------------------------------------------------------------------
//  Subject: [Delphi-ML:11553] Re:  MIXERCONTROL֘AŎ
//  Subject: [Delphi-ML:11575] Re:MIXERCONTROL֘AŎ
//  Subject: [Delphi-ML:11590] Re:MIXERCONTROL֘AŎ
procedure TForm1.Button1Click(Sender: TObject);

    procedure Put(const AText: String);
    begin
        Memo2.Lines.Add(AText);
    end;

var
    LNumDevs: Cardinal;
    LMixID: Cardinal;
    LMixCaps: TMixerCaps;
    LResult: MMRESULT;
    LhMixer: HMIXER;
    LError: String;
    i, j: Integer;
    LMixLine: TMixerLine;
    LLineID: DWORD;
    LpMixCtrl: PMixerControl;
    LMixLineCtrls: TMixerLineControls;
    LpMcArray: PMixerControl; 
    LMcDetails: TMixerControlDetails;
    LMcdUnsigned: TMixerControlDetailsUnsigned;
begin
    LNumDevs := mixerGetNumDevs();
    for LMixID := 0 to LNumDevs - 1 do
    begin
        mixerGetDevCaps(LMixID, @LMixCaps, SizeOf(LMixCaps));
        Put(Format('DeviceName:%s Desitination:%d',
                   [LMixCaps.szPname, LMixCaps.cDestinations]));
        LResult := mixerOpen(@LhMixer, LMixID, 0, 0, MIXER_OBJECTF_MIXER);
        LError := mixerOpenError(LResult);
        if (LError <> '') then
        begin
            Put(LError);
        end
        else
        begin
            try
                //  C̃Co̓Xs[JT
                for i := 0 to LMixCaps.cDestinations - 1 do
                begin
                    FillChar(LMixLine, 0, SizeOf(LMixLine));
                    LMixLine.cbStruct := SizeOf(LMixLine);
                    LMixLine.dwDestination := i;
                    LResult := mixerGetLineInfo(LhMixer, @LMixLine, MIXER_GETLINEINFOF_DESTINATION);
                    LError := mixerGetLineInfoError(LResult);
                    if (LError <> '') then
                    begin
                        Put(LError);
                    end
                    else
                    begin
                        if (LMixLine.dwComponentType = MIXERLINE_COMPONENTTYPE_DST_SPEAKERS) then
                        begin
                            //  Xs[J[
                            LLineID := LMixLine.dwLineID;
                            FillChar(LMixLine, 0, SizeOf(LMixLine));
                            LMixLine.cbStruct := SizeOf(LMixLine);
                            LMixLine.dwLineID := LLineID;
                            LResult := mixerGetLineInfo(LhMixer, @LMixLine, MIXER_GETLINEINFOF_LINEID);
                            LError := mixerGetLineInfoError(LResult);
                            if (LError <> '') then
                            begin
                                Put(LError);
                            end
                            else
                            begin
                                //  Rg[̊
                                try
                                    GetMem(PChar(LpMixCtrl), SizeOf(TMixerControl) * LMixLine.cControls);
                                    try
                                        FillChar(LMixLineCtrls, 0, SizeOf(LMixLineCtrls));
                                        LMixLineCtrls.cbStruct := SizeOf(LMixLineCtrls);
                                        LMixLineCtrls.dwLineID := LLineID;
                                        LMixLineCtrls.dwControlID := 0;
                                        LMixLineCtrls.dwControlType := 0;
                                        LMixLineCtrls.cControls := LMixLine.cControls;
                                        LMixLineCtrls.cbmxctrl := SizeOf(TMixerControl);
                                        LMixLineCtrls.pamxctrl := LpMixCtrl;

                                        LResult := mixerGetLineControls(LhMixer, @LMixLineCtrls, MIXER_GETLINECONTROLSF_ALL);
                                        LError := mixerGetLineControlsError(LResult);
                                        if (LError <> '') then
                                        begin
                                            Put(LError);
                                        end
                                        else         
                                        begin
                                            for j := 0 to LMixLineCtrls.cControls - 1 do
                                            begin
                                                LpMcArray := PMixerControl(PChar(LpMixCtrl) + SizeOf(TMixerControl) * j);
                                                if (LpMcArray^.dwControlType = MIXERCONTROL_CONTROLTYPE_VOLUME) then
                                                begin
                                                    //  u}X^ʁv
                                                    Put(Format('ShortName:%s',[LpMcArray^.szShortName]));
                                                    //  Rg[̏
                                                    FillChar(LMcDetails, 0, SizeOf(LMcDetails));
                                                    LMcDetails.cbStruct := SizeOf(LMcDetails);
                                                    LMcDetails.dwControlID := LpMcArray^.dwControlID;
                                                    LMcDetails.cChannels := LMixLine.cChannels;
                                                    LMcDetails.cMultipleItems := 0;
                                                    LMcDetails.cbDetails := SizeOf(LMcdUnsigned);
                                                    LMcDetails.paDetails := @LMcdUnsigned;

                                                    //  s LpMixCtrl Ĥ FreeMem łȂ
                                                    LResult := mixerGetControlDetails(LhMixer, @LMcDetails, MIXER_GETCONTROLDETAILSF_VALUE);
                                                    LError := mixerGetControlDetailsError(LResult);
                                                    if (LError <> '') then
                                                    begin
                                                        Put(LError);
                                                    end
                                                    else
                                                    begin
                                                        Put(Format('Volume = %d', [LMcdUnsigned.dwValue]))
                                                    end;
                                                end;
                                            end;    //  j
                                        end;
                                    finally
                                        FreeMem(LpMixCtrl, SizeOf(TMixerControl) * LMixLine.cControls);
                                    end;
                                except
                                    on E: Exception do Put(E.Message);
                                end;
                            end;
                        end;
                    end;    
                end;    //  i
            finally
                mixerClose(LhMixer);
            end;
        end;
    end;
end;

end.



