(*
Copyright (C) Microsoft Corporation,1991-1999
Module Name: mmreg.h
Abstract: Multimedia Registration
Revision History:
*)

//  2008.01.20  Ԃ̖

unit MMReg;

interface

uses
    Windows, SysUtils, MMSystem;

type
    TMixerCapsDetail = record
        Manufacturer: String;
        Product: String;
        DriverVersion: String;
        ProductName: String;
        fdwSupport: DWORD;
        cDestinations: DWORD;
    end;

//=============================================================================
//  manufacturer IDs
const
    MM_MICROSOFT                 = 1  ;         //'Microsoft Corporation'
    MM_CREATIVE                  = 2  ;         //'Creative Labs, Inc.'
    MM_MEDIAVISION               = 3  ;         //'Media Vision, Inc.'
    MM_FUJITSU                   = 4  ;         //'Fujitsu Corp.'
    MM_PRAGMATRAX                = 5  ;         //'PRAGMATRAX Software'
    MM_CYRIX                     = 6  ;         //'Cyrix Corporation'
    MM_PHILIPS_SPEECH_PROCESSING = 7  ;         //'Philips Speech Processing'
    MM_NETXL                     = 8  ;         //'NetXL, Inc.'
    MM_ZYXEL                     = 9  ;         //'ZyXEL Communications, Inc.'
    MM_BECUBED                   = 10 ;         //'BeCubed Software Inc.'
    MM_AARDVARK                  = 11 ;         //'Aardvark Computer Systems, Inc.'
    MM_BINTEC                    = 12 ;         //'Bin Tec Communications GmbH'
    MM_HEWLETT_PACKARD           = 13 ;         //'Hewlett-Packard Company'
    MM_ACULAB                    = 14 ;         //'Aculab plc'
    MM_FAITH                     = 15 ;         //'Faith,Inc.'
    MM_MITEL                     = 16 ;         //'Mitel Corporation'
    MM_QUANTUM3D                 = 17 ;         //'Quantum3D, Inc.'
    MM_SNI                       = 18 ;         //'Siemens-Nixdorf'
    MM_EMU                       = 19 ;         //'E-mu Systems, Inc.'
    MM_ARTISOFT                  = 20 ;         //'Artisoft, Inc.'
    MM_TURTLE_BEACH              = 21 ;         //'Turtle Beach, Inc.'
    MM_IBM                       = 22 ;         //'IBM Corporation'
    MM_VOCALTEC                  = 23 ;         //'Vocaltec Ltd.'
    MM_ROLAND                    = 24 ;         //'Roland'
    MM_DSP_SOLUTIONS             = 25 ;         //'DSP Solutions, Inc.'
    MM_NEC                       = 26 ;         //'NEC'
    MM_ATI                       = 27 ;         //'ATI Technologies Inc.'
    MM_WANGLABS                  = 28 ;         //'Wang Laboratories, Inc.'
    MM_TANDY                     = 29 ;         //'Tandy Corporation'
    MM_VOYETRA                   = 30 ;         //'Voyetra'
    MM_ANTEX                     = 31 ;         //'Antex Electronics Corporation'
    MM_ICL_PS                    = 32 ;         //'ICL Personal Systems'
    MM_INTEL                     = 33 ;         //'Intel Corporation'
    MM_GRAVIS                    = 34 ;         //'Advanced Gravis'
    MM_VAL                       = 35 ;         //'Video Associates Labs, Inc.'
    MM_INTERACTIVE               = 36 ;         //'InterActive Inc.'
    MM_YAMAHA                    = 37 ;         //'Yamaha Corporation of America'
    MM_EVEREX                    = 38 ;         //'Everex Systems, Inc.'
    MM_ECHO                      = 39 ;         //'Echo Speech Corporation'
    MM_SIERRA                    = 40 ;         //'Sierra Semiconductor Corp'
    MM_CAT                       = 41 ;         //'Computer Aided Technologies'
    MM_APPS                      = 42 ;         //'APPS Software International'
    MM_DSP_GROUP                 = 43 ;         //'DSP Group, Inc.'
    MM_MELABS                    = 44 ;         //'microEngineering Labs'
    MM_COMPUTER_FRIENDS          = 45 ;         //'Computer Friends, Inc.'
    MM_ESS                       = 46 ;         //'ESS Technology'
    MM_AUDIOFILE                 = 47 ;         //'Audio, Inc.'
    MM_MOTOROLA                  = 48 ;         //'Motorola, Inc.'
    MM_CANOPUS                   = 49 ;         //'Canopus, co., Ltd.'
    MM_EPSON                     = 50 ;         //'Seiko Epson Corporation'
    MM_TRUEVISION                = 51 ;         //'Truevision'
    MM_AZTECH                    = 52 ;         //'Aztech Labs, Inc.'
    MM_VIDEOLOGIC                = 53 ;         //'Videologic'
    MM_SCALACS                   = 54 ;         //'SCALACS'
    MM_KORG                      = 55 ;         //'Korg Inc.'
    MM_APT                       = 56 ;         //'Audio Processing Technology'
    MM_ICS                       = 57 ;         //'Integrated Circuit Systems, Inc.'
    MM_ITERATEDSYS               = 58 ;         //'Iterated Systems, Inc.'
    MM_METHEUS                   = 59 ;         //'Metheus'
    MM_LOGITECH                  = 60 ;         //'Logitech, Inc.'
    MM_WINNOV                    = 61 ;         //'Winnov, Inc.'
    MM_NCR                       = 62 ;         //'NCR Corporation'
    MM_EXAN                      = 63 ;         //'EXAN'
    MM_AST                       = 64 ;         //'AST Research Inc.'
    MM_WILLOWPOND                = 65 ;         //'Willow Pond Corporation'
    MM_SONICFOUNDRY              = 66 ;         //'Sonic Foundry'
    MM_VITEC                     = 67 ;         //'Vitec Multimedia'
    MM_MOSCOM                    = 68 ;         //'MOSCOM Corporation'
    MM_SILICONSOFT               = 69 ;         //'Silicon Soft, Inc.'
    MM_TERRATEC                  = 70 ;         //'TerraTec Electronic GmbH'
    MM_MEDIASONIC                = 71 ;         //'MediaSonic Ltd.'
    MM_SANYO                     = 72 ;         //'SANYO Electric Co., Ltd.'
    MM_SUPERMAC                  = 73 ;         //'Supermac'
    MM_AUDIOPT                   = 74 ;         //'Audio Processing Technology'
    MM_NOGATECH                  = 75 ;         //'NOGATECH Ltd.'
    MM_SPEECHCOMP                = 76 ;         //'Speech Compression'
    MM_AHEAD                     = 77 ;         //'Ahead, Inc.'
    MM_DOLBY                     = 78 ;         //'Dolby Laboratories'
    MM_OKI                       = 79 ;         //'OKI'
    MM_AURAVISION                = 80 ;         //'AuraVision Corporation'
    MM_OLIVETTI                  = 81 ;         //'Ing C. Olivetti & C., S.p.A.'
    MM_IOMAGIC                   = 82 ;         //'I/O Magic Corporation'
    MM_MATSUSHITA                = 83 ;         //'Matsushita Electric Industrial Co., Ltd.'
    MM_CONTROLRES                = 84 ;         //'Control Resources Limited'
    MM_XEBEC                     = 85 ;         //'Xebec Multimedia Solutions Limited'
    MM_NEWMEDIA                  = 86 ;         //'New Media Corporation'
    MM_NMS                       = 87 ;         //'Natural MicroSystems'
    MM_LYRRUS                    = 88 ;         //'Lyrrus Inc.'
    MM_COMPUSIC                  = 89 ;         //'Compusic'
    MM_OPTI                      = 90 ;         //'OPTi Computers Inc.'
    MM_ADLACC                    = 91 ;         //'Adlib Accessories Inc.'
    MM_COMPAQ                    = 92 ;         //'Compaq Computer Corp.'
    MM_DIALOGIC                  = 93 ;         //'Dialogic Corporation'
    MM_INSOFT                    = 94 ;         //'InSoft, Inc.'
    MM_MPTUS                     = 95 ;         //'M.P. Technologies, Inc.'
    MM_WEITEK                    = 96 ;         //'Weitek'
    MM_LERNOUT_AND_HAUSPIE       = 97 ;         //'Lernout & Hauspie'
    MM_QCIAR                     = 98 ;         //'Quanta Computer Inc.'
    MM_APPLE                     = 99 ;         //'Apple Computer, Inc.'
    MM_DIGITAL                   = 100;         //'Digital Equipment Corporation'
    MM_MOTU                      = 101;         //'Mark of the Unicorn'
    MM_WORKBIT                   = 102;         //'Workbit Corporation'
    MM_OSITECH                   = 103;         //'Ositech Communications Inc.'
    MM_MIRO                      = 104;         //'miro Computer Products AG'
    MM_CIRRUSLOGIC               = 105;         //'Cirrus Logic'
    MM_ISOLUTION                 = 106;         //'ISOLUTION  B.V.'
    MM_HORIZONS                  = 107;         //'Horizons Technology, Inc.'
    MM_CONCEPTS                  = 108;         //'Computer Concepts Ltd.'
    MM_VTG                       = 109;         //'Voice Technologies Group, Inc.'
    MM_RADIUS                    = 110;         //'Radius'
    MM_ROCKWELL                  = 111;         //'Rockwell International'
    MM_XYZ                       = 112;         //'Co. XYZ for testing'
    MM_OPCODE                    = 113;         //'Opcode Systems'
    MM_VOXWARE                   = 114;         //'Voxware Inc.'
    MM_NORTHERN_TELECOM          = 115;         //'Northern Telecom Limited'
    MM_APICOM                    = 116;         //'APICOM'
    MM_GRANDE                    = 117;         //'Grande Software'
    MM_ADDX                      = 118;         //'ADDX'
    MM_WILDCAT                   = 119;         //'Wildcat Canyon Software'
    MM_RHETOREX                  = 120;         //'Rhetorex Inc.'
    MM_BROOKTREE                 = 121;         //'Brooktree Corporation'
    MM_ENSONIQ                   = 125;         //'ENSONIQ Corporation'
    MM_FAST                      = 126;         //'FAST Multimedia AG'
    MM_NVIDIA                    = 127;         //'NVidia Corporation'
    MM_OKSORI                    = 128;         //'OKSORI Co., Ltd.'
    MM_DIACOUSTICS               = 129;         //'DiAcoustics, Inc.'
    MM_GULBRANSEN                = 130;         //'Gulbransen, Inc.'
    MM_KAY_ELEMETRICS            = 131;         //'Kay Elemetrics, Inc.'
    MM_CRYSTAL                   = 132;         //'Crystal Semiconductor Corporation'
    MM_SPLASH_STUDIOS            = 133;         //'Splash Studios'
    MM_QUARTERDECK               = 134;         //'Quarterdeck Corporation'
    MM_TDK                       = 135;         //'TDK Corporation'
    MM_DIGITAL_AUDIO_LABS        = 136;         //'Digital Audio Labs, Inc.'
    MM_SEERSYS                   = 137;         //'Seer Systems, Inc.'
    MM_PICTURETEL                = 138;         //'PictureTel Corporation'
    MM_ATT_MICROELECTRONICS      = 139;         //'AT&T Microelectronics'
    MM_OSPREY                    = 140;         //'Osprey Technologies, Inc.'
    MM_MEDIATRIX                 = 141;         //'Mediatrix Peripherals'
    MM_SOUNDESIGNS               = 142;         //'SounDesignS M.C.S. Ltd.'
    MM_ALDIGITAL                 = 143;         //'A.L. Digital Ltd.'
    MM_SPECTRUM_SIGNAL_PROCESSING= 144;         //'Spectrum Signal Processing, Inc.'
    MM_ECS                       = 145;         //'Electronic Courseware Systems, Inc.'
    MM_AMD                       = 146;         //'AMD'
    MM_COREDYNAMICS              = 147;         //'Core Dynamics'
    MM_CANAM                     = 148;         //'CANAM Computers'
    MM_SOFTSOUND                 = 149;         //'Softsound, Ltd.'
    MM_NORRIS                    = 150;         //'Norris Communications, Inc.'
    MM_DDD                       = 151;         //'Danka Data Devices'
    MM_EUPHONICS                 = 152;         //'EuPhonics'
    MM_PRECEPT                   = 153;         //'Precept Software, Inc.'
    MM_CRYSTAL_NET               = 154;         //'Crystal Net Corporation'
    MM_CHROMATIC                 = 155;         //'Chromatic Research, Inc.'
    MM_VOICEINFO                 = 156;         //'Voice Information Systems, Inc.'
    MM_VIENNASYS                 = 157;         //'Vienna Systems'
    MM_CONNECTIX                 = 158;         //'Connectix Corporation'
    MM_GADGETLABS                = 159;         //'Gadget Labs LLC'
    MM_FRONTIER                  = 160;         //'Frontier Design Group LLC'
    MM_VIONA                     = 161;         //'Viona Development GmbH'
    MM_CASIO                     = 162;         //'Casio Computer Co., LTD'
    MM_DIAMONDMM                 = 163;         //'Diamond Multimedia'
    MM_S3                        = 164;         //'S3'
    MM_DVISION                   = 165;         //'D-Vision Systems, Inc.'
    MM_NETSCAPE                  = 166;         //'Netscape Communications'
    MM_SOUNDSPACE                = 167;         //'Soundspace Audio'
    MM_VANKOEVERING              = 168;         //'VanKoevering Company'
    MM_QTEAM                     = 169;         //'Q-Team'
    MM_ZEFIRO                    = 170;         //'Zefiro Acoustics'
    MM_STUDER                    = 171;         //'Studer Professional Audio AG'
    MM_FRAUNHOFER_IIS            = 172;         //'Fraunhofer IIS'
    MM_QUICKNET                  = 173;         //'Quicknet Technologies'
    MM_ALARIS                    = 174;         //'Alaris, Inc.'
    MM_SICRESOURCE               = 175;         //'SIC Resource Inc.'
    MM_NEOMAGIC                  = 176;         //'NeoMagic Corporation'
    MM_MERGING_TECHNOLOGIES      = 177;         //'Merging Technologies S.A.'
    MM_XIRLINK                   = 178;         //'Xirlink, Inc.'
    MM_COLORGRAPH                = 179;         //'Colorgraph (UK) Ltd'
    MM_OTI                       = 180;         //'Oak Technology, Inc.'
    MM_AUREAL                    = 181;         //'Aureal Semiconductor'
    MM_VIVO                      = 182;         //'Vivo Software'
    MM_SHARP                     = 183;         //'Sharp'
    MM_LUCENT                    = 184;         //'Lucent Technologies'
    MM_ATT                       = 185;         //'AT&T Labs, Inc.'
    MM_SUNCOM                    = 186;         //'Sun Communications, Inc.'
    MM_SORVIS                    = 187;         //'Sorenson Vision'
    MM_INVISION                  = 188;         //'InVision Interactive'
    MM_BERKOM                    = 189;         //'Deutsche Telekom Berkom GmbH'
    MM_MARIAN                    = 190;         //'Marian GbR Leipzig'
    MM_DPSINC                    = 191;         //'Digital Processing Systems, Inc.'
    MM_BCB                       = 192;         //'BCB Holdings Inc.'
    MM_MOTIONPIXELS              = 193;         //'Motion Pixels'
    MM_QDESIGN                   = 194;         //'QDesign Corporation'
    MM_NMP                       = 195;         //'Nokia Mobile Phones'
    MM_DATAFUSION                = 196;         //'DataFusion Systems (Pty) (Ltd)'
    MM_DUCK                      = 197;         //'The Duck Corporation'
    MM_FTR                       = 198;         //'Future Technology Resources Pty Ltd'
    MM_BERCOS                    = 199;         //'BERCOS GmbH'
    MM_ONLIVE                    = 200;         //'OnLive! Technologies, Inc.'
    MM_SIEMENS_SBC               = 201;         //'Siemens Business Communications Systems'
    MM_TERALOGIC                 = 202;         //'TeraLogic, Inc.'
    MM_PHONET                    = 203;         //'PhoNet Communications Ltd.'
    MM_WINBOND                   = 204;         //'Winbond Electronics Corp'
    MM_VIRTUALMUSIC              = 205;         //'Virtual Music, Inc.'
    MM_ENET                      = 206;         //'e-Net, Inc.'
    MM_GUILLEMOT                 = 207;         //'Guillemot International'
    MM_EMAGIC                    = 208;         //'Emagic Soft- und Hardware GmbH'
    MM_MWM                       = 209;         //'MWM Acoustics LLC'
    MM_PACIFICRESEARCH           = 210;         //'Pacific Research and Engineering Corporation'
    MM_SIPROLAB                  = 211;         //'Sipro Lab Telecom Inc.'
    MM_LYNX                      = 212;         //'Lynx Studio Technology, Inc.'
    MM_SPECTRUM_PRODUCTIONS      = 213;         //'Spectrum Productions'
    MM_DICTAPHONE                = 214;         //'Dictaphone Corporation'
    MM_QUALCOMM                  = 215;         //'QUALCOMM, Inc.'
    MM_RZS                       = 216;         //'Ring Zero Systems, Inc'
    MM_AUDIOSCIENCE              = 217;         //'AudioScience Inc.'
    MM_PINNACLE                  = 218;         //'Pinnacle Systems, Inc.'
    MM_EES                       = 219;         //'EES Technik fuer Musik GmbH'
    MM_HAFTMANN                  = 220;         //'haftmann#software'
    MM_LUCID                     = 221;         //'Lucid Technology, Symetrix Inc.'
    MM_HEADSPACE                 = 222;         //'Headspace, Inc'
    MM_UNISYS                    = 223;         //'UNISYS CORPORATION'
    MM_LUMINOSITI                = 224;         //'Luminositi, Inc.'
    MM_ACTIVEVOICE               = 225;         //'ACTIVE VOICE CORPORATION'
    MM_DTS                       = 226;         //'Digital Theater Systems, Inc.'
    MM_DIGIGRAM                  = 227;         //'DIGIGRAM'
    MM_SOFTLAB_NSK               = 228;         //'Softlab-Nsk'
    MM_FORTEMEDIA                = 229;         //'ForteMedia, Inc'
    MM_SONORUS                   = 230;         //'Sonorus, Inc.'
    MM_ARRAY                     = 231;         //'Array Microsystems, Inc.'
    MM_DATARAN                   = 232;         //'Data Translation, Inc.'
    MM_I_LINK                    = 233;         //'I-link Worldwide'
    MM_SELSIUS_SYSTEMS           = 234;         //'Selsius Systems Inc.'
    MM_ADMOS                     = 235;         //'AdMOS Technology, Inc.'
    MM_LEXICON                   = 236;         //'Lexicon Inc.'
    MM_SGI                       = 237;         //'Silicon Graphics Inc.'
    MM_IPI                       = 238;         //'Interactive Product Inc.'
    MM_ICE                       = 239;         //'IC Ensemble, Inc.'
    MM_VQST                      = 240;         //'ViewQuest Technologies Inc.'
    MM_ETEK                      = 241;         //'eTEK Labs Inc.'
    MM_CS                        = 242;         //'Consistent Software'
    MM_ALESIS                    = 243;         //'Alesis Studio Electronics'
    MM_INTERNET                  = 244;         //'INTERNET Corporation'
    MM_SONY                      = 245;         //'Sony Corporation'
    MM_HYPERACTIVE               = 246;         //'Hyperactive Audio Systems, Inc.'
    MM_UHER_INFORMATIC           = 247;         //'UHER informatic GmbH'
    MM_SYDEC_NV                  = 248;         //'Sydec NV'
    MM_FLEXION                   = 249;         //'Flexion Systems Ltd.'
    MM_VIA                       = 250;         //'Via Technologies, Inc.'
    MM_MICRONAS                  = 251;         //'Micronas Semiconductors, Inc.'
    MM_ANALOGDEVICES             = 252;         //'Analog Devices, Inc.'
    MM_HP                        = 253;         //'Hewlett Packard Company'
    MM_MATROX_DIV                = 254;         //'Matrox'
    MM_QUICKAUDIO                = 255;         //'Quick Audio, GbR'
    MM_YOUCOM                    = 256;         //'You/Com Audiocommunicatie BV'
    MM_RICHMOND                  = 257;         //'Richmond Sound Design Ltd.'
    MM_IODD                      = 258;         //'I-O Data Device, Inc.'
    MM_ICCC                      = 259;         //'ICCC A/S'
    MM_3COM                      = 260;         //'3COM Corporation'
    MM_MALDEN                    = 261;         //'Malden Electronics Ltd.'
    MM_3DFX                      = 262;         //'3Dfx Interactive, Inc.'
    MM_MINDMAKER                 = 263;         //'Mindmaker, Inc.'
    MM_TELEKOL                   = 264;         //'Telekol Corp.'
    MM_ST_MICROELECTRONICS       = 265;         //'ST Microelectronics'
    MM_ALGOVISION                = 266;         //'Algo Vision Systems GmbH'
    MM_UNMAPPED                  = $ffff;       //'Unidentified Manufacturer'

//-----------------------------------------------------------------------------                                      
//  MM_MICROSOFT product IDs
    MM_MIDI_MAPPER                    = 1  ;    //'Midi Mapper'
    MM_WAVE_MAPPER                    = 2  ;    //'Wave Mapper'
    MM_SNDBLST_MIDIOUT                = 3  ;    //'Sound Blaster MIDI output port'
    MM_SNDBLST_MIDIIN                 = 4  ;    //'Sound Blaster MIDI input port'
    MM_SNDBLST_SYNTH                  = 5  ;    //'Sound Blaster internal synth'
    MM_SNDBLST_WAVEOUT                = 6  ;    //'Sound Blaster waveform output'
    MM_SNDBLST_WAVEIN                 = 7  ;    //'Sound Blaster waveform input'
    MM_ADLIB                          = 9  ;    //'Ad Lib Compatible synth'
    MM_MPU401_MIDIOUT                 = 10 ;    //'MPU 401 compatible MIDI output port'
    MM_MPU401_MIDIIN                  = 11 ;    //'MPU 401 compatible MIDI input port'
    MM_PC_JOYSTICK                    = 12 ;    //'Joystick adapter'
    MM_PCSPEAKER_WAVEOUT              = 13 ;    //'PC speaker waveform output'
    MM_MSFT_WSS_WAVEIN                = 14 ;    //'MS Audio Board waveform input'
    MM_MSFT_WSS_WAVEOUT               = 15 ;    //'MS Audio Board waveform output'
    MM_MSFT_WSS_FMSYNTH_STEREO        = 16 ;    //'MS Audio Board  Stereo FM synth'
    MM_MSFT_WSS_MIXER                 = 17 ;    //'MS Audio Board Mixer Driver'
    MM_MSFT_WSS_OEM_WAVEIN            = 18 ;    //'MS OEM Audio Board waveform input'
    MM_MSFT_WSS_OEM_WAVEOUT           = 19 ;    //'MS OEM Audio Board waveform output'
    MM_MSFT_WSS_OEM_FMSYNTH_STEREO    = 20 ;    //'MS OEM Audio Board Stereo FM Synth'
    MM_MSFT_WSS_AUX                   = 21 ;    //'MS Audio Board Aux. Port'
    MM_MSFT_WSS_OEM_AUX               = 22 ;    //'MS OEM Audio Aux Port'
    MM_MSFT_GENERIC_WAVEIN            = 23 ;    //'MS Vanilla driver waveform input'
    MM_MSFT_GENERIC_WAVEOUT           = 24 ;    //'MS Vanilla driver wavefrom output'
    MM_MSFT_GENERIC_MIDIIN            = 25 ;    //'MS Vanilla driver MIDI in'
    MM_MSFT_GENERIC_MIDIOUT           = 26 ;    //'MS Vanilla driver MIDI  external out'
    MM_MSFT_GENERIC_MIDISYNTH         = 27 ;    //'MS Vanilla driver MIDI synthesizer'
    MM_MSFT_GENERIC_AUX_LINE          = 28 ;    //'MS Vanilla driver aux (line in)'
    MM_MSFT_GENERIC_AUX_MIC           = 29 ;    //'MS Vanilla driver aux (mic)'
    MM_MSFT_GENERIC_AUX_CD            = 30 ;    //'MS Vanilla driver aux (CD)'
    MM_MSFT_WSS_OEM_MIXER             = 31 ;    //'MS OEM Audio Board Mixer Driver'
    MM_MSFT_MSACM                     = 32 ;    //'MS Audio Compression Manager'
    MM_MSFT_ACM_MSADPCM               = 33 ;    //'MS ADPCM Codec'
    MM_MSFT_ACM_IMAADPCM              = 34 ;    //'IMA ADPCM Codec'
    MM_MSFT_ACM_MSFILTER              = 35 ;    //'MS Filter'
    MM_MSFT_ACM_GSM610                = 36 ;    //'GSM 610 codec'
    MM_MSFT_ACM_G711                  = 37 ;    //'G.711 codec'
    MM_MSFT_ACM_PCM                   = 38 ;    //'PCM converter'

    // Microsoft Windows Sound System drivers
    MM_WSS_SB16_WAVEIN                = 39 ;    //'Sound Blaster 16 waveform input'
    MM_WSS_SB16_WAVEOUT               = 40 ;    //'Sound Blaster 16  waveform output'
    MM_WSS_SB16_MIDIIN                = 41 ;    //'Sound Blaster 16 midi-in'
    MM_WSS_SB16_MIDIOUT               = 42 ;    //'Sound Blaster 16 midi out'
    MM_WSS_SB16_SYNTH                 = 43 ;    //'Sound Blaster 16 FM Synthesis'
    MM_WSS_SB16_AUX_LINE              = 44 ;    //'Sound Blaster 16 aux (line in)'
    MM_WSS_SB16_AUX_CD                = 45 ;    //'Sound Blaster 16 aux (CD)'
    MM_WSS_SB16_MIXER                 = 46 ;    //'Sound Blaster 16 mixer device'
    MM_WSS_SBPRO_WAVEIN               = 47 ;    //'Sound Blaster Pro waveform input'
    MM_WSS_SBPRO_WAVEOUT              = 48 ;    //'Sound Blaster Pro waveform output'
    MM_WSS_SBPRO_MIDIIN               = 49 ;    //'Sound Blaster Pro midi in'
    MM_WSS_SBPRO_MIDIOUT              = 50 ;    //'Sound Blaster Pro midi out'
    MM_WSS_SBPRO_SYNTH                = 51 ;    //'Sound Blaster Pro FM synthesis'
    MM_WSS_SBPRO_AUX_LINE             = 52 ;    //'Sound Blaster Pro aux (line in )'
    MM_WSS_SBPRO_AUX_CD               = 53 ;    //'Sound Blaster Pro aux (CD)'
    MM_WSS_SBPRO_MIXER                = 54 ;    //'Sound Blaster Pro mixer'
    MM_MSFT_WSS_NT_WAVEIN             = 55 ;    //'WSS NT wave in'
    MM_MSFT_WSS_NT_WAVEOUT            = 56 ;    //'WSS NT wave out'
    MM_MSFT_WSS_NT_FMSYNTH_STEREO     = 57 ;    //'WSS NT FM synth'
    MM_MSFT_WSS_NT_MIXER              = 58 ;    //'WSS NT mixer'
    MM_MSFT_WSS_NT_AUX                = 59 ;    //'WSS NT aux'
    MM_MSFT_SB16_WAVEIN               = 60 ;    //'Sound Blaster 16 waveform input'
    MM_MSFT_SB16_WAVEOUT              = 61 ;    //'Sound Blaster 16  waveform output'
    MM_MSFT_SB16_MIDIIN               = 62 ;    //'Sound Blaster 16 midi-in'
    MM_MSFT_SB16_MIDIOUT              = 63 ;    //'Sound Blaster 16 midi out'
    MM_MSFT_SB16_SYNTH                = 64 ;    //'Sound Blaster 16 FM Synthesis'
    MM_MSFT_SB16_AUX_LINE             = 65 ;    //'Sound Blaster 16 aux (line in)'
    MM_MSFT_SB16_AUX_CD               = 66 ;    //'Sound Blaster 16 aux (CD)'
    MM_MSFT_SB16_MIXER                = 67 ;    //'Sound Blaster 16 mixer device'
    MM_MSFT_SBPRO_WAVEIN              = 68 ;    //'Sound Blaster Pro waveform input'
    MM_MSFT_SBPRO_WAVEOUT             = 69 ;    //'Sound Blaster Pro waveform output'
    MM_MSFT_SBPRO_MIDIIN              = 70 ;    //'Sound Blaster Pro midi in'
    MM_MSFT_SBPRO_MIDIOUT             = 71 ;    //'Sound Blaster Pro midi out'
    MM_MSFT_SBPRO_SYNTH               = 72 ;    //'Sound Blaster Pro FM synthesis'
    MM_MSFT_SBPRO_AUX_LINE            = 73 ;    //'Sound Blaster Pro aux (line in)'
    MM_MSFT_SBPRO_AUX_CD              = 74 ;    //'Sound Blaster Pro aux (CD)'
    MM_MSFT_SBPRO_MIXER               = 75 ;    //'Sound Blaster Pro mixer'

    MM_MSFT_MSOPL_SYNTH               = 76 ;    //'Yamaha OPL2/OPL3 compatible FM synthesis'

    MM_MSFT_VMDMS_LINE_WAVEIN         = 80 ;   //'Voice Modem Serial Line Wave Input'
    MM_MSFT_VMDMS_LINE_WAVEOUT        = 81 ;   //'Voice Modem Serial Line Wave Output'
    MM_MSFT_VMDMS_HANDSET_WAVEIN      = 82 ;   //'Voice Modem Serial Handset Wave Input'
    MM_MSFT_VMDMS_HANDSET_WAVEOUT     = 83 ;   //'Voice Modem Serial Handset Wave Output'
    MM_MSFT_VMDMW_LINE_WAVEIN         = 84 ;   //'Voice Modem Wrapper Line Wave Input'
    MM_MSFT_VMDMW_LINE_WAVEOUT        = 85 ;   //'Voice Modem Wrapper Line Wave Output'
    MM_MSFT_VMDMW_HANDSET_WAVEIN      = 86 ;   //'Voice Modem Wrapper Handset Wave Input'
    MM_MSFT_VMDMW_HANDSET_WAVEOUT     = 87 ;   //'Voice Modem Wrapper Handset Wave Output'
    MM_MSFT_VMDMW_MIXER               = 88 ;   //'Voice Modem Wrapper Mixer'
    MM_MSFT_VMDM_GAME_WAVEOUT         = 89 ;   //'Voice Modem Game Compatible Wave Device'
    MM_MSFT_VMDM_GAME_WAVEIN          = 90 ;   //'Voice Modem Game Compatible Wave Device'

    MM_MSFT_ACM_MSNAUDIO              = 91 ;
    MM_MSFT_ACM_MSG723                = 92 ;
    MM_MSFT_ACM_MSRT24                = 93 ;

    MM_MSFT_WDMAUDIO_WAVEOUT          = 100;   //'Generic id for WDM Audio drivers'
    MM_MSFT_WDMAUDIO_WAVEIN           = 101;   //'Generic id for WDM Audio drivers'
    MM_MSFT_WDMAUDIO_MIDIOUT          = 102;   //'Generic id for WDM Audio drivers'
    MM_MSFT_WDMAUDIO_MIDIIN           = 103;   //'Generic id for WDM Audio drivers'
    MM_MSFT_WDMAUDIO_MIXER            = 104;   //'Generic id for WDM Audio drivers'
    MM_MSFT_WDMAUDIO_AUX              = 105;   //'Generic id for WDM Audio drivers'

//-----------------------------------------------------------------------------                                      
//  MM_CREATIVE product IDs
    MM_CREATIVE_SB15_WAVEIN           = 1  ;    //'SB (r) 1.5 waveform input'
    MM_CREATIVE_SB20_WAVEIN           = 2  ;
    MM_CREATIVE_SBPRO_WAVEIN          = 3  ;
    MM_CREATIVE_SBP16_WAVEIN          = 4  ;
    MM_CREATIVE_PHNBLST_WAVEIN        = 5  ;
    MM_CREATIVE_SB15_WAVEOUT          = 101;
    MM_CREATIVE_SB20_WAVEOUT          = 102;
    MM_CREATIVE_SBPRO_WAVEOUT         = 103;
    MM_CREATIVE_SBP16_WAVEOUT         = 104;
    MM_CREATIVE_PHNBLST_WAVEOUT       = 105;
    MM_CREATIVE_MIDIOUT               = 201;    //'SB (r)'
    MM_CREATIVE_MIDIIN                = 202;    //'SB (r)'
    MM_CREATIVE_FMSYNTH_MONO          = 301;    //'SB (r)'
    MM_CREATIVE_FMSYNTH_STEREO        = 302;    //'SB Pro (r) stereo synthesizer'
    MM_CREATIVE_MIDI_AWE32            = 303;
    MM_CREATIVE_AUX_CD                = 401;    //'SB Pro (r) aux (CD)'
    MM_CREATIVE_AUX_LINE              = 402;    //'SB Pro (r) aux (Line in )'
    MM_CREATIVE_AUX_MIC               = 403;    //'SB Pro (r) aux (mic)'
    MM_CREATIVE_AUX_MASTER            = 404;
    MM_CREATIVE_AUX_PCSPK             = 405;
    MM_CREATIVE_AUX_WAVE              = 406;
    MM_CREATIVE_AUX_MIDI              = 407;
    MM_CREATIVE_SBPRO_MIXER           = 408;
    MM_CREATIVE_SB16_MIXER            = 409;

//-----------------------------------------------------------------------------                                      
//  MM_MEDIAVISION product IDs

// Pro Audio Spectrum
    MM_MEDIAVISION_PROAUDIO           = $10;
    MM_PROAUD_MIDIOUT                 = (MM_MEDIAVISION_PROAUDIO+1);
    MM_PROAUD_MIDIIN                  = (MM_MEDIAVISION_PROAUDIO+2);
    MM_PROAUD_SYNTH                   = (MM_MEDIAVISION_PROAUDIO+3);
    MM_PROAUD_WAVEOUT                 = (MM_MEDIAVISION_PROAUDIO+4);
    MM_PROAUD_WAVEIN                  = (MM_MEDIAVISION_PROAUDIO+5);
    MM_PROAUD_MIXER                   = (MM_MEDIAVISION_PROAUDIO+6);
    MM_PROAUD_AUX                     = (MM_MEDIAVISION_PROAUDIO+7);

// Thunder Board
    MM_MEDIAVISION_THUNDER            = $20;
    MM_THUNDER_SYNTH                  = (MM_MEDIAVISION_THUNDER+3);
    MM_THUNDER_WAVEOUT                = (MM_MEDIAVISION_THUNDER+4);
    MM_THUNDER_WAVEIN                 = (MM_MEDIAVISION_THUNDER+5);
    MM_THUNDER_AUX                    = (MM_MEDIAVISION_THUNDER+7);

// Audio Port
    MM_MEDIAVISION_TPORT              = $40;
    MM_TPORT_WAVEOUT                  = (MM_MEDIAVISION_TPORT+1);
    MM_TPORT_WAVEIN                   = (MM_MEDIAVISION_TPORT+2);
    MM_TPORT_SYNTH                    = (MM_MEDIAVISION_TPORT+3);

// Pro Audio Spectrum Plus
    MM_MEDIAVISION_PROAUDIO_PLUS      = $50;
    MM_PROAUD_PLUS_MIDIOUT            = (MM_MEDIAVISION_PROAUDIO_PLUS+1);
    MM_PROAUD_PLUS_MIDIIN             = (MM_MEDIAVISION_PROAUDIO_PLUS+2);
    MM_PROAUD_PLUS_SYNTH              = (MM_MEDIAVISION_PROAUDIO_PLUS+3);
    MM_PROAUD_PLUS_WAVEOUT            = (MM_MEDIAVISION_PROAUDIO_PLUS+4);
    MM_PROAUD_PLUS_WAVEIN             = (MM_MEDIAVISION_PROAUDIO_PLUS+5);
    MM_PROAUD_PLUS_MIXER              = (MM_MEDIAVISION_PROAUDIO_PLUS+6);
    MM_PROAUD_PLUS_AUX                = (MM_MEDIAVISION_PROAUDIO_PLUS+7);

// Pro Audio Spectrum 16
    MM_MEDIAVISION_PROAUDIO_16        = $60;
    MM_PROAUD_16_MIDIOUT              = (MM_MEDIAVISION_PROAUDIO_16+1);
    MM_PROAUD_16_MIDIIN               = (MM_MEDIAVISION_PROAUDIO_16+2);
    MM_PROAUD_16_SYNTH                = (MM_MEDIAVISION_PROAUDIO_16+3);
    MM_PROAUD_16_WAVEOUT              = (MM_MEDIAVISION_PROAUDIO_16+4);
    MM_PROAUD_16_WAVEIN               = (MM_MEDIAVISION_PROAUDIO_16+5);
    MM_PROAUD_16_MIXER                = (MM_MEDIAVISION_PROAUDIO_16+6);
    MM_PROAUD_16_AUX                  = (MM_MEDIAVISION_PROAUDIO_16+7);

// Pro Audio Studio 16
    MM_MEDIAVISION_PROSTUDIO_16       = $60;
    MM_STUDIO_16_MIDIOUT              = (MM_MEDIAVISION_PROSTUDIO_16+1);
    MM_STUDIO_16_MIDIIN               = (MM_MEDIAVISION_PROSTUDIO_16+2);
    MM_STUDIO_16_SYNTH                = (MM_MEDIAVISION_PROSTUDIO_16+3);
    MM_STUDIO_16_WAVEOUT              = (MM_MEDIAVISION_PROSTUDIO_16+4);
    MM_STUDIO_16_WAVEIN               = (MM_MEDIAVISION_PROSTUDIO_16+5);
    MM_STUDIO_16_MIXER                = (MM_MEDIAVISION_PROSTUDIO_16+6);
    MM_STUDIO_16_AUX                  = (MM_MEDIAVISION_PROSTUDIO_16+7);

// CDPC
    MM_MEDIAVISION_CDPC               = $70;
    MM_CDPC_MIDIOUT                   = (MM_MEDIAVISION_CDPC+1);
    MM_CDPC_MIDIIN                    = (MM_MEDIAVISION_CDPC+2);
    MM_CDPC_SYNTH                     = (MM_MEDIAVISION_CDPC+3);
    MM_CDPC_WAVEOUT                   = (MM_MEDIAVISION_CDPC+4);
    MM_CDPC_WAVEIN                    = (MM_MEDIAVISION_CDPC+5);
    MM_CDPC_MIXER                     = (MM_MEDIAVISION_CDPC+6);
    MM_CDPC_AUX                       = (MM_MEDIAVISION_CDPC+7);

// Opus MV 1208 Chipsent
    MM_MEDIAVISION_OPUS1208           = $80;
    MM_OPUS401_MIDIOUT                = (MM_MEDIAVISION_OPUS1208+1);
    MM_OPUS401_MIDIIN                 = (MM_MEDIAVISION_OPUS1208+2);
    MM_OPUS1208_SYNTH                 = (MM_MEDIAVISION_OPUS1208+3);
    MM_OPUS1208_WAVEOUT               = (MM_MEDIAVISION_OPUS1208+4);
    MM_OPUS1208_WAVEIN                = (MM_MEDIAVISION_OPUS1208+5);
    MM_OPUS1208_MIXER                 = (MM_MEDIAVISION_OPUS1208+6);
    MM_OPUS1208_AUX                   = (MM_MEDIAVISION_OPUS1208+7);

// Opus MV 1216 chipset
    MM_MEDIAVISION_OPUS1216           = $90;
    MM_OPUS1216_MIDIOUT               = (MM_MEDIAVISION_OPUS1216+1);
    MM_OPUS1216_MIDIIN                = (MM_MEDIAVISION_OPUS1216+2);
    MM_OPUS1216_SYNTH                 = (MM_MEDIAVISION_OPUS1216+3);
    MM_OPUS1216_WAVEOUT               = (MM_MEDIAVISION_OPUS1216+4);
    MM_OPUS1216_WAVEIN                = (MM_MEDIAVISION_OPUS1216+5);
    MM_OPUS1216_MIXER                 = (MM_MEDIAVISION_OPUS1216+6);
    MM_OPUS1216_AUX                   = (MM_MEDIAVISION_OPUS1216+7);

//-----------------------------------------------------------------------------
//  MM_CYRIX product IDs
    MM_CYRIX_XASYNTH                  = 1;
    MM_CYRIX_XAMIDIIN                 = 2;
    MM_CYRIX_XAMIDIOUT                = 3;
    MM_CYRIX_XAWAVEIN                 = 4;
    MM_CYRIX_XAWAVEOUT                = 5;
    MM_CYRIX_XAAUX                    = 6;
    MM_CYRIX_XAMIXER                  = 7;

//-----------------------------------------------------------------------------
//  MM_PHILIPS_SPEECH_PROCESSING products IDs
    MM_PHILIPS_ACM_LPCBB              = 1;

//-----------------------------------------------------------------------------
//  MM_NETXL product IDs
    MM_NETXL_XLVIDEO                  = 1;

//-----------------------------------------------------------------------------
//  MM_ZYXEL product IDs
    MM_ZYXEL_ACM_ADPCM                = 1;

//-----------------------------------------------------------------------------
//  MM_AARDVARK product IDs
    MM_AARDVARK_STUDIO12_WAVEOUT      = 1;
    MM_AARDVARK_STUDIO12_WAVEIN       = 2;
    MM_AARDVARK_STUDIO88_WAVEOUT      = 3;
    MM_AARDVARK_STUDIO88_WAVEIN       = 4;

//-----------------------------------------------------------------------------
//  MM_BINTEC product IDs
    MM_BINTEC_TAPI_WAVE               = 1;

//-----------------------------------------------------------------------------
//  MM_HEWLETT_PACKARD product IDs
    MM_HEWLETT_PACKARD_CU_CODEC       = 1;

//-----------------------------------------------------------------------------
//  MM_MITEL product IDs
    MM_MITEL_TALKTO_LINE_WAVEOUT      = 100;
    MM_MITEL_TALKTO_LINE_WAVEIN       = 101;
    MM_MITEL_TALKTO_HANDSET_WAVEOUT   = 102;
    MM_MITEL_TALKTO_HANDSET_WAVEIN    = 103;
    MM_MITEL_TALKTO_BRIDGED_WAVEOUT   = 104;
    MM_MITEL_TALKTO_BRIDGED_WAVEIN    = 105;
    MM_MITEL_MPA_HANDSET_WAVEOUT      = 200;
    MM_MITEL_MPA_HANDSET_WAVEIN       = 201;
    MM_MITEL_MPA_HANDSFREE_WAVEOUT    = 202;
    MM_MITEL_MPA_HANDSFREE_WAVEIN     = 203;
    MM_MITEL_MPA_LINE1_WAVEOUT        = 204;
    MM_MITEL_MPA_LINE1_WAVEIN         = 205;
    MM_MITEL_MPA_LINE2_WAVEOUT        = 206;
    MM_MITEL_MPA_LINE2_WAVEIN         = 207;
    MM_MITEL_MEDIAPATH_WAVEOUT        = 300;
    MM_MITEL_MEDIAPATH_WAVEIN         = 301;

//-----------------------------------------------------------------------------
//  MM_SNI product IDs
    MM_SNI_ACM_G721                   = 1;

//-----------------------------------------------------------------------------
//  MM_EMU product IDs
    MM_EMU_APSSYNTH                   = 1;
    MM_EMU_APSMIDIIN                  = 2;
    MM_EMU_APSMIDIOUT                 = 3;
    MM_EMU_APSWAVEIN                  = 4;
    MM_EMU_APSWAVEOUT                 = 5;

//-----------------------------------------------------------------------------
//  MM_ARTISOFT product IDs
    MM_ARTISOFT_SBWAVEIN              = 1;      //'Artisoft sounding Board waveform input'
    MM_ARTISOFT_SBWAVEOUT             = 2;      //'Artisoft sounding Board waveform output'

//-----------------------------------------------------------------------------
//  MM_TURTLE_BEACH product IDs
    MM_TBS_TROPEZ_WAVEIN              = 37;
    MM_TBS_TROPEZ_WAVEOUT             = 38;
    MM_TBS_TROPEZ_AUX1                = 39;
    MM_TBS_TROPEZ_AUX2                = 40;
    MM_TBS_TROPEZ_LINE                = 41;

//-----------------------------------------------------------------------------
//  MM_IBM product IDs
    MM_MMOTION_WAVEAUX                = 1 ;     //'IBM M-Motion Auxiliary Device'
    MM_MMOTION_WAVEOUT                = 2 ;     //'IBM M-Motion Waveform output'
    MM_MMOTION_WAVEIN                 = 3 ;     //'IBM M-Motion  Waveform Input'
    MM_IBM_PCMCIA_WAVEIN              = 11;     //'IBM waveform input'
    MM_IBM_PCMCIA_WAVEOUT             = 12;     //'IBM Waveform output'
    MM_IBM_PCMCIA_SYNTH               = 13;     //'IBM Midi Synthesis'
    MM_IBM_PCMCIA_MIDIIN              = 14;     //'IBM external MIDI in'
    MM_IBM_PCMCIA_MIDIOUT             = 15;     //'IBM external MIDI out'
    MM_IBM_PCMCIA_AUX                 = 16;     //'IBM auxiliary control'
    MM_IBM_THINKPAD200                = 17;
    MM_IBM_MWAVE_WAVEIN               = 18;
    MM_IBM_MWAVE_WAVEOUT              = 19;
    MM_IBM_MWAVE_MIXER                = 20;
    MM_IBM_MWAVE_MIDIIN               = 21;
    MM_IBM_MWAVE_MIDIOUT              = 22;
    MM_IBM_MWAVE_AUX                  = 23;
    MM_IBM_WC_MIDIOUT                 = 30;
    MM_IBM_WC_WAVEOUT                 = 31;
    MM_IBM_WC_MIXEROUT                = 33;

//-----------------------------------------------------------------------------
//  MM_VOCALTEC product IDs
    MM_VOCALTEC_WAVEOUT               = 1 ;
    MM_VOCALTEC_WAVEIN                = 2 ;

//-----------------------------------------------------------------------------
//  MM_ROLAND product IDs
    MM_ROLAND_RAP10_MIDIOUT           = 10;     //'MM_ROLAND_RAP10'
    MM_ROLAND_RAP10_MIDIIN            = 11;     //'MM_ROLAND_RAP10'
    MM_ROLAND_RAP10_SYNTH             = 12;     //'MM_ROLAND_RAP10'
    MM_ROLAND_RAP10_WAVEOUT           = 13;     //'MM_ROLAND_RAP10'
    MM_ROLAND_RAP10_WAVEIN            = 14;     //'MM_ROLAND_RAP10'
    MM_ROLAND_MPU401_MIDIOUT          = 15;
    MM_ROLAND_MPU401_MIDIIN           = 16;
    MM_ROLAND_SMPU_MIDIOUTA           = 17;
    MM_ROLAND_SMPU_MIDIOUTB           = 18;
    MM_ROLAND_SMPU_MIDIINA            = 19;
    MM_ROLAND_SMPU_MIDIINB            = 20;
    MM_ROLAND_SC7_MIDIOUT             = 21;
    MM_ROLAND_SC7_MIDIIN              = 22;
    MM_ROLAND_SERIAL_MIDIOUT          = 23;
    MM_ROLAND_SERIAL_MIDIIN           = 24;
    MM_ROLAND_SCP_MIDIOUT             = 38;
    MM_ROLAND_SCP_MIDIIN              = 39;
    MM_ROLAND_SCP_WAVEOUT             = 40;
    MM_ROLAND_SCP_WAVEIN              = 41;
    MM_ROLAND_SCP_MIXER               = 42;
    MM_ROLAND_SCP_AUX                 = 48;

//-----------------------------------------------------------------------------
//  MM_DSP_SOLUTIONS product IDs
    MM_DSP_SOLUTIONS_WAVEOUT          = 1;
    MM_DSP_SOLUTIONS_WAVEIN           = 2;
    MM_DSP_SOLUTIONS_SYNTH            = 3;
    MM_DSP_SOLUTIONS_AUX              = 4;

//-----------------------------------------------------------------------------
//  MM_NEC product IDs
    MM_NEC_73_86_SYNTH                = 5 ;
    MM_NEC_73_86_WAVEOUT              = 6 ;
    MM_NEC_73_86_WAVEIN               = 7 ;
    MM_NEC_26_SYNTH                   = 9 ;
    MM_NEC_MPU401_MIDIOUT             = 10;
    MM_NEC_MPU401_MIDIIN              = 11;
    MM_NEC_JOYSTICK                   = 12;

//-----------------------------------------------------------------------------
//  MM_WANGLABS product IDs
    MM_WANGLABS_WAVEIN1               = 1;      //'Input audio wave on CPU board models: Exec 4010, 4030, 3450; PC 251/25c, pc 461/25s , pc 461/33c'
    MM_WANGLABS_WAVEOUT1              = 2;

//-----------------------------------------------------------------------------
//  MM_TANDY product IDs
    MM_TANDY_VISWAVEIN                = 1 ;
    MM_TANDY_VISWAVEOUT               = 2 ;
    MM_TANDY_VISBIOSSYNTH             = 3 ;
    MM_TANDY_SENS_MMAWAVEIN           = 4 ;
    MM_TANDY_SENS_MMAWAVEOUT          = 5 ;
    MM_TANDY_SENS_MMAMIDIIN           = 6 ;
    MM_TANDY_SENS_MMAMIDIOUT          = 7 ;
    MM_TANDY_SENS_VISWAVEOUT          = 8 ;
    MM_TANDY_PSSJWAVEIN               = 9 ;
    MM_TANDY_PSSJWAVEOUT              = 10;

//-----------------------------------------------------------------------------
//  MM_ANTEX product IDs
    MM_ANTEX_SX12_WAVEIN              = 1 ;
    MM_ANTEX_SX12_WAVEOUT             = 2 ;
    MM_ANTEX_SX15_WAVEIN              = 3 ;
    MM_ANTEX_SX15_WAVEOUT             = 4 ;
    MM_ANTEX_VP625_WAVEIN             = 5 ;
    MM_ANTEX_VP625_WAVEOUT            = 6 ;
    MM_ANTEX_AUDIOPORT22_WAVEIN       = 7 ;
    MM_ANTEX_AUDIOPORT22_WAVEOUT      = 8 ;
    MM_ANTEX_AUDIOPORT22_FEEDTHRU     = 9 ;

//-----------------------------------------------------------------------------
//  MM_INTEL product IDs
    MM_INTELOPD_WAVEIN                = 1  ;    //'HID2 WaveAudio Driver'
    MM_INTELOPD_WAVEOUT               = 101;    //'HID2'
    MM_INTELOPD_AUX                   = 401;    //'HID2 for mixing'
    MM_INTEL_NSPMODEMLINEIN           = 501;
    MM_INTEL_NSPMODEMLINEOUT          = 502;

//-----------------------------------------------------------------------------
//  MM_VAL product IDs
    MM_VAL_MICROKEY_AP_WAVEIN         = 1;
    MM_VAL_MICROKEY_AP_WAVEOUT        = 2;

//-----------------------------------------------------------------------------
//  MM_INTERACTIVE product IDs
    MM_INTERACTIVE_WAVEIN             = $45;
    MM_INTERACTIVE_WAVEOUT            = $45;

//-----------------------------------------------------------------------------
//  MM_YAMAHA product IDs
    MM_YAMAHA_GSS_SYNTH               = $01;
    MM_YAMAHA_GSS_WAVEOUT             = $02;
    MM_YAMAHA_GSS_WAVEIN              = $03;
    MM_YAMAHA_GSS_MIDIOUT             = $04;
    MM_YAMAHA_GSS_MIDIIN              = $05;
    MM_YAMAHA_GSS_AUX                 = $06;
    MM_YAMAHA_SERIAL_MIDIOUT          = $07;
    MM_YAMAHA_SERIAL_MIDIIN           = $08;
    MM_YAMAHA_OPL3SA_WAVEOUT          = $10;
    MM_YAMAHA_OPL3SA_WAVEIN           = $11;
    MM_YAMAHA_OPL3SA_FMSYNTH          = $12;
    MM_YAMAHA_OPL3SA_YSYNTH           = $13;
    MM_YAMAHA_OPL3SA_MIDIOUT          = $14;
    MM_YAMAHA_OPL3SA_MIDIIN           = $15;
    MM_YAMAHA_OPL3SA_MIXER            = $17;
    MM_YAMAHA_OPL3SA_JOYSTICK         = $18;
    MM_YAMAHA_YMF724LEG_MIDIOUT       = $19;
    MM_YAMAHA_YMF724LEG_MIDIIN        = $1a;
    MM_YAMAHA_YMF724_WAVEOUT          = $1b;
    MM_YAMAHA_YMF724_WAVEIN           = $1c;
    MM_YAMAHA_YMF724_MIDIOUT          = $1d;
    MM_YAMAHA_YMF724_AUX              = $1e;
    MM_YAMAHA_YMF724_MIXER            = $1f;
    MM_YAMAHA_YMF724LEG_FMSYNTH       = $20;
    MM_YAMAHA_YMF724LEG_MIXER         = $21;
    MM_YAMAHA_SXG_MIDIOUT             = $22;
    MM_YAMAHA_SXG_WAVEOUT             = $23;
    MM_YAMAHA_SXG_MIXER               = $24;
    MM_YAMAHA_ACXG_WAVEIN             = $25;
    MM_YAMAHA_ACXG_WAVEOUT            = $26;
    MM_YAMAHA_ACXG_MIDIOUT            = $27;
    MM_YAMAHA_ACXG_MIXER              = $28;
    MM_YAMAHA_ACXG_AUX                = $29;

//-----------------------------------------------------------------------------
//  MM_EVEREX product IDs
    MM_EVEREX_CARRIER                 = 1;

//-----------------------------------------------------------------------------
//  MM_ECHO product IDs
    MM_ECHO_SYNTH                     = 1;
    MM_ECHO_WAVEOUT                   = 2;
    MM_ECHO_WAVEIN                    = 3;
    MM_ECHO_MIDIOUT                   = 4;
    MM_ECHO_MIDIIN                    = 5;
    MM_ECHO_AUX                       = 6;

//-----------------------------------------------------------------------------
//  MM_SIERRA product IDs
    MM_SIERRA_ARIA_MIDIOUT            = $14;
    MM_SIERRA_ARIA_MIDIIN             = $15;
    MM_SIERRA_ARIA_SYNTH              = $16;
    MM_SIERRA_ARIA_WAVEOUT            = $17;
    MM_SIERRA_ARIA_WAVEIN             = $18;
    MM_SIERRA_ARIA_AUX                = $19;
    MM_SIERRA_ARIA_AUX2               = $20;
    MM_SIERRA_QUARTET_WAVEIN          = $50;
    MM_SIERRA_QUARTET_WAVEOUT         = $51;
    MM_SIERRA_QUARTET_MIDIIN          = $52;
    MM_SIERRA_QUARTET_MIDIOUT         = $53;
    MM_SIERRA_QUARTET_SYNTH           = $54;
    MM_SIERRA_QUARTET_AUX_CD          = $55;
    MM_SIERRA_QUARTET_AUX_LINE        = $56;
    MM_SIERRA_QUARTET_AUX_MODEM       = $57;
    MM_SIERRA_QUARTET_MIXER           = $58;

//-----------------------------------------------------------------------------
//  MM_CAT product IDs
    MM_CAT_WAVEOUT                    = 1;

//-----------------------------------------------------------------------------
//  MM_DSP_GROUP product IDs
    MM_DSP_GROUP_TRUESPEECH           = 1;

//-----------------------------------------------------------------------------
//  MM_MELABS product IDs
    MM_MELABS_MIDI2GO                 = 1;

//-----------------------------------------------------------------------------
//  MM_ESS product IDs
    MM_ESS_AMWAVEOUT                  = $01;
    MM_ESS_AMWAVEIN                   = $02;
    MM_ESS_AMAUX                      = $03;
    MM_ESS_AMSYNTH                    = $04;
    MM_ESS_AMMIDIOUT                  = $05;
    MM_ESS_AMMIDIIN                   = $06;
    MM_ESS_MIXER                      = $07;
    MM_ESS_AUX_CD                     = $08;
    MM_ESS_MPU401_MIDIOUT             = $09;
    MM_ESS_MPU401_MIDIIN              = $0A;
    MM_ESS_ES488_WAVEOUT              = $10;
    MM_ESS_ES488_WAVEIN               = $11;
    MM_ESS_ES488_MIXER                = $12;
    MM_ESS_ES688_WAVEOUT              = $13;
    MM_ESS_ES688_WAVEIN               = $14;
    MM_ESS_ES688_MIXER                = $15;
    MM_ESS_ES1488_WAVEOUT             = $16;
    MM_ESS_ES1488_WAVEIN              = $17;
    MM_ESS_ES1488_MIXER               = $18;
    MM_ESS_ES1688_WAVEOUT             = $19;
    MM_ESS_ES1688_WAVEIN              = $1A;
    MM_ESS_ES1688_MIXER               = $1B;
    MM_ESS_ES1788_WAVEOUT             = $1C;
    MM_ESS_ES1788_WAVEIN              = $1D;
    MM_ESS_ES1788_MIXER               = $1E;
    MM_ESS_ES1888_WAVEOUT             = $1F;
    MM_ESS_ES1888_WAVEIN              = $20;
    MM_ESS_ES1888_MIXER               = $21;
    MM_ESS_ES1868_WAVEOUT             = $22;
    MM_ESS_ES1868_WAVEIN              = $23;
    MM_ESS_ES1868_MIXER               = $24;
    MM_ESS_ES1878_WAVEOUT             = $25;
    MM_ESS_ES1878_WAVEIN              = $26;
    MM_ESS_ES1878_MIXER               = $27;

//-----------------------------------------------------------------------------
//  MM_CANOPUS product IDs
    MM_CANOPUS_ACM_DVREX              = 1;

//-----------------------------------------------------------------------------
//  MM_EPSON product IDs
    MM_EPS_FMSND                      = 1;

//-----------------------------------------------------------------------------
//  MM_TRUEVISION product IDs
    MM_TRUEVISION_WAVEIN1             = 1;
    MM_TRUEVISION_WAVEOUT1            = 2;

//-----------------------------------------------------------------------------
//  MM_AZTECH product IDs
    MM_AZTECH_MIDIOUT                 = 3  ;
    MM_AZTECH_MIDIIN                  = 4  ;
    MM_AZTECH_WAVEIN                  = 17 ;
    MM_AZTECH_WAVEOUT                 = 18 ;
    MM_AZTECH_FMSYNTH                 = 20 ;
    MM_AZTECH_MIXER                   = 21 ;
    MM_AZTECH_PRO16_WAVEIN            = 33 ;
    MM_AZTECH_PRO16_WAVEOUT           = 34 ;
    MM_AZTECH_PRO16_FMSYNTH           = 38 ;
    MM_AZTECH_DSP16_WAVEIN            = 65 ;
    MM_AZTECH_DSP16_WAVEOUT           = 66 ;
    MM_AZTECH_DSP16_FMSYNTH           = 68 ;
    MM_AZTECH_DSP16_WAVESYNTH         = 70 ;
    MM_AZTECH_NOVA16_WAVEIN           = 71 ;
    MM_AZTECH_NOVA16_WAVEOUT          = 72 ;
    MM_AZTECH_NOVA16_MIXER            = 73 ;
    MM_AZTECH_WASH16_WAVEIN           = 74 ;
    MM_AZTECH_WASH16_WAVEOUT          = 75 ;
    MM_AZTECH_WASH16_MIXER            = 76 ;
    MM_AZTECH_AUX_CD                  = 401;
    MM_AZTECH_AUX_LINE                = 402;
    MM_AZTECH_AUX_MIC                 = 403;
    MM_AZTECH_AUX                     = 404;

//-----------------------------------------------------------------------------
//  MM_VIDEOLOGIC product IDs
    MM_VIDEOLOGIC_MSWAVEIN            = 1;
    MM_VIDEOLOGIC_MSWAVEOUT           = 2;

//-----------------------------------------------------------------------------
//  MM_KORG product IDs
    MM_KORG_PCIF_MIDIOUT              = 1;
    MM_KORG_PCIF_MIDIIN               = 2;
    MM_KORG_1212IO_MSWAVEIN           = 3;
    MM_KORG_1212IO_MSWAVEOUT          = 4;

//-----------------------------------------------------------------------------
//  MM_APT product IDs
    MM_APT_ACE100CD                   = 1;

//-----------------------------------------------------------------------------
//  MM_ICS product IDs
    MM_ICS_WAVEDECK_WAVEOUT           = 1 ;     //'MS WSS compatible card and driver'
    MM_ICS_WAVEDECK_WAVEIN            = 2 ;
    MM_ICS_WAVEDECK_MIXER             = 3 ;
    MM_ICS_WAVEDECK_AUX               = 4 ;
    MM_ICS_WAVEDECK_SYNTH             = 5 ;
    MM_ICS_WAVEDEC_SB_WAVEOUT         = 6 ;
    MM_ICS_WAVEDEC_SB_WAVEIN          = 7 ;
    MM_ICS_WAVEDEC_SB_FM_MIDIOUT      = 8 ;
    MM_ICS_WAVEDEC_SB_MPU401_MIDIOUT  = 9 ;
    MM_ICS_WAVEDEC_SB_MPU401_MIDIIN   = 10;
    MM_ICS_WAVEDEC_SB_MIXER           = 11;
    MM_ICS_WAVEDEC_SB_AUX             = 12;
    MM_ICS_2115_LITE_MIDIOUT          = 13;
    MM_ICS_2120_LITE_MIDIOUT          = 14;

//-----------------------------------------------------------------------------
//  MM_ITERATEDSYS product IDs
    MM_ITERATEDSYS_FUFCODEC           = 1;

//-----------------------------------------------------------------------------
//  MM_METHEUS product IDs
    MM_METHEUS_ZIPPER                 = 1;

//-----------------------------------------------------------------------------
//  MM_WINNOV product IDs
    MM_WINNOV_CAVIAR_WAVEIN           = 1;
    MM_WINNOV_CAVIAR_WAVEOUT          = 2;
    MM_WINNOV_CAVIAR_VIDC             = 3;
    MM_WINNOV_CAVIAR_CHAMPAGNE        = 4;      //'Fourcc is CHAM'
    MM_WINNOV_CAVIAR_YUV8             = 5;      //'Fourcc is YUV8'

//-----------------------------------------------------------------------------
//  MM_NCR product IDs'
    MM_NCR_BA_WAVEIN                  = 1;
    MM_NCR_BA_WAVEOUT                 = 2;
    MM_NCR_BA_SYNTH                   = 3;
    MM_NCR_BA_AUX                     = 4;
    MM_NCR_BA_MIXER                   = 5;

//-----------------------------------------------------------------------------
//  MM_AST product IDs
    MM_AST_MODEMWAVE_WAVEIN           = 13;
    MM_AST_MODEMWAVE_WAVEOUT          = 14;

//-----------------------------------------------------------------------------
//  MM_WILLOWPOND product IDs
    MM_WILLOWPOND_FMSYNTH_STEREO      = 20 ;
    MM_WILLOWPOND_MPU401              = 21 ;
    MM_WILLOWPOND_SNDPORT_WAVEIN      = 100;
    MM_WILLOWPOND_SNDPORT_WAVEOUT     = 101;
    MM_WILLOWPOND_SNDPORT_MIXER       = 102;
    MM_WILLOWPOND_SNDPORT_AUX         = 103;
    MM_WILLOWPOND_PH_WAVEIN           = 104;
    MM_WILLOWPOND_PH_WAVEOUT          = 105;
    MM_WILLOWPOND_PH_MIXER            = 106;
    MM_WILLOWPOND_PH_AUX              = 107;
    MM_WILLOPOND_SNDCOMM_WAVEIN       = 108;
    MM_WILLOWPOND_SNDCOMM_WAVEOUT     = 109;
    MM_WILLOWPOND_SNDCOMM_MIXER       = 110;
    MM_WILLOWPOND_SNDCOMM_AUX         = 111;
    MM_WILLOWPOND_GENERIC_WAVEIN      = 112;
    MM_WILLOWPOND_GENERIC_WAVEOUT     = 113;
    MM_WILLOWPOND_GENERIC_MIXER       = 114;
    MM_WILLOWPOND_GENERIC_AUX         = 115;

//-----------------------------------------------------------------------------
//  MM_VITEC product IDs
    MM_VITEC_VMAKER                   = 1;
    MM_VITEC_VMPRO                    = 2;

//-----------------------------------------------------------------------------
//  MM_MOSCOM product IDs
    MM_MOSCOM_VPC2400_IN              = 1;      //'Four Port Voice Processing / Voice Recognition Board'
    MM_MOSCOM_VPC2400_OUT             = 2;      //'VPC2400'

//-----------------------------------------------------------------------------
//  MM_SILICONSOFT product IDs
    MM_SILICONSOFT_SC1_WAVEIN         = 1;      //'Waveform in , high sample rate'
    MM_SILICONSOFT_SC1_WAVEOUT        = 2;      //'Waveform out , high sample rate'
    MM_SILICONSOFT_SC2_WAVEIN         = 3;      //'Waveform in 2 channels, high sample rate'
    MM_SILICONSOFT_SC2_WAVEOUT        = 4;      //'Waveform out 2 channels, high sample rate'
    MM_SILICONSOFT_SOUNDJR2_WAVEOUT   = 5;      //'Waveform out, self powered, efficient'
    MM_SILICONSOFT_SOUNDJR2PR_WAVEIN  = 6;      //'Waveform in, self powered, efficient'
    MM_SILICONSOFT_SOUNDJR2PR_WAVEOUT = 7;      //'Waveform out 2 channels, self powered, efficient'
    MM_SILICONSOFT_SOUNDJR3_WAVEOUT   = 8;      //'Waveform in 2 channels, self powered, efficient'

//-----------------------------------------------------------------------------
//  MM_TERRATEC product IDs
    MM_TTEWS_WAVEIN                   = 1 ;
    MM_TTEWS_WAVEOUT                  = 2 ;
    MM_TTEWS_MIDIIN                   = 3 ;
    MM_TTEWS_MIDIOUT                  = 4 ;
    MM_TTEWS_MIDISYNTH                = 5 ;
    MM_TTEWS_MIDIMONITOR              = 6 ;
    MM_TTEWS_VMIDIIN                  = 7 ;
    MM_TTEWS_VMIDIOUT                 = 8 ;
    MM_TTEWS_AUX                      = 9 ;
    MM_TTEWS_MIXER                    = 10;

//-----------------------------------------------------------------------------
//  MM_MEDIASONIC product IDs
    MM_MEDIASONIC_ACM_G723            = 1;
    MM_MEDIASONIC_ICOM                = 2;
    MM_ICOM_WAVEIN                    = 3;
    MM_ICOM_WAVEOUT                   = 4;
    MM_ICOM_MIXER                     = 5;
    MM_ICOM_AUX                       = 6;
    MM_ICOM_LINE                      = 7;

//-----------------------------------------------------------------------------
//  MM_SANYO product IDs
    MM_SANYO_ACM_LD_ADPCM             = 1;

//-----------------------------------------------------------------------------
//  MM_AHEAD product IDs
    MM_AHEAD_MULTISOUND               = 1;
    MM_AHEAD_SOUNDBLASTER             = 2;
    MM_AHEAD_PROAUDIO                 = 3;
    MM_AHEAD_GENERIC                  = 4;

//-----------------------------------------------------------------------------
//  MM_OLIVETTI product IDs
    MM_OLIVETTI_WAVEIN                = 1 ;
    MM_OLIVETTI_WAVEOUT               = 2 ;
    MM_OLIVETTI_MIXER                 = 3 ;
    MM_OLIVETTI_AUX                   = 4 ;
    MM_OLIVETTI_MIDIIN                = 5 ;
    MM_OLIVETTI_MIDIOUT               = 6 ;
    MM_OLIVETTI_SYNTH                 = 7 ;
    MM_OLIVETTI_JOYSTICK              = 8 ;
    MM_OLIVETTI_ACM_GSM               = 9 ;
    MM_OLIVETTI_ACM_ADPCM             = 10;
    MM_OLIVETTI_ACM_CELP              = 11;
    MM_OLIVETTI_ACM_SBC               = 12;
    MM_OLIVETTI_ACM_OPR               = 13;

//-----------------------------------------------------------------------------
//  MM_IOMAGIC product IDs
    MM_IOMAGIC_TEMPO_WAVEOUT          = 1;
    MM_IOMAGIC_TEMPO_WAVEIN           = 2;
    MM_IOMAGIC_TEMPO_SYNTH            = 3;
    MM_IOMAGIC_TEMPO_MIDIOUT          = 4;
    MM_IOMAGIC_TEMPO_MXDOUT           = 5;
    MM_IOMAGIC_TEMPO_AUXOUT           = 6;

//-----------------------------------------------------------------------------
//  MM_MATSUSHITA product IDs
    MM_MATSUSHITA_WAVEIN              = 1;
    MM_MATSUSHITA_WAVEOUT             = 2;
    MM_MATSUSHITA_FMSYNTH_STEREO      = 3;
    MM_MATSUSHITA_MIXER               = 4;
    MM_MATSUSHITA_AUX                 = 5;

//-----------------------------------------------------------------------------
//  MM_NEWMEDIA product IDs
    MM_NEWMEDIA_WAVJAMMER             = 1;      //'WSS Compatible sound card.'

//-----------------------------------------------------------------------------
//  MM_LYRRUS product IDs
    MM_LYRRUS_BRIDGE_GUITAR           = 1;

//-----------------------------------------------------------------------------
//  MM_OPTI product IDs
    MM_OPTI_M16_FMSYNTH_STEREO        = $0001;
    MM_OPTI_M16_MIDIIN                = $0002;
    MM_OPTI_M16_MIDIOUT               = $0003;
    MM_OPTI_M16_WAVEIN                = $0004;
    MM_OPTI_M16_WAVEOUT               = $0005;
    MM_OPTI_M16_MIXER                 = $0006;
    MM_OPTI_M16_AUX                   = $0007;
    MM_OPTI_P16_FMSYNTH_STEREO        = $0010;
    MM_OPTI_P16_MIDIIN                = $0011;
    MM_OPTI_P16_MIDIOUT               = $0012;
    MM_OPTI_P16_WAVEIN                = $0013;
    MM_OPTI_P16_WAVEOUT               = $0014;
    MM_OPTI_P16_MIXER                 = $0015;
    MM_OPTI_P16_AUX                   = $0016;
    MM_OPTI_M32_WAVEIN                = $0020;
    MM_OPTI_M32_WAVEOUT               = $0021;
    MM_OPTI_M32_MIDIIN                = $0022;
    MM_OPTI_M32_MIDIOUT               = $0023;
    MM_OPTI_M32_SYNTH_STEREO          = $0024;
    MM_OPTI_M32_MIXER                 = $0025;
    MM_OPTI_M32_AUX                   = $0026;

//-----------------------------------------------------------------------------
//  MM_COMPAQ product IDs
    MM_COMPAQ_BB_WAVEIN               = 1;
    MM_COMPAQ_BB_WAVEOUT              = 2;
    MM_COMPAQ_BB_WAVEAUX              = 3;

//-----------------------------------------------------------------------------
//  MM_MPTUS product IDs
    MM_MPTUS_SPWAVEOUT                = 1;      //'Sound Pallette'

//-----------------------------------------------------------------------------
//  MM_LERNOUT_AND_HAUSPIE product IDs
    MM_LERNOUT_ANDHAUSPIE_LHCODECACM  = 1;

//-----------------------------------------------------------------------------
//  MM_DIGITAL product IDs
    MM_DIGITAL_AV320_WAVEIN           = 1;      //'Digital Audio Video Compression Board'
    MM_DIGITAL_AV320_WAVEOUT          = 2;      //'Digital Audio Video Compression Board'
    MM_DIGITAL_ACM_G723               = 3;
    MM_DIGITAL_ICM_H263               = 4;
    MM_DIGITAL_ICM_H261               = 5;

//-----------------------------------------------------------------------------
//  MM_MOTU product IDs
    MM_MOTU_MTP_MIDIOUT_ALL           = 100 ;
    MM_MOTU_MTP_MIDIIN_1              = 101 ;
    MM_MOTU_MTP_MIDIOUT_1             = 101 ;
    MM_MOTU_MTP_MIDIIN_2              = 102 ;
    MM_MOTU_MTP_MIDIOUT_2             = 102 ;
    MM_MOTU_MTP_MIDIIN_3              = 103 ;
    MM_MOTU_MTP_MIDIOUT_3             = 103 ;
    MM_MOTU_MTP_MIDIIN_4              = 104 ;
    MM_MOTU_MTP_MIDIOUT_4             = 104 ;
    MM_MOTU_MTP_MIDIIN_5              = 105 ;
    MM_MOTU_MTP_MIDIOUT_5             = 105 ;
    MM_MOTU_MTP_MIDIIN_6              = 106 ;
    MM_MOTU_MTP_MIDIOUT_6             = 106 ;
    MM_MOTU_MTP_MIDIIN_7              = 107 ;
    MM_MOTU_MTP_MIDIOUT_7             = 107 ;
    MM_MOTU_MTP_MIDIIN_8              = 108 ;
    MM_MOTU_MTP_MIDIOUT_8             = 108 ;

    MM_MOTU_MTPII_MIDIOUT_ALL         = 200 ;
    MM_MOTU_MTPII_MIDIIN_SYNC         = 200 ;
    MM_MOTU_MTPII_MIDIIN_1            = 201 ;
    MM_MOTU_MTPII_MIDIOUT_1           = 201 ;
    MM_MOTU_MTPII_MIDIIN_2            = 202 ;
    MM_MOTU_MTPII_MIDIOUT_2           = 202 ;
    MM_MOTU_MTPII_MIDIIN_3            = 203 ;
    MM_MOTU_MTPII_MIDIOUT_3           = 203 ;
    MM_MOTU_MTPII_MIDIIN_4            = 204 ;
    MM_MOTU_MTPII_MIDIOUT_4           = 204 ;
    MM_MOTU_MTPII_MIDIIN_5            = 205 ;
    MM_MOTU_MTPII_MIDIOUT_5           = 205 ;
    MM_MOTU_MTPII_MIDIIN_6            = 206 ;
    MM_MOTU_MTPII_MIDIOUT_6           = 206 ;
    MM_MOTU_MTPII_MIDIIN_7            = 207 ;
    MM_MOTU_MTPII_MIDIOUT_7           = 207 ;
    MM_MOTU_MTPII_MIDIIN_8            = 208 ;
    MM_MOTU_MTPII_MIDIOUT_8           = 208 ;
    MM_MOTU_MTPII_NET_MIDIIN_1        = 209 ;
    MM_MOTU_MTPII_NET_MIDIOUT_1       = 209 ;
    MM_MOTU_MTPII_NET_MIDIIN_2        = 210 ;
    MM_MOTU_MTPII_NET_MIDIOUT_2       = 210 ;
    MM_MOTU_MTPII_NET_MIDIIN_3        = 211 ;
    MM_MOTU_MTPII_NET_MIDIOUT_3       = 211 ;
    MM_MOTU_MTPII_NET_MIDIIN_4        = 212 ;
    MM_MOTU_MTPII_NET_MIDIOUT_4       = 212 ;
    MM_MOTU_MTPII_NET_MIDIIN_5        = 213 ;
    MM_MOTU_MTPII_NET_MIDIOUT_5       = 213 ;
    MM_MOTU_MTPII_NET_MIDIIN_6        = 214 ;
    MM_MOTU_MTPII_NET_MIDIOUT_6       = 214 ;
    MM_MOTU_MTPII_NET_MIDIIN_7        = 215 ;
    MM_MOTU_MTPII_NET_MIDIOUT_7       = 215 ;
    MM_MOTU_MTPII_NET_MIDIIN_8        = 216 ;
    MM_MOTU_MTPII_NET_MIDIOUT_8       = 216 ;

    MM_MOTU_MXP_MIDIIN_MIDIOUT_ALL    = 300 ;
    MM_MOTU_MXP_MIDIIN_SYNC           = 300 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_1       = 301 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_1      = 301 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_2       = 302 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_2      = 302 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_3       = 303 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_3      = 303 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_4       = 304 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_4      = 304 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_5       = 305 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_5      = 305 ;
    MM_MOTU_MXP_MIDIIN_MIDIIN_6       = 306 ;
    MM_MOTU_MXP_MIDIIN_MIDIOUT_6      = 306 ;

    MM_MOTU_MXPMPU_MIDIOUT_ALL        = 400 ;
    MM_MOTU_MXPMPU_MIDIIN_SYNC        = 400 ;
    MM_MOTU_MXPMPU_MIDIIN_1           = 401 ;
    MM_MOTU_MXPMPU_MIDIOUT_1          = 401 ;
    MM_MOTU_MXPMPU_MIDIIN_2           = 402 ;
    MM_MOTU_MXPMPU_MIDIOUT_2          = 402 ;
    MM_MOTU_MXPMPU_MIDIIN_3           = 403 ;
    MM_MOTU_MXPMPU_MIDIOUT_3          = 403 ;
    MM_MOTU_MXPMPU_MIDIIN_4           = 404 ;
    MM_MOTU_MXPMPU_MIDIOUT_4          = 404 ;
    MM_MOTU_MXPMPU_MIDIIN_5           = 405 ;
    MM_MOTU_MXPMPU_MIDIOUT_5          = 405 ;
    MM_MOTU_MXPMPU_MIDIIN_6           = 406 ;
    MM_MOTU_MXPMPU_MIDIOUT_6          = 406 ;

    MM_MOTU_MXN_MIDIOUT_ALL           = 500 ;
    MM_MOTU_MXN_MIDIIN_SYNC           = 500 ;
    MM_MOTU_MXN_MIDIIN_1              = 501 ;
    MM_MOTU_MXN_MIDIOUT_1             = 501 ;
    MM_MOTU_MXN_MIDIIN_2              = 502 ;
    MM_MOTU_MXN_MIDIOUT_2             = 502 ;
    MM_MOTU_MXN_MIDIIN_3              = 503 ;
    MM_MOTU_MXN_MIDIOUT_3             = 503 ;
    MM_MOTU_MXN_MIDIIN_4              = 504 ;
    MM_MOTU_MXN_MIDIOUT_4             = 504 ;

    MM_MOTU_FLYER_MIDI_IN_SYNC        = 600 ;
    MM_MOTU_FLYER_MIDI_IN_A           = 601 ;
    MM_MOTU_FLYER_MIDI_OUT_A          = 601 ;
    MM_MOTU_FLYER_MIDI_IN_B           = 602 ;
    MM_MOTU_FLYER_MIDI_OUT_B          = 602 ;

    MM_MOTU_PKX_MIDI_IN_SYNC          = 700 ;
    MM_MOTU_PKX_MIDI_IN_A             = 701 ;
    MM_MOTU_PKX_MIDI_OUT_A            = 701 ;
    MM_MOTU_PKX_MIDI_IN_B             = 702 ;
    MM_MOTU_PKX_MIDI_OUT_B            = 702 ;

    MM_MOTU_DTX_MIDI_IN_SYNC          = 800 ;
    MM_MOTU_DTX_MIDI_IN_A             = 801 ;
    MM_MOTU_DTX_MIDI_OUT_A            = 801 ;
    MM_MOTU_DTX_MIDI_IN_B             = 802 ;
    MM_MOTU_DTX_MIDI_OUT_B            = 802 ;

    MM_MOTU_MTPAV_MIDIOUT_ALL         = 900 ;
    MM_MOTU_MTPAV_MIDIIN_SYNC         = 900 ;
    MM_MOTU_MTPAV_MIDIIN_1            = 901 ;
    MM_MOTU_MTPAV_MIDIOUT_1           = 901 ;
    MM_MOTU_MTPAV_MIDIIN_2            = 902 ;
    MM_MOTU_MTPAV_MIDIOUT_2           = 902 ;
    MM_MOTU_MTPAV_MIDIIN_3            = 903 ;
    MM_MOTU_MTPAV_MIDIOUT_3           = 903 ;
    MM_MOTU_MTPAV_MIDIIN_4            = 904 ;
    MM_MOTU_MTPAV_MIDIOUT_4           = 904 ;
    MM_MOTU_MTPAV_MIDIIN_5            = 905 ;
    MM_MOTU_MTPAV_MIDIOUT_5           = 905 ;
    MM_MOTU_MTPAV_MIDIIN_6            = 906 ;
    MM_MOTU_MTPAV_MIDIOUT_6           = 906 ;
    MM_MOTU_MTPAV_MIDIIN_7            = 907 ;
    MM_MOTU_MTPAV_MIDIOUT_7           = 907 ;
    MM_MOTU_MTPAV_MIDIIN_8            = 908 ;
    MM_MOTU_MTPAV_MIDIOUT_8           = 908 ;
    MM_MOTU_MTPAV_NET_MIDIIN_1        = 909 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_1       = 909 ;
    MM_MOTU_MTPAV_NET_MIDIIN_2        = 910 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_2       = 910 ;
    MM_MOTU_MTPAV_NET_MIDIIN_3        = 911 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_3       = 911 ;
    MM_MOTU_MTPAV_NET_MIDIIN_4        = 912 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_4       = 912 ;
    MM_MOTU_MTPAV_NET_MIDIIN_5        = 913 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_5       = 913 ;
    MM_MOTU_MTPAV_NET_MIDIIN_6        = 914 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_6       = 914 ;
    MM_MOTU_MTPAV_NET_MIDIIN_7        = 915 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_7       = 915 ;
    MM_MOTU_MTPAV_NET_MIDIIN_8        = 916 ;
    MM_MOTU_MTPAV_NET_MIDIOUT_8       = 916 ;
    MM_MOTU_MTPAV_MIDIIN_ADAT         = 917 ;
    MM_MOTU_MTPAV_MIDIOUT_ADAT        = 917 ;
    MM_MOTU_MXPXT_MIDIIN_SYNC         = 1000;
    MM_MOTU_MXPXT_MIDIOUT_ALL         = 1000;
    MM_MOTU_MXPXT_MIDIIN_1            = 1001;
    MM_MOTU_MXPXT_MIDIOUT_1           = 1001;
    MM_MOTU_MXPXT_MIDIOUT_2           = 1002;
    MM_MOTU_MXPXT_MIDIIN_2            = 1002;
    MM_MOTU_MXPXT_MIDIIN_3            = 1003;
    MM_MOTU_MXPXT_MIDIOUT_3           = 1003;
    MM_MOTU_MXPXT_MIDIIN_4            = 1004;
    MM_MOTU_MXPXT_MIDIOUT_4           = 1004;
    MM_MOTU_MXPXT_MIDIIN_5            = 1005;
    MM_MOTU_MXPXT_MIDIOUT_5           = 1005;
    MM_MOTU_MXPXT_MIDIOUT_6           = 1006;
    MM_MOTU_MXPXT_MIDIIN_6            = 1006;
    MM_MOTU_MXPXT_MIDIOUT_7           = 1007;
    MM_MOTU_MXPXT_MIDIIN_7            = 1007;
    MM_MOTU_MXPXT_MIDIOUT_8           = 1008;
    MM_MOTU_MXPXT_MIDIIN_8            = 1008;

//-----------------------------------------------------------------------------
//  MM_WORKBIT product IDs
    MM_WORKBIT_MIXER                  = 1;     //'Harmony Mixer'
    MM_WORKBIT_WAVEOUT                = 2;     //'Harmony Mixer'
    MM_WORKBIT_WAVEIN                 = 3;     //'Harmony Mixer'
    MM_WORKBIT_MIDIIN                 = 4;     //'Harmony Mixer'
    MM_WORKBIT_MIDIOUT                = 5;     //'Harmony Mixer'
    MM_WORKBIT_FMSYNTH                = 6;     //'Harmony Mixer'
    MM_WORKBIT_AUX                    = 7;     //'Harmony Mixer'
    MM_WORKBIT_JOYSTICK               = 8;

//-----------------------------------------------------------------------------
//  MM_OSITECH product IDs
    MM_OSITECH_TRUMPCARD              = 1;      //'Trumpcard'

//-----------------------------------------------------------------------------
//  MM_MIRO product IDs
    MM_MIRO_MOVIEPRO                  = 1;      //'miroMOVIE pro'
    MM_MIRO_VIDEOD1                   = 2;      //'miroVIDEO D1'
    MM_MIRO_VIDEODC1TV                = 3;      //'miroVIDEO DC1 tv'
    MM_MIRO_VIDEOTD                   = 4;      //'miroVIDEO 10/20 TD'
    MM_MIRO_DC30_WAVEOUT              = 5;
    MM_MIRO_DC30_WAVEIN               = 6;
    MM_MIRO_DC30_MIX                  = 7;

//-----------------------------------------------------------------------------
//  MM_ISOLUTION product IDs
    MM_ISOLUTION_PASCAL               = 1;

//-----------------------------------------------------------------------------
//  MM_ROCKWELL product IDs
    MM_VOICEMIXER                 = 1  ;
ROCKWELL_WA1_WAVEIN               = 100;
ROCKWELL_WA1_WAVEOUT              = 101;
ROCKWELL_WA1_SYNTH                = 102;
ROCKWELL_WA1_MIXER                = 103;
ROCKWELL_WA1_MPU401_IN            = 104;
ROCKWELL_WA1_MPU401_OUT           = 105;
ROCKWELL_WA2_WAVEIN               = 200;
ROCKWELL_WA2_WAVEOUT              = 201;
ROCKWELL_WA2_SYNTH                = 202;
ROCKWELL_WA2_MIXER                = 203;
ROCKWELL_WA2_MPU401_IN            = 204;
ROCKWELL_WA2_MPU401_OUT           = 205;

//-----------------------------------------------------------------------------
//  MM_VOXWARE product IDs
    MM_VOXWARE_CODEC                  = 1;

//-----------------------------------------------------------------------------                                      
//  MM_NORTHERN_TELECOM product IDs
    MM_NORTEL_MPXAC_WAVEIN            = 1;      //'MPX Audio Card Wave Input Device'
    MM_NORTEL_MPXAC_WAVEOUT           = 2;      //'MPX Audio Card Wave Output Device'

//-----------------------------------------------------------------------------
//  MM_ADDX product IDs
    MM_ADDX_PCTV_DIGITALMIX           = 1;      //'MM_ADDX_PCTV_DIGITALMIX'
    MM_ADDX_PCTV_WAVEIN               = 2;      //'MM_ADDX_PCTV_WAVEIN'
    MM_ADDX_PCTV_WAVEOUT              = 3;      //'MM_ADDX_PCTV_WAVEOUT'
    MM_ADDX_PCTV_MIXER                = 4;      //'MM_ADDX_PCTV_MIXER'
    MM_ADDX_PCTV_AUX_CD               = 5;      //'MM_ADDX_PCTV_AUX_CD'
    MM_ADDX_PCTV_AUX_LINE             = 6;      //'MM_ADDX_PCTV_AUX_LINE'

//-----------------------------------------------------------------------------
//  MM_WILDCAT product IDs
    MM_WILDCAT_AUTOSCOREMIDIIN        = 1;      //'Autoscore'

//-----------------------------------------------------------------------------
//  MM_RHETOREX product IDs
    MM_RHETOREX_WAVEIN                = 1;
    MM_RHETOREX_WAVEOUT               = 2;

//-----------------------------------------------------------------------------
//  MM_BROOKTREE product IDs
    MM_BTV_WAVEIN                     = 1 ;     //'Brooktree PCM Wave Audio In'
    MM_BTV_WAVEOUT                    = 2 ;     //'Brooktree PCM Wave Audio Out'
    MM_BTV_MIDIIN                     = 3 ;     //'Brooktree MIDI In'
    MM_BTV_MIDIOUT                    = 4 ;     //'Brooktree MIDI out'
    MM_BTV_MIDISYNTH                  = 5 ;     //'Brooktree MIDI FM synth'
    MM_BTV_AUX_LINE                   = 6 ;     //'Brooktree Line Input'
    MM_BTV_AUX_MIC                    = 7 ;     //'Brooktree Microphone Input'
    MM_BTV_AUX_CD                     = 8 ;     //'Brooktree CD Input'
    MM_BTV_DIGITALIN                  = 9 ;     //'Brooktree PCM Wave in with subcode information'
    MM_BTV_DIGITALOUT                 = 10;     //'Brooktree PCM Wave out with subcode information'
    MM_BTV_MIDIWAVESTREAM             = 11;     //'Brooktree WaveStream'
    MM_BTV_MIXER                      = 12;     //'Brooktree WSS Mixer driver'

//-----------------------------------------------------------------------------
//  MM_ENSONIQ product IDs
    MM_ENSONIQ_SOUNDSCAPE             = $10;   //'ENSONIQ Soundscape'
    MM_SOUNDSCAPE_WAVEOUT             = MM_ENSONIQ_SOUNDSCAPE+1;
    MM_SOUNDSCAPE_WAVEOUT_AUX         = MM_ENSONIQ_SOUNDSCAPE+2;
    MM_SOUNDSCAPE_WAVEIN              = MM_ENSONIQ_SOUNDSCAPE+3;
    MM_SOUNDSCAPE_MIDIOUT             = MM_ENSONIQ_SOUNDSCAPE+4;
    MM_SOUNDSCAPE_MIDIIN              = MM_ENSONIQ_SOUNDSCAPE+5;
    MM_SOUNDSCAPE_SYNTH               = MM_ENSONIQ_SOUNDSCAPE+6;
    MM_SOUNDSCAPE_MIXER               = MM_ENSONIQ_SOUNDSCAPE+7;
    MM_SOUNDSCAPE_AUX                 = MM_ENSONIQ_SOUNDSCAPE+8;

//-----------------------------------------------------------------------------
//  MM_NVIDIA product IDs
    MM_NVIDIA_WAVEOUT                 = 1;
    MM_NVIDIA_WAVEIN                  = 2;
    MM_NVIDIA_MIDIOUT                 = 3;
    MM_NVIDIA_MIDIIN                  = 4;
    MM_NVIDIA_GAMEPORT                = 5;
    MM_NVIDIA_MIXER                   = 6;
    MM_NVIDIA_AUX                     = 7;

//-----------------------------------------------------------------------------
//  MM_OKSORI product IDs
    MM_OKSORI_BASE                    = 0;                     //'Oksori Base'
    MM_OKSORI_OSR8_WAVEOUT            = MM_OKSORI_BASE+1 ;     //'Oksori 8bit Wave out'
    MM_OKSORI_OSR8_WAVEIN             = MM_OKSORI_BASE+2 ;     //'Oksori 8bit Wave in'
    MM_OKSORI_OSR16_WAVEOUT           = MM_OKSORI_BASE+3 ;     //'Oksori 16 bit Wave out'
    MM_OKSORI_OSR16_WAVEIN            = MM_OKSORI_BASE+4 ;     //'Oksori 16 bit Wave in'
    MM_OKSORI_FM_OPL4                 = MM_OKSORI_BASE+5 ;     //'Oksori FM Synth Yamaha OPL4'
    MM_OKSORI_MIX_MASTER              = MM_OKSORI_BASE+6 ;     //'Oksori DSP Mixer - Master Volume'
    MM_OKSORI_MIX_WAVE                = MM_OKSORI_BASE+7 ;     //'Oksori DSP Mixer - Wave Volume'
    MM_OKSORI_MIX_FM                  = MM_OKSORI_BASE+8 ;     //'Oksori DSP Mixer - FM Volume'
    MM_OKSORI_MIX_LINE                = MM_OKSORI_BASE+9 ;     //'Oksori DSP Mixer - Line Volume'
    MM_OKSORI_MIX_CD                  = MM_OKSORI_BASE+10;     //'Oksori DSP Mixer - CD Volume'
    MM_OKSORI_MIX_MIC                 = MM_OKSORI_BASE+11;     //'Oksori DSP Mixer - MIC Volume'
    MM_OKSORI_MIX_ECHO                = MM_OKSORI_BASE+12;     //'Oksori DSP Mixer - Echo Volume'
    MM_OKSORI_MIX_AUX1                = MM_OKSORI_BASE+13;     //'Oksori AD1848 - AUX1 Volume'
    MM_OKSORI_MIX_LINE1               = MM_OKSORI_BASE+14;     //'Oksori AD1848 - LINE1 Volume'
    MM_OKSORI_EXT_MIC1                = MM_OKSORI_BASE+15;     //'Oksori External - One Mic Connect'
    MM_OKSORI_EXT_MIC2                = MM_OKSORI_BASE+16;     //'Oksori External - Two Mic Connect'
    MM_OKSORI_MIDIOUT                 = MM_OKSORI_BASE+17;     //'Oksori MIDI Out Device'
    MM_OKSORI_MIDIIN                  = MM_OKSORI_BASE+18;     //'Oksori MIDI In Device'
    MM_OKSORI_MPEG_CDVISION           = MM_OKSORI_BASE+19;     //'Oksori CD-Vision MPEG Decoder'

//-----------------------------------------------------------------------------
//  MM_DIACOUSTICS product IDs
    MM_DIACOUSTICS_DRUM_ACTION        = 1;      //'Drum Action'

//-----------------------------------------------------------------------------
//  MM_KAY_ELEMETRICS product IDs
    MM_KAY_ELEMETRICS_CSL             = $4300;
    MM_KAY_ELEMETRICS_CSL_DAT         = $4308;
    MM_KAY_ELEMETRICS_CSL_4CHANNEL    = $4309;

//-----------------------------------------------------------------------------
//  MM_CRYSTAL product IDs
    MM_CRYSTAL_CS4232_WAVEIN          = 1 ;
    MM_CRYSTAL_CS4232_WAVEOUT         = 2 ;
    MM_CRYSTAL_CS4232_WAVEMIXER       = 3 ;
    MM_CRYSTAL_CS4232_WAVEAUX_AUX1    = 4 ;
    MM_CRYSTAL_CS4232_WAVEAUX_AUX2    = 5 ;
    MM_CRYSTAL_CS4232_WAVEAUX_LINE    = 6 ;
    MM_CRYSTAL_CS4232_WAVEAUX_MONO    = 7 ;
    MM_CRYSTAL_CS4232_WAVEAUX_MASTER  = 8 ;
    MM_CRYSTAL_CS4232_MIDIIN          = 9 ;
    MM_CRYSTAL_CS4232_MIDIOUT         = 10;
    MM_CRYSTAL_CS4232_INPUTGAIN_AUX1  = 13;
    MM_CRYSTAL_CS4232_INPUTGAIN_LOOP  = 14;
    MM_CRYSTAL_SOUND_FUSION_WAVEIN    = 21;
    MM_CRYSTAL_SOUND_FUSION_WAVEOUT   = 22;
    MM_CRYSTAL_SOUND_FUSION_MIXER     = 23;
    MM_CRYSTAL_SOUND_FUSION_MIDIIN    = 24;
    MM_CRYSTAL_SOUND_FUSION_MIDIOUT   = 25;
    MM_CRYSTAL_SOUND_FUSION_JOYSTICK  = 26;

//-----------------------------------------------------------------------------
//  MM_QUARTERDECK product IDs
    MM_QUARTERDECK_LHWAVEIN           = 0;     //'Quarterdeck L&H Codec Wave In'
    MM_QUARTERDECK_LHWAVEOUT          = 1;     //'Quarterdeck L&H Codec Wave Out'

//-----------------------------------------------------------------------------
//  MM_TDK product IDs
    MM_TDK_MW_MIDI_SYNTH              = 1  ;
    MM_TDK_MW_MIDI_IN                 = 2  ;
    MM_TDK_MW_MIDI_OUT                = 3  ;
    MM_TDK_MW_WAVE_IN                 = 4  ;
    MM_TDK_MW_WAVE_OUT                = 5  ;
    MM_TDK_MW_AUX                     = 6  ;
    MM_TDK_MW_MIXER                   = 10 ;
    MM_TDK_MW_AUX_MASTER              = 100;
    MM_TDK_MW_AUX_BASS                = 101;
    MM_TDK_MW_AUX_TREBLE              = 102;
    MM_TDK_MW_AUX_MIDI_VOL            = 103;
    MM_TDK_MW_AUX_WAVE_VOL            = 104;
    MM_TDK_MW_AUX_WAVE_RVB            = 105;
    MM_TDK_MW_AUX_WAVE_CHR            = 106;
    MM_TDK_MW_AUX_VOL                 = 107;
    MM_TDK_MW_AUX_RVB                 = 108;
    MM_TDK_MW_AUX_CHR                 = 109;

//-----------------------------------------------------------------------------
//  MM_DIGITAL_AUDIO_LABS product IDs
    MM_DIGITAL_AUDIO_LABS_TC          = $01;
    MM_DIGITAL_AUDIO_LABS_DOC         = $02;
    MM_DIGITAL_AUDIO_LABS_V8          = $10;
    MM_DIGITAL_AUDIO_LABS_CPRO        = $11;
    MM_DIGITAL_AUDIO_LABS_VP          = $12;
    MM_DIGITAL_AUDIO_LABS_CDLX        = $13;
    MM_DIGITAL_AUDIO_LABS_CTDIF       = $14;

//-----------------------------------------------------------------------------
//  MM_SEERSYS product IDs
    MM_SEERSYS_SEERSYNTH              = 1;
    MM_SEERSYS_SEERWAVE               = 2;
    MM_SEERSYS_SEERMIX                = 3;
    MM_SEERSYS_WAVESYNTH              = 4;
    MM_SEERSYS_WAVESYNTH_WG           = 5;
    MM_SEERSYS_REALITY                = 6;

//-----------------------------------------------------------------------------
//  MM_OSPREY product IDs
    MM_OSPREY_1000WAVEIN              = 1;
    MM_OSPREY_1000WAVEOUT             = 2;

//-----------------------------------------------------------------------------
//  MM_SOUNDESIGNS product IDs
    MM_SOUNDESIGNS_WAVEIN             = 1;
    MM_SOUNDESIGNS_WAVEOUT            = 2;

//-----------------------------------------------------------------------------
//  MM_SPECTRUM_SIGNAL_PROCESSING product IDs
    MM_SSP_SNDFESWAVEIN               = 1;      //'Sound Festa Wave In Device'
    MM_SSP_SNDFESWAVEOUT              = 2;      //'Sound Festa Wave Out Device'
    MM_SSP_SNDFESMIDIIN               = 3;      //'Sound Festa MIDI In Device'
    MM_SSP_SNDFESMIDIOUT              = 4;      //'Sound Festa MIDI Out Device'
    MM_SSP_SNDFESSYNTH                = 5;      //'Sound Festa MIDI Synth Device'
    MM_SSP_SNDFESMIX                  = 6;      //'Sound Festa Mixer Device'
    MM_SSP_SNDFESAUX                  = 7;      //'Sound Festa Auxilliary Device'

//-----------------------------------------------------------------------------
//  MM_ECS product IDs
    MM_ECS_AADF_MIDI_IN               = 10;
    MM_ECS_AADF_MIDI_OUT              = 11;
    MM_ECS_AADF_WAVE2MIDI_IN          = 12;

//-----------------------------------------------------------------------------
//  MM_AMD product IDs
    MM_AMD_INTERWAVE_WAVEIN           = 1 ;
    MM_AMD_INTERWAVE_WAVEOUT          = 2 ;
    MM_AMD_INTERWAVE_SYNTH            = 3 ;
    MM_AMD_INTERWAVE_MIXER1           = 4 ;
    MM_AMD_INTERWAVE_MIXER2           = 5 ;
    MM_AMD_INTERWAVE_JOYSTICK         = 6 ;
    MM_AMD_INTERWAVE_EX_CD            = 7 ;
    MM_AMD_INTERWAVE_MIDIIN           = 8 ;
    MM_AMD_INTERWAVE_MIDIOUT          = 9 ;
    MM_AMD_INTERWAVE_AUX1             = 10;
    MM_AMD_INTERWAVE_AUX2             = 11;
    MM_AMD_INTERWAVE_AUX_MIC          = 12;
    MM_AMD_INTERWAVE_AUX_CD           = 13;
    MM_AMD_INTERWAVE_MONO_IN          = 14;
    MM_AMD_INTERWAVE_MONO_OUT         = 15;
    MM_AMD_INTERWAVE_EX_TELEPHONY     = 16;
    MM_AMD_INTERWAVE_WAVEOUT_BASE     = 17;
    MM_AMD_INTERWAVE_WAVEOUT_TREBLE   = 18;
    MM_AMD_INTERWAVE_STEREO_ENHANCED  = 19;

//-----------------------------------------------------------------------------
//  MM_COREDYNAMICS product IDs
    MM_COREDYNAMICS_DYNAMIXHR           = 1 ;     //'DynaMax Hi-Rez'
    MM_COREDYNAMICS_DYNASONIX_SYNTH     = 2 ;     //'DynaSonix'
    MM_COREDYNAMICS_DYNASONIX_MIDI_IN   = 3 ;
    MM_COREDYNAMICS_DYNASONIX_MIDI_OUT  = 4 ;
    MM_COREDYNAMICS_DYNASONIX_WAVE_IN   = 5 ;
    MM_COREDYNAMICS_DYNASONIX_WAVE_OUT  = 6 ;
    MM_COREDYNAMICS_DYNASONIX_AUDIO_IN  = 7 ;
    MM_COREDYNAMICS_DYNASONIX_AUDIO_OUT = 8 ;
    MM_COREDYNAMICS_DYNAGRAFX_VGA       = 9 ;     //'DynaGrfx'
    MM_COREDYNAMICS_DYNAGRAFX_WAVE_IN   = 10;
    MM_COREDYNAMICS_DYNAGRAFX_WAVE_OUT  = 11;

//-----------------------------------------------------------------------------
//  MM_CANAM product IDs
    MM_CANAM_CBXWAVEOUT               = 1;
    MM_CANAM_CBXWAVEIN                = 2;

//-----------------------------------------------------------------------------                                      
//  MM_SOFTSOUND product IDs
    MM_SOFTSOUND_CODEC                = 1;

//-----------------------------------------------------------------------------
//  MM_NORRIS product IDs
    MM_NORRIS_VOICELINK               = 1;

//-----------------------------------------------------------------------------
//  MM_DDD product IDs
    MM_DDD_MIDILINK_MIDIIN            = 1;
    MM_DDD_MIDILINK_MIDIOUT           = 2;

//-----------------------------------------------------------------------------
//  MM_EUPHONICS product IDs
    MM_EUPHONICS_AUX_CD               = 1 ;
    MM_EUPHONICS_AUX_LINE             = 2 ;
    MM_EUPHONICS_AUX_MASTER           = 3 ;
    MM_EUPHONICS_AUX_MIC              = 4 ;
    MM_EUPHONICS_AUX_MIDI             = 5 ;
    MM_EUPHONICS_AUX_WAVE             = 6 ;
    MM_EUPHONICS_FMSYNTH_MONO         = 7 ;
    MM_EUPHONICS_FMSYNTH_STEREO       = 8 ;
    MM_EUPHONICS_MIDIIN               = 9 ;
    MM_EUPHONICS_MIDIOUT              = 10;
    MM_EUPHONICS_MIXER                = 11;
    MM_EUPHONICS_WAVEIN               = 12;
    MM_EUPHONICS_WAVEOUT              = 13;
    MM_EUPHONICS_EUSYNTH              = 14;

//-----------------------------------------------------------------------------                                      
//  MM_CRYSTAL_NET product IDs
CRYSTAL_NET_SFM_CODEC             = 1;

//-----------------------------------------------------------------------------
//  MM_CHROMATIC product IDs
    MM_CHROMATIC_M1                   = $0001;
    MM_CHROMATIC_M1_WAVEIN            = $0002;
    MM_CHROMATIC_M1_WAVEOUT           = $0003;
    MM_CHROMATIC_M1_FMSYNTH           = $0004;
    MM_CHROMATIC_M1_MIXER             = $0005;
    MM_CHROMATIC_M1_AUX               = $0006;
    MM_CHROMATIC_M1_AUX_CD            = $0007;
    MM_CHROMATIC_M1_MIDIIN            = $0008;
    MM_CHROMATIC_M1_MIDIOUT           = $0009;
    MM_CHROMATIC_M1_WTSYNTH           = $0010;
    MM_CHROMATIC_M1_MPEGWAVEIN        = $0011;
    MM_CHROMATIC_M1_MPEGWAVEOUT       = $0012;
    MM_CHROMATIC_M2                   = $0013;
    MM_CHROMATIC_M2_WAVEIN            = $0014;
    MM_CHROMATIC_M2_WAVEOUT           = $0015;
    MM_CHROMATIC_M2_FMSYNTH           = $0016;
    MM_CHROMATIC_M2_MIXER             = $0017;
    MM_CHROMATIC_M2_AUX               = $0018;
    MM_CHROMATIC_M2_AUX_CD            = $0019;
    MM_CHROMATIC_M2_MIDIIN            = $0020;
    MM_CHROMATIC_M2_MIDIOUT           = $0021;
    MM_CHROMATIC_M2_WTSYNTH           = $0022;
    MM_CHROMATIC_M2_MPEGWAVEIN        = $0023;
    MM_CHROMATIC_M2_MPEGWAVEOUT       = $0024;

//-----------------------------------------------------------------------------
//  MM_VIENNASYS product IDs
    MM_VIENNASYS_TSP_WAVE_DRIVER      = 1;

//-----------------------------------------------------------------------------
//  MM_CONNECTIX product IDs
    MM_CONNECTIX_VIDEC_CODEC          = 1;

//-----------------------------------------------------------------------------
//  MM_GADGETLABS product IDs
    MM_GADGETLABS_WAVE44_WAVEIN       = 1;
    MM_GADGETLABS_WAVE44_WAVEOUT      = 2;
    MM_GADGETLABS_WAVE42_WAVEIN       = 3;
    MM_GADGETLABS_WAVE42_WAVEOUT      = 4;
    MM_GADGETLABS_WAVE4_MIDIIN        = 5;
    MM_GADGETLABS_WAVE4_MIDIOUT       = 6;

//-----------------------------------------------------------------------------
//  MM_FRONTIER product IDs
    MM_FRONTIER_WAVECENTER_MIDIIN     = 1;      //'WaveCenter'
    MM_FRONTIER_WAVECENTER_MIDIOUT    = 2;
    MM_FRONTIER_WAVECENTER_WAVEIN     = 3;
    MM_FRONTIER_WAVECENTER_WAVEOUT    = 4;

//-----------------------------------------------------------------------------
//  MM_VIONA product IDs
    MM_VIONA_QVINPCI_MIXER            = 1;      //'Q-Motion PCI II/Bravado 2000'
    MM_VIONA_QVINPCI_WAVEIN           = 2;
    MM_VIONAQVINPCI_WAVEOUT           = 3;
    MM_VIONA_BUSTER_MIXER             = 4;      //'Buster'
    MM_VIONA_CINEMASTER_MIXER         = 5;      //'Cinemaster'
    MM_VIONA_CONCERTO_MIXER           = 6;      //'Concerto'

//-----------------------------------------------------------------------------
//  MM_CASIO product IDs
    MM_CASIO_WP150_MIDIOUT            = 1;      //'wp150'
    MM_CASIO_WP150_MIDIIN             = 2;
    MM_CASIO_LSG_MIDIOUT              = 3;

//-----------------------------------------------------------------------------
//  MM_DIAMONDMM product IDs
    MM_DIMD_PLATFORM                  = 0 ;     //'Freedom Audio'
    MM_DIMD_DIRSOUND                  = 1 ;
    MM_DIMD_VIRTMPU                   = 2 ;
    MM_DIMD_VIRTSB                    = 3 ;
    MM_DIMD_VIRTJOY                   = 4 ;
    MM_DIMD_WAVEIN                    = 5 ;
    MM_DIMD_WAVEOUT                   = 6 ;
    MM_DIMD_MIDIIN                    = 7 ;
    MM_DIMD_MIDIOUT                   = 8 ;
    MM_DIMD_AUX_LINE                  = 9 ;
    MM_DIMD_MIXER                     = 10;
    MM_DIMD_WSS_WAVEIN                = 14;
    MM_DIMD_WSS_WAVEOUT               = 15;
    MM_DIMD_WSS_MIXER                 = 17;
    MM_DIMD_WSS_AUX                   = 21;
    MM_DIMD_WSS_SYNTH                 = 76;

//-----------------------------------------------------------------------------                                      
//  MM_S3 product IDs
    MM_S3_WAVEOUT                     = 1;
    MM_S3_WAVEIN                      = 2;
    MM_S3_MIDIOUT                     = 3;
    MM_S3_MIDIIN                      = 4;
    MM_S3_FMSYNTH                     = 5;
    MM_S3_MIXER                       = 6;
    MM_S3_AUX                         = 7;

//-----------------------------------------------------------------------------
//  MM_VANKOEVERING product IDs
    MM_VKC_MPU401_MIDIIN              = $0100;
    MM_VKC_SERIAL_MIDIIN              = $0101;
    MM_VKC_MPU401_MIDIOUT             = $0200;
    MM_VKC_SERIAL_MIDIOUT             = $0201;

//-----------------------------------------------------------------------------                                      
//  MM_ZEFIRO product IDs
    MM_ZEFIRO_ZA2                     = 2;

//-----------------------------------------------------------------------------
//  MM_FRAUNHOFER_IIS product IDs
    MM_FHGIIS_MPEGLAYER3              = 10;

//-----------------------------------------------------------------------------
//  MM_QUICKNET product IDs
    MM_QUICKNET_PJWAVEIN              = 1;
    MM_QUICKNET_PJWAVEOUT             = 2;

//-----------------------------------------------------------------------------
//  MM_SICRESOURCE product IDs
    MM_SICRESOURCE_SSO3D              = 2;
    MM_SICRESOURCE_SSOW3DI            = 3;

//-----------------------------------------------------------------------------
//  MM_NEOMAGIC product IDs
    MM_NEOMAGIC_SYNTH                 = 1 ;
    MM_NEOMAGIC_WAVEOUT               = 2 ;
    MM_NEOMAGIC_WAVEIN                = 3 ;
    MM_NEOMAGIC_MIDIOUT               = 4 ;
    MM_NEOMAGIC_MIDIIN                = 5 ;
    MM_NEOMAGIC_AUX                   = 6 ;
    MM_NEOMAGIC_MW3DX_WAVEOUT         = 10;
    MM_NEOMAGIC_MW3DX_WAVEIN          = 11;
    MM_NEOMAGIC_MW3DX_MIDIOUT         = 12;
    MM_NEOMAGIC_MW3DX_MIDIIN          = 13;
    MM_NEOMAGIC_MW3DX_FMSYNTH         = 14;
    MM_NEOMAGIC_MW3DX_GMSYNTH         = 15;
    MM_NEOMAGIC_MW3DX_MIXER           = 16;
    MM_NEOMAGIC_MW3DX_AUX             = 17;
    MM_NEOMAGIC_MWAVE_WAVEOUT         = 20;
    MM_NEOMAGIC_MWAVE_WAVEIN          = 21;
    MM_NEOMAGIC_MWAVE_MIDIOUT         = 22;
    MM_NEOMAGIC_MWAVE_MIDIIN          = 23;
    MM_NEOMAGIC_MWAVE_MIXER           = 24;
    MM_NEOMAGIC_MWAVE_AUX             = 25;

//-----------------------------------------------------------------------------                                      
//  MM_MERGING_TECHNOLOGIES product IDs
    MM_MERGING_MPEGL3                 = 1;

//-----------------------------------------------------------------------------
//  MM_XIRLINK product IDs
    MM_XIRLINK_VISIONLINK             = 1;

//-----------------------------------------------------------------------------
//  MM_OTI product IDs
    MM_OTI_611WAVEIN                  = 5  ;
    MM_OTI_611WAVEOUT                 = 6  ;
    MM_OTI_611MIXER                   = 7  ;
    MM_OTI_611MIDIN                   = $12;
    MM_OTI_611MIDIOUT                 = $13;

//-----------------------------------------------------------------------------
//  MM_AUREAL product IDs
    MM_AUREAL_AU8820                  = 16;
    MM_AU8820_SYNTH                   = 17;
    MM_AU8820_WAVEOUT                 = 18;
    MM_AU8820_WAVEIN                  = 19;
    MM_AU8820_MIXER                   = 20;
    MM_AU8820_AUX                     = 21;
    MM_AU8820_MIDIOUT                 = 22;
    MM_AU8820_MIDIIN                  = 23;
    MM_AUREAL_AU8830                  = 32;
    MM_AU8830_SYNTH                   = 33;
    MM_AU8830_WAVEOUT                 = 34;
    MM_AU8830_WAVEIN                  = 35;
    MM_AU8830_MIXER                   = 36;
    MM_AU8830_AUX                     = 37;
    MM_AU8830_MIDIOUT                 = 38;
    MM_AU8830_MIDIIN                  = 39;

//-----------------------------------------------------------------------------
//  MM_VIVO product IDs
    MM_VIVO_AUDIO_CODEC               = 1;

//-----------------------------------------------------------------------------
//  MM_SHARP product IDs
    MM_SHARP_MDC_MIDI_SYNTH           = 1  ;
    MM_SHARP_MDC_MIDI_IN              = 2  ;
    MM_SHARP_MDC_MIDI_OUT             = 3  ;
    MM_SHARP_MDC_WAVE_IN              = 4  ;
    MM_SHARP_MDC_WAVE_OUT             = 5  ;
    MM_SHARP_MDC_AUX                  = 6  ;
    MM_SHARP_MDC_MIXER                = 10 ;
    MM_SHARP_MDC_AUX_MASTER           = 100;
    MM_SHARP_MDC_AUX_BASS             = 101;
    MM_SHARP_MDC_AUX_TREBLE           = 102;
    MM_SHARP_MDC_AUX_MIDI_VOL         = 103;
    MM_SHARP_MDC_AUX_WAVE_VOL         = 104;
    MM_SHARP_MDC_AUX_WAVE_RVB         = 105;
    MM_SHARP_MDC_AUX_WAVE_CHR         = 106;
    MM_SHARP_MDC_AUX_VOL              = 107;
    MM_SHARP_MDC_AUX_RVB              = 108;
    MM_SHARP_MDC_AUX_CHR              = 109;

//-----------------------------------------------------------------------------
//  MM_LUCENT product IDs
    MM_LUCENT_ACM_G723                = 0;

//-----------------------------------------------------------------------------
//  MM_ATT product IDs
    MM_ATT_G729A                      = 1;

//-----------------------------------------------------------------------------
//  MM_MARIAN product IDs
    MM_MARIAN_ARC44WAVEIN             = 1;
    MM_MARIAN_ARC44WAVEOUT            = 2;
    MM_MARIAN_PRODIF24WAVEIN          = 3;
    MM_MARIAN_PRODIF24WAVEOUT         = 4;
    MM_MARIAN_ARC88WAVEIN             = 5;
    MM_MARIAN_ARC88WAVEOUT            = 6;

//-----------------------------------------------------------------------------
//  MM_BCB product IDs
    MM_BCB_NETBOARD_10                = 1;
    MM_BCB_TT75_10                    = 2;

//-----------------------------------------------------------------------------
//  MM_MOTIONPIXELS product IDs
    MM_MOTIONPIXELS_MVI2              = 1;

//-----------------------------------------------------------------------------
//  MM_QDESIGN product IDs
    MM_QDESIGN_ACM_MPEG               = 1;
    MM_QDESIGN_ACM_QDESIGN_MUSIC      = 2;

//-----------------------------------------------------------------------------
//  MM_NMP product IDs
    MM_NMP_CCP_WAVEIN                 = 1 ;
    MM_NMP_CCP_WAVEOUT                = 2 ;
    MM_NMP_ACM_AMR                    = 10;

//-----------------------------------------------------------------------------
//  MM_DATAFUSION product IDs
    MM_DF_ACM_G726                    = 1;
    MM_DF_ACM_GSM610                  = 2;

//-----------------------------------------------------------------------------
//  MM_BERCOS product IDs
    MM_BERCOS_WAVEIN                  = 1;
    MM_BERCOS_MIXER                   = 2;
    MM_BERCOS_WAVEOUT                 = 3;

//-----------------------------------------------------------------------------
//  MM_ONLIVE product IDs
    MM_ONLIVE_MPCODEC                 = 1;

//-----------------------------------------------------------------------------
//  MM_PHONET product IDs
    MM_PHONET_PP_WAVEOUT              = 1;
    MM_PHONET_PP_WAVEIN               = 2;
    MM_PHONET_PP_MIXER                = 3;

//-----------------------------------------------------------------------------
//  MM_FTR product IDs
    MM_FTR_ENCODER_WAVEIN             = 1;
    MM_FTR_ACM                        = 2;

//-----------------------------------------------------------------------------
//  MM_ENET product IDs
    MM_ENET_T2000_LINEIN              = 1;
    MM_ENET_T2000_LINEOUT             = 2;
    MM_ENET_T2000_HANDSETIN           = 3;
    MM_ENET_T2000_HANDSETOUT          = 4;

//-----------------------------------------------------------------------------
//  MM_EMAGIC product IDs
    MM_EMAGIC_UNITOR8                 = 1;

//-----------------------------------------------------------------------------
//  MM_SIPROLAB product IDs
    MM_SIPROLAB_ACELPNET              = 1;

//-----------------------------------------------------------------------------
//  MM_DICTAPHONE product IDs
    MM_DICTAPHONE_G726                = 1;      //'G726 ACM codec (g726pcm.acm)'

//-----------------------------------------------------------------------------
//  MM_RZS product IDs
    MM_RZS_ACM_TUBGSM                 = 1;     //'GSM 06.10 CODEC'

//-----------------------------------------------------------------------------
//  MM_EES product IDs
    MM_EES_PCMIDI14                   = 1;
    MM_EES_PCMIDI14_IN                = 2;
    MM_EES_PCMIDI14_OUT1              = 3;
    MM_EES_PCMIDI14_OUT2              = 4;
    MM_EES_PCMIDI14_OUT3              = 5;
    MM_EES_PCMIDI14_OUT4              = 6;

//-----------------------------------------------------------------------------
//  MM_HAFTMANN product IDs
    MM_HAFTMANN_LPTDAC2               = 1;

//-----------------------------------------------------------------------------
//  MM_LUCID product IDs
    MM_LUCID_PCI24WAVEIN              = 1;
    MM_LUCID_PCI24WAVEOUT             = 2;

//-----------------------------------------------------------------------------
//  MM_HEADSPACE product IDs
    MM_HEADSPACE_HAESYNTH             = 1;
    MM_HEADSPACE_HAEWAVEOUT           = 2;
    MM_HEADSPACE_HAEWAVEIN            = 3;
    MM_HEADSPACE_HAEMIXER             = 4;

//-----------------------------------------------------------------------------
//  MM_UNISYS product IDs
    MM_UNISYS_ACM_NAP                 = 1;

//-----------------------------------------------------------------------------
//  MM_LUMINOSITI product IDs

    MM_LUMINOSITI_SCWAVEIN            = 1;
    MM_LUMINOSITI_SCWAVEOUT           = 2;
    MM_LUMINOSITI_SCWAVEMIX           = 3;

//-----------------------------------------------------------------------------
//  MM_ACTIVEVOICE product IDs
    MM_ACTIVEVOICE_ACM_VOXADPCM       = 1;

//-----------------------------------------------------------------------------
//  MM_DTS product IDs
    MM_DTS_DS                         = 1;

//-----------------------------------------------------------------------------
//  MM_SOFTLAB_NSK product IDs
    MM_SOFTLAB_NSK_FRW_WAVEIN         = 1;
    MM_SOFTLAB_NSK_FRW_WAVEOUT        = 2;
    MM_SOFTLAB_NSK_FRW_MIXER          = 3;
    MM_SOFTLAB_NSK_FRW_AUX            = 4;

//-----------------------------------------------------------------------------
//  MM_FORTEMEDIA product IDs
    MM_FORTEMEDIA_WAVEIN              = 1;
    MM_FORTEMEDIA_WAVEOUT             = 2;
    MM_FORTEMEDIA_FMSYNC              = 3;
    MM_FORTEMEDIA_MIXER               = 4;
    MM_FORTEMEDIA_AUX                 = 5;

//-----------------------------------------------------------------------------
//  MM_SONORUS product IDs
    MM_SONORUS_STUDIO                 = 1;

//-----------------------------------------------------------------------------
//  MM_I_LINK product IDs
    MM_I_LINK_VOICE_CODER             = 1;

//-----------------------------------------------------------------------------
//  MM_SELSIUS_SYSTEMS product IDs
    MM_SELSIUS_SYSTEMS_RTPWAVEOUT     = 1;
    MM_SELSIUS_SYSTEMS_RTPWAVEIN      = 2;

//-----------------------------------------------------------------------------
//  MM_ADMOS product IDs
    MM_ADMOS_FM_SYNTH                 = 1;
    MM_ADMOS_QS3AMIDIOUT              = 2;
    MM_ADMOS_QS3AMIDIIN               = 3;
    MM_ADMOS_QS3AWAVEOUT              = 4;
    MM_ADMOS_QS3AWAVEIN               = 5;

//-----------------------------------------------------------------------------
//  MM_LEXICON product IDs
    MM_LEXICON_STUDIO_WAVE_OUT        = 1;
    MM_LEXICON_STUDIO_WAVE_IN         = 2;

//-----------------------------------------------------------------------------
//  MM_SGI product IDs
    MM_SGI_320_WAVEIN                 = 1 ;
    MM_SGI_320_WAVEOUT                = 2 ;
    MM_SGI_320_MIXER                  = 3 ;
    MM_SGI_540_WAVEIN                 = 4 ;
    MM_SGI_540_WAVEOUT                = 5 ;
    MM_SGI_540_MIXER                  = 6 ;
    MM_SGI_RAD_ADATMONO1_WAVEIN       = 7 ;
    MM_SGI_RAD_ADATMONO2_WAVEIN       = 8 ;
    MM_SGI_RAD_ADATMONO3_WAVEIN       = 9 ;
    MM_SGI_RAD_ADATMONO4_WAVEIN       = 10;
    MM_SGI_RAD_ADATMONO5_WAVEIN       = 11;
    MM_SGI_RAD_ADATMONO6_WAVEIN       = 12;
    MM_SGI_RAD_ADATMONO7_WAVEIN       = 13;
    MM_SGI_RAD_ADATMONO8_WAVEIN       = 14;
    MM_SGI_RAD_ADATSTEREO12_WAVEIN    = 15;
    MM_SGI_RAD_ADATSTEREO34_WAVEIN    = 16;
    MM_SGI_RAD_ADATSTEREO56_WAVEIN    = 17;
    MM_SGI_RAD_ADATSTEREO78_WAVEIN    = 18;
    MM_SGI_RAD_ADAT8CHAN_WAVEIN       = 19;
    MM_SGI_RAD_ADATMONO1_WAVEOUT      = 20;
    MM_SGI_RAD_ADATMONO2_WAVEOUT      = 21;
    MM_SGI_RAD_ADATMONO3_WAVEOUT      = 22;
    MM_SGI_RAD_ADATMONO4_WAVEOUT      = 23;
    MM_SGI_RAD_ADATMONO5_WAVEOUT      = 24;
    MM_SGI_RAD_ADATMONO6_WAVEOUT      = 25;
    MM_SGI_RAD_ADATMONO7_WAVEOUT      = 26;
    MM_SGI_RAD_ADATMONO8_WAVEOUT      = 27;
    MM_SGI_RAD_ADATSTEREO12_WAVEOUT   = 28;
    MM_SGI_RAD_ADATSTEREO32_WAVEOUT   = 29;
    MM_SGI_RAD_ADATSTEREO56_WAVEOUT   = 30;
    MM_SGI_RAD_ADATSTEREO78_WAVEOUT   = 31;
    MM_SGI_RAD_ADAT8CHAN_WAVEOUT      = 32;
    MM_SGI_RAD_AESMONO1_WAVEIN        = 33;
    MM_SGI_RAD_AESMONO2_WAVEIN        = 34;
    MM_SGI_RAD_AESSTEREO_WAVEIN       = 35;
    MM_SGI_RAD_AESMONO1_WAVEOUT       = 36;
    MM_SGI_RAD_AESMONO2_WAVEOUT       = 37;
    MM_SGI_RAD_AESSTEREO_WAVEOUT      = 38;

//-----------------------------------------------------------------------------
//  MM_IPI product IDs
    MM_IPI_ACM_HSX                    = 1;
    MM_IPI_ACM_RPELP                  = 2;
    MM_IPI_WF_ASSS                    = 3;
    MM_IPI_AT_WAVEOUT                 = 4;
    MM_IPI_AT_WAVEIN                  = 5;
    MM_IPI_AT_MIXER                   = 6;

//-----------------------------------------------------------------------------
//  MM_ICE product IDs
    MM_ICE_WAVEOUT                    = 1 ;
    MM_ICE_WAVEIN                     = 2 ;
    MM_ICE_MTWAVEOUT                  = 3 ;
    MM_ICE_MTWAVEIN                   = 4 ;
    MM_ICE_MIDIOUT1                   = 5 ;
    MM_ICE_MIDIIN1                    = 6 ;
    MM_ICE_MIDIOUT2                   = 7 ;
    MM_ICE_MIDIIN2                    = 8 ;
    MM_ICE_SYNTH                      = 9 ;
    MM_ICE_MIXER                      = 10;
    MM_ICE_AUX                        = 11;

//-----------------------------------------------------------------------------
//  MM_VQST product IDs
    MM_VQST_VQC1                      = 1;
    MM_VQST_VQC2                      = 2;

//-----------------------------------------------------------------------------
//  MM_ETEK product IDs
    MM_ETEK_KWIKMIDI_MIDIIN           = 1;
    MM_ETEK_KWIKMIDI_MIDIOUT          = 2;

//-----------------------------------------------------------------------------
//  MM_INTERNET product IDs
    MM_INTERNET_SSW_MIDIOUT           = 10;
    MM_INTERNET_SSW_MIDIIN            = 11;
    MM_INTERNET_SSW_WAVEOUT           = 12;
    MM_INTERNET_SSW_WAVEIN            = 13;

//-----------------------------------------------------------------------------
//  MM_SONY product IDs
    MM_SONY_ACM_SCX                   = 1;

//-----------------------------------------------------------------------------
//  MM_UHER_INFORMATIC product IDs
    MM_UH_ACM_ADPCM                   = 1;

//-----------------------------------------------------------------------------
//  MM_SYDEC_NV product IDs
    MM_SYDEC_NV_WAVEIN                = 1;
    MM_SYDEC_NV_WAVEOUT               = 2;

//-----------------------------------------------------------------------------
//  MM_FLEXION product IDs
    MM_FLEXION_X300_WAVEIN            = 1;
    MM_FLEXION_X300_WAVEOUT           = 2;

//-----------------------------------------------------------------------------
//  MM_VIA product IDs
    MM_VIA_WAVEOUT                    = 1 ;
    MM_VIA_WAVEIN                     = 2 ;
    MM_VIA_MIXER                      = 3 ;
    MM_VIA_AUX                        = 4 ;
    MM_VIA_MPU401_MIDIOUT             = 5 ;
    MM_VIA_MPU401_MIDIIN              = 6 ;
    MM_VIA_SWFM_SYNTH                 = 7 ;
    MM_VIA_WDM_WAVEOUT                = 8 ;
    MM_VIA_WDM_WAVEIN                 = 9 ;
    MM_VIA_WDM_MIXER                  = 10;
    MM_VIA_WDM_MPU401_MIDIOUT         = 11;
    MM_VIA_WDM_MPU401_MIDIIN          = 12;

//-----------------------------------------------------------------------------
//  MM_MICRONAS product IDs
    MM_MICRONAS_SC4                   = 1;
    MM_MICRONAS_CLP833                = 2;

//-----------------------------------------------------------------------------
//  MM_HP product IDs
    MM_HP_WAVEOUT                     = 1;
    MM_HP_WAVEIN                      = 2;

//-----------------------------------------------------------------------------
//  MM_QUICKAUDIO product IDs
    MM_QUICKAUDIO_MINIMIDI            = 1;
    MM_QUICKAUDIO_MAXIMIDI            = 2;

//-----------------------------------------------------------------------------
//  MM_ICCC product IDs
    MM_ICCC_UNA3_WAVEIN               = 1;
    MM_ICCC_UNA3_WAVEOUT              = 2;
    MM_ICCC_UNA3_AUX                  = 3;
    MM_ICCC_UNA3_MIXER                = 4;

//-----------------------------------------------------------------------------
//  MM_3COM product IDs
    MM_3COM_CB_MIXER                  = 1;
    MM_3COM_CB_WAVEIN                 = 2;
    MM_3COM_CB_WAVEOUT                = 3;

//-----------------------------------------------------------------------------
//  MM_MINDMAKER product IDs
    MM_MINDMAKER_GC_WAVEIN            = 1;
    MM_MINDMAKER_GC_WAVEOUT           = 2;
    MM_MINDMAKER_GC_MIXER             = 3;

//-----------------------------------------------------------------------------
//  MM_TELEKOL product IDs
    MM_TELEKOL_WAVEOUT                = 1;
    MM_TELEKOL_WAVEIN                 = 2;

//-----------------------------------------------------------------------------
//  MM_ALGOVISION product IDs
    MM_ALGOVISION_VB80WAVEOUT         = 1;
    MM_ALGOVISION_VB80WAVEIN          = 2;
    MM_ALGOVISION_VB80MIXER           = 3;
    MM_ALGOVISION_VB80AUX             = 4;
    MM_ALGOVISION_VB80AUX2            = 5;

//-----------------------------------------------------------------------------
    MM_PID_UNMAPPED                   = MM_UNMAPPED;    //'extensible PID mapping'

//-----------------------------------------------------------------------------
//  TMixerCaps ł邾ɒ
function GetMixerCapsDetail(const AMixerCaps: TMixerCaps): TMixerCapsDetail;

implementation

//-----------------------------------------------------------------------------
//  TMixerCaps ł邾ɒ
function GetMixerCapsDetail(const AMixerCaps: TMixerCaps): TMixerCapsDetail;
var
    LVersion: MMVERSION;
begin
    Result.ProductName := AMixerCaps.szPname;

    LVersion := AMixerCaps.vDriverVersion;
    Result.DriverVersion := Format('Ver.%d.%d', [HiWord(LVersion), LoWord(LVersion)]);

    Result.fdwSupport := AMixerCaps.fdwSupport;
    Result.cDestinations := AMixerCaps.cDestinations;
    
    case AMixerCaps.wMid of
        MM_MICROSOFT                 :
        begin
            Result.Manufacturer := 'Microsoft Corporation';
            case AMixerCaps.wPid of
            MM_MIDI_MAPPER                    : Result.Product := 'Midi Mapper';
            MM_WAVE_MAPPER                    : Result.Product := 'Wave Mapper';
            MM_SNDBLST_MIDIOUT                : Result.Product := 'Sound Blaster MIDI output port';
            MM_SNDBLST_MIDIIN                 : Result.Product := 'Sound Blaster MIDI input port';
            MM_SNDBLST_SYNTH                  : Result.Product := 'Sound Blaster internal synth';
            MM_SNDBLST_WAVEOUT                : Result.Product := 'Sound Blaster waveform output';
            MM_SNDBLST_WAVEIN                 : Result.Product := 'Sound Blaster waveform input';
            MM_ADLIB                          : Result.Product := 'Ad Lib Compatible synth';
            MM_MPU401_MIDIOUT                 : Result.Product := 'MPU 401 compatible MIDI output port';
            MM_MPU401_MIDIIN                  : Result.Product := 'MPU 401 compatible MIDI input port';
            MM_PC_JOYSTICK                    : Result.Product := 'Joystick adapter';
            MM_PCSPEAKER_WAVEOUT              : Result.Product := 'PC speaker waveform output';
            MM_MSFT_WSS_WAVEIN                : Result.Product := 'MS Audio Board waveform input';
            MM_MSFT_WSS_WAVEOUT               : Result.Product := 'MS Audio Board waveform output';
            MM_MSFT_WSS_FMSYNTH_STEREO        : Result.Product := 'MS Audio Board  Stereo FM synth';
            MM_MSFT_WSS_MIXER                 : Result.Product := 'MS Audio Board Mixer Driver';
            MM_MSFT_WSS_OEM_WAVEIN            : Result.Product := 'MS OEM Audio Board waveform input';
            MM_MSFT_WSS_OEM_WAVEOUT           : Result.Product := 'MS OEM Audio Board waveform output';
            MM_MSFT_WSS_OEM_FMSYNTH_STEREO    : Result.Product := 'MS OEM Audio Board Stereo FM Synth';
            MM_MSFT_WSS_AUX                   : Result.Product := 'MS Audio Board Aux. Port';
            MM_MSFT_WSS_OEM_AUX               : Result.Product := 'MS OEM Audio Aux Port';
            MM_MSFT_GENERIC_WAVEIN            : Result.Product := 'MS Vanilla driver waveform input';
            MM_MSFT_GENERIC_WAVEOUT           : Result.Product := 'MS Vanilla driver wavefrom output';
            MM_MSFT_GENERIC_MIDIIN            : Result.Product := 'MS Vanilla driver MIDI in';
            MM_MSFT_GENERIC_MIDIOUT           : Result.Product := 'MS Vanilla driver MIDI  external out';
            MM_MSFT_GENERIC_MIDISYNTH         : Result.Product := 'MS Vanilla driver MIDI synthesizer';
            MM_MSFT_GENERIC_AUX_LINE          : Result.Product := 'MS Vanilla driver aux (line in)';
            MM_MSFT_GENERIC_AUX_MIC           : Result.Product := 'MS Vanilla driver aux (mic)';
            MM_MSFT_GENERIC_AUX_CD            : Result.Product := 'MS Vanilla driver aux (CD)';
            MM_MSFT_WSS_OEM_MIXER             : Result.Product := 'MS OEM Audio Board Mixer Driver';
            MM_MSFT_MSACM                     : Result.Product := 'MS Audio Compression Manager';
            MM_MSFT_ACM_MSADPCM               : Result.Product := 'MS ADPCM Codec';
            MM_MSFT_ACM_IMAADPCM              : Result.Product := 'IMA ADPCM Codec';
            MM_MSFT_ACM_MSFILTER              : Result.Product := 'MS Filter';
            MM_MSFT_ACM_GSM610                : Result.Product := 'GSM 610 codec';
            MM_MSFT_ACM_G711                  : Result.Product := 'G.711 codec';
            MM_MSFT_ACM_PCM                   : Result.Product := 'PCM converter';
            MM_WSS_SB16_WAVEIN                : Result.Product := 'Sound Blaster 16 waveform input';
            MM_WSS_SB16_WAVEOUT               : Result.Product := 'Sound Blaster 16  waveform output';
            MM_WSS_SB16_MIDIIN                : Result.Product := 'Sound Blaster 16 midi-in';
            MM_WSS_SB16_MIDIOUT               : Result.Product := 'Sound Blaster 16 midi out';
            MM_WSS_SB16_SYNTH                 : Result.Product := 'Sound Blaster 16 FM Synthesis';
            MM_WSS_SB16_AUX_LINE              : Result.Product := 'Sound Blaster 16 aux (line in)';
            MM_WSS_SB16_AUX_CD                : Result.Product := 'Sound Blaster 16 aux (CD)';
            MM_WSS_SB16_MIXER                 : Result.Product := 'Sound Blaster 16 mixer device';
            MM_WSS_SBPRO_WAVEIN               : Result.Product := 'Sound Blaster Pro waveform input';
            MM_WSS_SBPRO_WAVEOUT              : Result.Product := 'Sound Blaster Pro waveform output';
            MM_WSS_SBPRO_MIDIIN               : Result.Product := 'Sound Blaster Pro midi in';
            MM_WSS_SBPRO_MIDIOUT              : Result.Product := 'Sound Blaster Pro midi out';
            MM_WSS_SBPRO_SYNTH                : Result.Product := 'Sound Blaster Pro FM synthesis';
            MM_WSS_SBPRO_AUX_LINE             : Result.Product := 'Sound Blaster Pro aux (line in )';
            MM_WSS_SBPRO_AUX_CD               : Result.Product := 'Sound Blaster Pro aux (CD)';
            MM_WSS_SBPRO_MIXER                : Result.Product := 'Sound Blaster Pro mixer';
            MM_MSFT_WSS_NT_WAVEIN             : Result.Product := 'WSS NT wave in';
            MM_MSFT_WSS_NT_WAVEOUT            : Result.Product := 'WSS NT wave out';
            MM_MSFT_WSS_NT_FMSYNTH_STEREO     : Result.Product := 'WSS NT FM synth';
            MM_MSFT_WSS_NT_MIXER              : Result.Product := 'WSS NT mixer';
            MM_MSFT_WSS_NT_AUX                : Result.Product := 'WSS NT aux';
            MM_MSFT_SB16_WAVEIN               : Result.Product := 'Sound Blaster 16 waveform input';
            MM_MSFT_SB16_WAVEOUT              : Result.Product := 'Sound Blaster 16  waveform output';
            MM_MSFT_SB16_MIDIIN               : Result.Product := 'Sound Blaster 16 midi-in';
            MM_MSFT_SB16_MIDIOUT              : Result.Product := 'Sound Blaster 16 midi out';
            MM_MSFT_SB16_SYNTH                : Result.Product := 'Sound Blaster 16 FM Synthesis';
            MM_MSFT_SB16_AUX_LINE             : Result.Product := 'Sound Blaster 16 aux (line in)';
            MM_MSFT_SB16_AUX_CD               : Result.Product := 'Sound Blaster 16 aux (CD)';
            MM_MSFT_SB16_MIXER                : Result.Product := 'Sound Blaster 16 mixer device';
            MM_MSFT_SBPRO_WAVEIN              : Result.Product := 'Sound Blaster Pro waveform input';
            MM_MSFT_SBPRO_WAVEOUT             : Result.Product := 'Sound Blaster Pro waveform output';
            MM_MSFT_SBPRO_MIDIIN              : Result.Product := 'Sound Blaster Pro midi in';
            MM_MSFT_SBPRO_MIDIOUT             : Result.Product := 'Sound Blaster Pro midi out';
            MM_MSFT_SBPRO_SYNTH               : Result.Product := 'Sound Blaster Pro FM synthesis';
            MM_MSFT_SBPRO_AUX_LINE            : Result.Product := 'Sound Blaster Pro aux (line in)';
            MM_MSFT_SBPRO_AUX_CD              : Result.Product := 'Sound Blaster Pro aux (CD)';
            MM_MSFT_SBPRO_MIXER               : Result.Product := 'Sound Blaster Pro mixer';
            MM_MSFT_MSOPL_SYNTH               : Result.Product := 'Yamaha OPL2/OPL3 compatible FM synthesis';
            MM_MSFT_VMDMS_LINE_WAVEIN         : Result.Product := 'Voice Modem Serial Line Wave Input';
            MM_MSFT_VMDMS_LINE_WAVEOUT        : Result.Product := 'Voice Modem Serial Line Wave Output';
            MM_MSFT_VMDMS_HANDSET_WAVEIN      : Result.Product := 'Voice Modem Serial Handset Wave Input';
            MM_MSFT_VMDMS_HANDSET_WAVEOUT     : Result.Product := 'Voice Modem Serial Handset Wave Output';
            MM_MSFT_VMDMW_LINE_WAVEIN         : Result.Product := 'Voice Modem Wrapper Line Wave Input';
            MM_MSFT_VMDMW_LINE_WAVEOUT        : Result.Product := 'Voice Modem Wrapper Line Wave Output';
            MM_MSFT_VMDMW_HANDSET_WAVEIN      : Result.Product := 'Voice Modem Wrapper Handset Wave Input';
            MM_MSFT_VMDMW_HANDSET_WAVEOUT     : Result.Product := 'Voice Modem Wrapper Handset Wave Output';
            MM_MSFT_VMDMW_MIXER               : Result.Product := 'Voice Modem Wrapper Mixer';
            MM_MSFT_VMDM_GAME_WAVEOUT         : Result.Product := 'Voice Modem Game Compatible Wave Device';
            MM_MSFT_VMDM_GAME_WAVEIN          : Result.Product := 'Voice Modem Game Compatible Wave Device';
            MM_MSFT_ACM_MSNAUDIO              : Result.Product := 'ACM_MSNAUDIO';
            MM_MSFT_ACM_MSG723                : Result.Product := 'ACM_MSG723';
            MM_MSFT_ACM_MSRT24                : Result.Product := 'ACM_MSRT24';
            MM_MSFT_WDMAUDIO_WAVEOUT          : Result.Product := 'Generic id for WDM Audio drivers';
            MM_MSFT_WDMAUDIO_WAVEIN           : Result.Product := 'Generic id for WDM Audio drivers';
            MM_MSFT_WDMAUDIO_MIDIOUT          : Result.Product := 'Generic id for WDM Audio drivers';
            MM_MSFT_WDMAUDIO_MIDIIN           : Result.Product := 'Generic id for WDM Audio drivers';
            MM_MSFT_WDMAUDIO_MIXER            : Result.Product := 'Generic id for WDM Audio drivers';
            MM_MSFT_WDMAUDIO_AUX              : Result.Product := 'Generic id for WDM Audio drivers';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CREATIVE                  :
        begin
            Result.Manufacturer := 'Creative Labs, Inc.';
            case AMixerCaps.wPid of
            MM_CREATIVE_SB15_WAVEIN           : Result.Product := 'SB (r) 1.5 waveform input';
            MM_CREATIVE_SB20_WAVEIN           : Result.Product := 'SB20_WAVEIN';
            MM_CREATIVE_SBPRO_WAVEIN          : Result.Product := 'SBPRO_WAVEIN';
            MM_CREATIVE_SBP16_WAVEIN          : Result.Product := 'SBP16_WAVEIN';
            MM_CREATIVE_PHNBLST_WAVEIN        : Result.Product := 'PHNBLST_WAVEIN';
            MM_CREATIVE_SB15_WAVEOUT          : Result.Product := 'SB15_WAVEOUT';
            MM_CREATIVE_SB20_WAVEOUT          : Result.Product := 'SB20_WAVEOUT';
            MM_CREATIVE_SBPRO_WAVEOUT         : Result.Product := 'SBPRO_WAVEOUT';
            MM_CREATIVE_SBP16_WAVEOUT         : Result.Product := 'SBP16_WAVEOUT';
            MM_CREATIVE_PHNBLST_WAVEOUT       : Result.Product := 'PHNBLST_WAVEOUT';
            MM_CREATIVE_MIDIOUT               : Result.Product := 'SB (r)';
            MM_CREATIVE_MIDIIN                : Result.Product := 'SB (r)';
            MM_CREATIVE_FMSYNTH_MONO          : Result.Product := 'SB (r)';
            MM_CREATIVE_FMSYNTH_STEREO        : Result.Product := 'SB Pro (r) stereo synthesizer';
            MM_CREATIVE_MIDI_AWE32            : Result.Product := 'MIDI_AWE32';
            MM_CREATIVE_AUX_CD                : Result.Product := 'SB Pro (r) aux (CD)';
            MM_CREATIVE_AUX_LINE              : Result.Product := 'SB Pro (r) aux (Line in )';
            MM_CREATIVE_AUX_MIC               : Result.Product := 'SB Pro (r) aux (mic)';
            MM_CREATIVE_AUX_MASTER            : Result.Product := 'AUX_MASTER';
            MM_CREATIVE_AUX_PCSPK             : Result.Product := 'AUX_PCSPK';
            MM_CREATIVE_AUX_WAVE              : Result.Product := 'AUX_WAVE';
            MM_CREATIVE_AUX_MIDI              : Result.Product := 'AUX_MIDI';
            MM_CREATIVE_SBPRO_MIXER           : Result.Product := 'SBPRO_MIXER';
            MM_CREATIVE_SB16_MIXER            : Result.Product := 'SB16_MIXER';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MEDIAVISION               :
        begin
            Result.Manufacturer := 'Media Vision, Inc.';
            case AMixerCaps.wPid of
            MM_MEDIAVISION_PROAUDIO           : Result.Product := 'Pro Audio Spectrum';
            MM_PROAUD_MIDIOUT                 : Result.Product := 'Pro Audio Spectrum MIDIOUT';
            MM_PROAUD_MIDIIN                  : Result.Product := 'Pro Audio Spectrum MIDIIN ';
            MM_PROAUD_SYNTH                   : Result.Product := 'Pro Audio Spectrum SYNTH  ';
            MM_PROAUD_WAVEOUT                 : Result.Product := 'Pro Audio Spectrum WAVEOUT';
            MM_PROAUD_WAVEIN                  : Result.Product := 'Pro Audio Spectrum WAVEIN ';
            MM_PROAUD_MIXER                   : Result.Product := 'Pro Audio Spectrum MIXER  ';
            MM_PROAUD_AUX                     : Result.Product := 'Pro Audio Spectrum AUX    ';

            MM_MEDIAVISION_THUNDER            : Result.Product := 'Thunder Board';
            MM_THUNDER_SYNTH                  : Result.Product := 'Thunder Board SYNTH      ';
            MM_THUNDER_WAVEOUT                : Result.Product := 'Thunder Board WAVEOUT    ';
            MM_THUNDER_WAVEIN                 : Result.Product := 'Thunder Board WAVEIN     ';
            MM_THUNDER_AUX                    : Result.Product := 'Thunder Board AUX        ';

            MM_MEDIAVISION_TPORT              : Result.Product := 'Audio Port';
            MM_TPORT_WAVEOUT                  : Result.Product := 'Audio Port WAVEOUT    ';
            MM_TPORT_WAVEIN                   : Result.Product := 'Audio Port WAVEIN     ';
            MM_TPORT_SYNTH                    : Result.Product := 'Audio Port SYNTH      ';

            MM_MEDIAVISION_PROAUDIO_PLUS      : Result.Product := 'Pro Audio Spectrum Plus';
            MM_PROAUD_PLUS_MIDIOUT            : Result.Product := 'Pro Audio Spectrum Plus MIDIOUT';
            MM_PROAUD_PLUS_MIDIIN             : Result.Product := 'Pro Audio Spectrum Plus MIDIIN ';
            MM_PROAUD_PLUS_SYNTH              : Result.Product := 'Pro Audio Spectrum Plus SYNTH  ';
            MM_PROAUD_PLUS_WAVEOUT            : Result.Product := 'Pro Audio Spectrum Plus WAVEOUT';
            MM_PROAUD_PLUS_WAVEIN             : Result.Product := 'Pro Audio Spectrum Plus WAVEIN ';
            MM_PROAUD_PLUS_MIXER              : Result.Product := 'Pro Audio Spectrum Plus MIXER  ';
            MM_PROAUD_PLUS_AUX                : Result.Product := 'Pro Audio Spectrum Plus AUX    ';

            MM_MEDIAVISION_PROAUDIO_16        : Result.Product := 'Pro Audio Spectrum 16';
            MM_PROAUD_16_MIDIOUT              : Result.Product := 'Pro Audio Spectrum 16 MIDIOUT';
            MM_PROAUD_16_MIDIIN               : Result.Product := 'Pro Audio Spectrum 16 MIDIIN ';
            MM_PROAUD_16_SYNTH                : Result.Product := 'Pro Audio Spectrum 16 SYNTH  ';
            MM_PROAUD_16_WAVEOUT              : Result.Product := 'Pro Audio Spectrum 16 WAVEOUT';
            MM_PROAUD_16_WAVEIN               : Result.Product := 'Pro Audio Spectrum 16 WAVEIN ';
            MM_PROAUD_16_MIXER                : Result.Product := 'Pro Audio Spectrum 16 MIXER  ';
            MM_PROAUD_16_AUX                  : Result.Product := 'Pro Audio Spectrum 16 AUX    ';

            MM_MEDIAVISION_CDPC               : Result.Product := 'CDPC';
            MM_CDPC_MIDIOUT                   : Result.Product := 'CDPC_MIDIOUT';
            MM_CDPC_MIDIIN                    : Result.Product := 'CDPC_MIDIIN ';
            MM_CDPC_SYNTH                     : Result.Product := 'CDPC_SYNTH  ';
            MM_CDPC_WAVEOUT                   : Result.Product := 'CDPC_WAVEOUT';
            MM_CDPC_WAVEIN                    : Result.Product := 'CDPC_WAVEIN ';
            MM_CDPC_MIXER                     : Result.Product := 'CDPC_MIXER  ';
            MM_CDPC_AUX                       : Result.Product := 'CDPC_AUX    ';

            MM_MEDIAVISION_OPUS1208           : Result.Product := 'Opus MV 1208 Chipsent';
            MM_OPUS401_MIDIOUT                : Result.Product := 'Opus MV 1208 Chipsent OPUS401_MIDIOUT ';
            MM_OPUS401_MIDIIN                 : Result.Product := 'Opus MV 1208 Chipsent OPUS401_MIDIIN  ';
            MM_OPUS1208_SYNTH                 : Result.Product := 'Opus MV 1208 Chipsent SYNTH  ';
            MM_OPUS1208_WAVEOUT               : Result.Product := 'Opus MV 1208 Chipsent WAVEOUT';
            MM_OPUS1208_WAVEIN                : Result.Product := 'Opus MV 1208 Chipsent WAVEIN ';
            MM_OPUS1208_MIXER                 : Result.Product := 'Opus MV 1208 Chipsent MIXER  ';
            MM_OPUS1208_AUX                   : Result.Product := 'Opus MV 1208 Chipsent AUX    ';

            MM_MEDIAVISION_OPUS1216           : Result.Product := 'Opus MV 1216 chipset ';
            MM_OPUS1216_MIDIOUT               : Result.Product := 'Opus MV 1216 chipset MIDIOUT';
            MM_OPUS1216_MIDIIN                : Result.Product := 'Opus MV 1216 chipset MIDIIN ';
            MM_OPUS1216_SYNTH                 : Result.Product := 'Opus MV 1216 chipset SYNTH  ';
            MM_OPUS1216_WAVEOUT               : Result.Product := 'Opus MV 1216 chipset WAVEOUT';
            MM_OPUS1216_WAVEIN                : Result.Product := 'Opus MV 1216 chipset WAVEIN ';
            MM_OPUS1216_MIXER                 : Result.Product := 'Opus MV 1216 chipset MIXER  ';
            MM_OPUS1216_AUX                   : Result.Product := 'Opus MV 1216 chipset AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_FUJITSU                   :
        begin
            Result.Manufacturer := 'Fujitsu Corp.';
            Result.Product := 'Unmapped Product';
        end;
        MM_PRAGMATRAX                :
        begin
            Result.Manufacturer := 'PRAGMATRAX Software';
            Result.Product := 'Unmapped Product';
        end;
        MM_CYRIX                     :
        begin
            Result.Manufacturer := 'Cyrix Corporation';
            case AMixerCaps.wPid of
            MM_CYRIX_XASYNTH                  :Result.Product := 'XASYNTH  ';
            MM_CYRIX_XAMIDIIN                 :Result.Product := 'XAMIDIIN ';
            MM_CYRIX_XAMIDIOUT                :Result.Product := 'XAMIDIOUT';
            MM_CYRIX_XAWAVEIN                 :Result.Product := 'XAWAVEIN ';
            MM_CYRIX_XAWAVEOUT                :Result.Product := 'XAWAVEOUT';
            MM_CYRIX_XAAUX                    :Result.Product := 'XAAUX    ';
            MM_CYRIX_XAMIXER                  :Result.Product := 'XAMIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_PHILIPS_SPEECH_PROCESSING :
        begin
            Result.Manufacturer := 'Philips Speech Processing';
            case AMixerCaps.wPid of
            MM_PHILIPS_ACM_LPCBB              :Result.Product := 'ACM_LPCBB';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NETXL                     :
        begin
            Result.Manufacturer := 'NetXL, Inc.';
            case AMixerCaps.wPid of
            MM_NETXL_XLVIDEO                  :Result.Product := 'XLVIDEO';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ZYXEL                     :
        begin
            Result.Manufacturer := 'ZyXEL Communications, Inc.';
            case AMixerCaps.wPid of
            MM_ZYXEL_ACM_ADPCM                :Result.Product := 'ACM_ADPCM';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_BECUBED                   :
        begin
            Result.Manufacturer := 'BeCubed Software Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_AARDVARK                  :
        begin
            Result.Manufacturer := 'Aardvark Computer Systems, Inc.';
            case AMixerCaps.wPid of
            MM_AARDVARK_STUDIO12_WAVEOUT      :Result.Product := 'STUDIO12_WAVEOUT';
            MM_AARDVARK_STUDIO12_WAVEIN       :Result.Product := 'STUDIO12_WAVEIN ';
            MM_AARDVARK_STUDIO88_WAVEOUT      :Result.Product := 'STUDIO88_WAVEOUT';
            MM_AARDVARK_STUDIO88_WAVEIN       :Result.Product := 'STUDIO88_WAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_BINTEC                    :
        begin
            Result.Manufacturer := 'Bin Tec Communications GmbH';
            case AMixerCaps.wPid of
            MM_BINTEC_TAPI_WAVE               :Result.Product := 'TAPI_WAVE';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_HEWLETT_PACKARD           :
        begin
            Result.Manufacturer := 'Hewlett-Packard Company';
            case AMixerCaps.wPid of
            MM_HEWLETT_PACKARD_CU_CODEC       :Result.Product := 'CU_CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ACULAB                    :
        begin
            Result.Manufacturer := 'Aculab plc';
            Result.Product := 'Unmapped Product';
        end;
        MM_FAITH                     :
        begin
            Result.Manufacturer := 'Faith,Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_MITEL                     :
        begin
            Result.Manufacturer := 'Mitel Corporation';
            case AMixerCaps.wPid of
            MM_MITEL_TALKTO_LINE_WAVEOUT      :Result.Product := 'TALKTO_LINE_WAVEOUT   ';
            MM_MITEL_TALKTO_LINE_WAVEIN       :Result.Product := 'TALKTO_LINE_WAVEIN    ';
            MM_MITEL_TALKTO_HANDSET_WAVEOUT   :Result.Product := 'TALKTO_HANDSET_WAVEOUT';
            MM_MITEL_TALKTO_HANDSET_WAVEIN    :Result.Product := 'TALKTO_HANDSET_WAVEIN ';
            MM_MITEL_TALKTO_BRIDGED_WAVEOUT   :Result.Product := 'TALKTO_BRIDGED_WAVEOUT';
            MM_MITEL_TALKTO_BRIDGED_WAVEIN    :Result.Product := 'TALKTO_BRIDGED_WAVEIN ';
            MM_MITEL_MPA_HANDSET_WAVEOUT      :Result.Product := 'MPA_HANDSET_WAVEOUT   ';
            MM_MITEL_MPA_HANDSET_WAVEIN       :Result.Product := 'MPA_HANDSET_WAVEIN    ';
            MM_MITEL_MPA_HANDSFREE_WAVEOUT    :Result.Product := 'MPA_HANDSFREE_WAVEOUT ';
            MM_MITEL_MPA_HANDSFREE_WAVEIN     :Result.Product := 'MPA_HANDSFREE_WAVEIN  ';
            MM_MITEL_MPA_LINE1_WAVEOUT        :Result.Product := 'MPA_LINE1_WAVEOUT     ';
            MM_MITEL_MPA_LINE1_WAVEIN         :Result.Product := 'MPA_LINE1_WAVEIN      ';
            MM_MITEL_MPA_LINE2_WAVEOUT        :Result.Product := 'MPA_LINE2_WAVEOUT     ';
            MM_MITEL_MPA_LINE2_WAVEIN         :Result.Product := 'MPA_LINE2_WAVEIN      ';
            MM_MITEL_MEDIAPATH_WAVEOUT        :Result.Product := 'MEDIAPATH_WAVEOUT     ';
            MM_MITEL_MEDIAPATH_WAVEIN         :Result.Product := 'MEDIAPATH_WAVEIN      ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QUANTUM3D                 :
        begin
            Result.Manufacturer := 'Quantum3D, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SNI                       :
        begin
            Result.Manufacturer := 'Siemens-Nixdorf';
            case AMixerCaps.wPid of
            MM_SNI_ACM_G721                   :Result.Product := 'ACM_G721';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_EMU                       :
        begin
            Result.Manufacturer := 'E-mu Systems, Inc.';
            case AMixerCaps.wPid of
            MM_EMU_APSSYNTH                   :Result.Product := 'APSSYNTH  ';
            MM_EMU_APSMIDIIN                  :Result.Product := 'APSMIDIIN ';
            MM_EMU_APSMIDIOUT                 :Result.Product := 'APSMIDIOUT';
            MM_EMU_APSWAVEIN                  :Result.Product := 'APSWAVEIN ';
            MM_EMU_APSWAVEOUT                 :Result.Product := 'APSWAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ARTISOFT                  :
        begin
            Result.Manufacturer := 'Artisoft, Inc.';
            case AMixerCaps.wPid of
            MM_ARTISOFT_SBWAVEIN              :Result.Product := 'Artisoft sounding Board waveform input';
            MM_ARTISOFT_SBWAVEOUT             :Result.Product := 'Artisoft sounding Board waveform output';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TURTLE_BEACH              :
        begin
            Result.Manufacturer := 'Turtle Beach, Inc.';
            case AMixerCaps.wPid of
            MM_TBS_TROPEZ_WAVEIN              :Result.Product := 'TROPEZ_WAVEIN ';
            MM_TBS_TROPEZ_WAVEOUT             :Result.Product := 'TROPEZ_WAVEOUT';
            MM_TBS_TROPEZ_AUX1                :Result.Product := 'TROPEZ_AUX1   ';
            MM_TBS_TROPEZ_AUX2                :Result.Product := 'TROPEZ_AUX2   ';
            MM_TBS_TROPEZ_LINE                :Result.Product := 'TROPEZ_LINE   ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_IBM                       :
        begin
            Result.Manufacturer := 'IBM Corporation';
            case AMixerCaps.wPid of
            MM_MMOTION_WAVEAUX                :Result.Product := 'IBM M-Motion Auxiliary Device';
            MM_MMOTION_WAVEOUT                :Result.Product := 'IBM M-Motion Waveform output';
            MM_MMOTION_WAVEIN                 :Result.Product := 'IBM M-Motion  Waveform Input';
            MM_IBM_PCMCIA_WAVEIN              :Result.Product := 'IBM waveform input';
            MM_IBM_PCMCIA_WAVEOUT             :Result.Product := 'IBM Waveform output';
            MM_IBM_PCMCIA_SYNTH               :Result.Product := 'IBM Midi Synthesis';
            MM_IBM_PCMCIA_MIDIIN              :Result.Product := 'IBM external MIDI in';
            MM_IBM_PCMCIA_MIDIOUT             :Result.Product := 'IBM external MIDI out';
            MM_IBM_PCMCIA_AUX                 :Result.Product := 'IBM auxiliary control';
            MM_IBM_THINKPAD200                :Result.Product := 'THINKPAD200  ';
            MM_IBM_MWAVE_WAVEIN               :Result.Product := 'MWAVE_WAVEIN ';
            MM_IBM_MWAVE_WAVEOUT              :Result.Product := 'MWAVE_WAVEOUT';
            MM_IBM_MWAVE_MIXER                :Result.Product := 'MWAVE_MIXER  ';
            MM_IBM_MWAVE_MIDIIN               :Result.Product := 'MWAVE_MIDIIN ';
            MM_IBM_MWAVE_MIDIOUT              :Result.Product := 'MWAVE_MIDIOUT';
            MM_IBM_MWAVE_AUX                  :Result.Product := 'MWAVE_AUX    ';
            MM_IBM_WC_MIDIOUT                 :Result.Product := 'WC_MIDIOUT   ';
            MM_IBM_WC_WAVEOUT                 :Result.Product := 'WC_WAVEOUT   ';
            MM_IBM_WC_MIXEROUT                :Result.Product := 'WC_MIXEROUT  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VOCALTEC                  :
        begin
            Result.Manufacturer := 'Vocaltec Ltd.';
            case AMixerCaps.wPid of
            MM_VOCALTEC_WAVEOUT               :Result.Product := 'WAVEOUT';
            MM_VOCALTEC_WAVEIN                :Result.Product := 'WAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ROLAND                    :
        begin
            Result.Manufacturer := 'Roland';
            case AMixerCaps.wPid of
            MM_ROLAND_RAP10_MIDIOUT           :Result.Product := 'MM_ROLAND_RAP10';
            MM_ROLAND_RAP10_MIDIIN            :Result.Product := 'MM_ROLAND_RAP10';
            MM_ROLAND_RAP10_SYNTH             :Result.Product := 'MM_ROLAND_RAP10';
            MM_ROLAND_RAP10_WAVEOUT           :Result.Product := 'MM_ROLAND_RAP10';
            MM_ROLAND_RAP10_WAVEIN            :Result.Product := 'MM_ROLAND_RAP10';
            MM_ROLAND_MPU401_MIDIOUT          :Result.Product := 'MPU401_MIDIOUT';
            MM_ROLAND_MPU401_MIDIIN           :Result.Product := 'MPU401_MIDIIN ';
            MM_ROLAND_SMPU_MIDIOUTA           :Result.Product := 'SMPU_MIDIOUTA ';
            MM_ROLAND_SMPU_MIDIOUTB           :Result.Product := 'SMPU_MIDIOUTB ';
            MM_ROLAND_SMPU_MIDIINA            :Result.Product := 'SMPU_MIDIINA  ';
            MM_ROLAND_SMPU_MIDIINB            :Result.Product := 'SMPU_MIDIINB  ';
            MM_ROLAND_SC7_MIDIOUT             :Result.Product := 'SC7_MIDIOUT   ';
            MM_ROLAND_SC7_MIDIIN              :Result.Product := 'SC7_MIDIIN    ';
            MM_ROLAND_SERIAL_MIDIOUT          :Result.Product := 'SERIAL_MIDIOUT';
            MM_ROLAND_SERIAL_MIDIIN           :Result.Product := 'SERIAL_MIDIIN ';
            MM_ROLAND_SCP_MIDIOUT             :Result.Product := 'SCP_MIDIOUT   ';
            MM_ROLAND_SCP_MIDIIN              :Result.Product := 'SCP_MIDIIN    ';
            MM_ROLAND_SCP_WAVEOUT             :Result.Product := 'SCP_WAVEOUT   ';
            MM_ROLAND_SCP_WAVEIN              :Result.Product := 'SCP_WAVEIN    ';
            MM_ROLAND_SCP_MIXER               :Result.Product := 'SCP_MIXER     ';
            MM_ROLAND_SCP_AUX                 :Result.Product := 'SCP_AUX       ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DSP_SOLUTIONS             :
        begin
            Result.Manufacturer := 'DSP Solutions, Inc.';
            case AMixerCaps.wPid of
            MM_DSP_SOLUTIONS_WAVEOUT          :Result.Product := 'WAVEOUT';
            MM_DSP_SOLUTIONS_WAVEIN           :Result.Product := 'WAVEIN ';
            MM_DSP_SOLUTIONS_SYNTH            :Result.Product := 'SYNTH  ';
            MM_DSP_SOLUTIONS_AUX              :Result.Product := 'AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NEC                       :
        begin
            Result.Manufacturer := 'NEC';
            case AMixerCaps.wPid of
            MM_NEC_73_86_SYNTH                :Result.Product := '73_86_SYNTH   ';
            MM_NEC_73_86_WAVEOUT              :Result.Product := '73_86_WAVEOUT ';
            MM_NEC_73_86_WAVEIN               :Result.Product := '73_86_WAVEIN  ';
            MM_NEC_26_SYNTH                   :Result.Product := '26_SYNTH      ';
            MM_NEC_MPU401_MIDIOUT             :Result.Product := 'MPU401_MIDIOUT';
            MM_NEC_MPU401_MIDIIN              :Result.Product := 'MPU401_MIDIIN ';
            MM_NEC_JOYSTICK                   :Result.Product := 'JOYSTICK      ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ATI                       :
        begin
            Result.Manufacturer := 'ATI Technologies Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_WANGLABS                  :
        begin
            Result.Manufacturer := 'Wang Laboratories, Inc.';
            case AMixerCaps.wPid of
            MM_WANGLABS_WAVEIN1               :Result.Product := 'Input audio wave on CPU board models: Exec 4010, 4030, 3450; PC 251/25c, pc 461/25s , pc 461/33c';
            MM_WANGLABS_WAVEOUT1              :Result.Product := 'WAVEOUT1';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TANDY                     :
        begin
            Result.Manufacturer := 'Tandy Corporation';
            case AMixerCaps.wPid of
            MM_TANDY_VISWAVEIN                :Result.Product := 'VISWAVEIN      ';
            MM_TANDY_VISWAVEOUT               :Result.Product := 'VISWAVEOUT     ';
            MM_TANDY_VISBIOSSYNTH             :Result.Product := 'VISBIOSSYNTH   ';
            MM_TANDY_SENS_MMAWAVEIN           :Result.Product := 'SENS_MMAWAVEIN ';
            MM_TANDY_SENS_MMAWAVEOUT          :Result.Product := 'SENS_MMAWAVEOUT';
            MM_TANDY_SENS_MMAMIDIIN           :Result.Product := 'SENS_MMAMIDIIN ';
            MM_TANDY_SENS_MMAMIDIOUT          :Result.Product := 'SENS_MMAMIDIOUT';
            MM_TANDY_SENS_VISWAVEOUT          :Result.Product := 'SENS_VISWAVEOUT';
            MM_TANDY_PSSJWAVEIN               :Result.Product := 'PSSJWAVEIN     ';
            MM_TANDY_PSSJWAVEOUT              :Result.Product := 'PSSJWAVEOUT    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VOYETRA                   :
        begin
            Result.Manufacturer := 'Voyetra';
            Result.Product := 'Unmapped Product';
        end;
        MM_ANTEX                     :
        begin
            Result.Manufacturer := 'Antex Electronics Corporation';
            case AMixerCaps.wPid of
            MM_ANTEX_SX12_WAVEIN              :Result.Product := 'SX12_WAVEIN         ';
            MM_ANTEX_SX12_WAVEOUT             :Result.Product := 'SX12_WAVEOUT        ';
            MM_ANTEX_SX15_WAVEIN              :Result.Product := 'SX15_WAVEIN         ';
            MM_ANTEX_SX15_WAVEOUT             :Result.Product := 'SX15_WAVEOUT        ';
            MM_ANTEX_VP625_WAVEIN             :Result.Product := 'VP625_WAVEIN        ';
            MM_ANTEX_VP625_WAVEOUT            :Result.Product := 'VP625_WAVEOUT       ';
            MM_ANTEX_AUDIOPORT22_WAVEIN       :Result.Product := 'AUDIOPORT22_WAVEIN  ';
            MM_ANTEX_AUDIOPORT22_WAVEOUT      :Result.Product := 'AUDIOPORT22_WAVEOUT ';
            MM_ANTEX_AUDIOPORT22_FEEDTHRU     :Result.Product := 'AUDIOPORT22_FEEDTHRU';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ICL_PS                    :
        begin
            Result.Manufacturer := 'ICL Personal Systems';
            Result.Product := 'Unmapped Product';
        end;
        MM_INTEL                     :
        begin
            Result.Manufacturer := 'Intel Corporation';
            case AMixerCaps.wPid of
            MM_INTELOPD_WAVEIN                :Result.Product := 'HID2 WaveAudio Driver';
            MM_INTELOPD_WAVEOUT               :Result.Product := 'HID2';
            MM_INTELOPD_AUX                   :Result.Product := 'HID2 for mixing';
            MM_INTEL_NSPMODEMLINEIN           :Result.Product := 'NSPMODEMLINEIN ';
            MM_INTEL_NSPMODEMLINEOUT          :Result.Product := 'NSPMODEMLINEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_GRAVIS                    :
        begin
            Result.Manufacturer := 'Advanced Gravis';
            Result.Product := 'Unmapped Product';
        end;
        MM_VAL                       :
        begin
            Result.Manufacturer := 'Video Associates Labs, Inc.';
            case AMixerCaps.wPid of
            MM_VAL_MICROKEY_AP_WAVEIN         :Result.Product := 'MICROKEY_AP_WAVEIN ';
            MM_VAL_MICROKEY_AP_WAVEOUT        :Result.Product := 'MICROKEY_AP_WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_INTERACTIVE               :
        begin
            Result.Manufacturer := 'InterActive Inc.';
            case AMixerCaps.wPid of
            MM_INTERACTIVE_WAVEIN             : Result.Product := 'WAVEIN/OUT';
            //MM_INTERACTIVE_WAVEOUT            : Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_YAMAHA                    :
        begin
            Result.Manufacturer := 'Yamaha Corporation of America';
            case AMixerCaps.wPid of
            MM_YAMAHA_GSS_SYNTH               : Result.Product := 'GSS_SYNTH        ';
            MM_YAMAHA_GSS_WAVEOUT             : Result.Product := 'GSS_WAVEOUT      ';
            MM_YAMAHA_GSS_WAVEIN              : Result.Product := 'GSS_WAVEIN       ';
            MM_YAMAHA_GSS_MIDIOUT             : Result.Product := 'GSS_MIDIOUT      ';
            MM_YAMAHA_GSS_MIDIIN              : Result.Product := 'GSS_MIDIIN       ';
            MM_YAMAHA_GSS_AUX                 : Result.Product := 'GSS_AUX          ';
            MM_YAMAHA_SERIAL_MIDIOUT          : Result.Product := 'SERIAL_MIDIOUT   ';
            MM_YAMAHA_SERIAL_MIDIIN           : Result.Product := 'SERIAL_MIDIIN    ';
            MM_YAMAHA_OPL3SA_WAVEOUT          : Result.Product := 'OPL3SA_WAVEOUT   ';
            MM_YAMAHA_OPL3SA_WAVEIN           : Result.Product := 'OPL3SA_WAVEIN    ';
            MM_YAMAHA_OPL3SA_FMSYNTH          : Result.Product := 'OPL3SA_FMSYNTH   ';
            MM_YAMAHA_OPL3SA_YSYNTH           : Result.Product := 'OPL3SA_YSYNTH    ';
            MM_YAMAHA_OPL3SA_MIDIOUT          : Result.Product := 'OPL3SA_MIDIOUT   ';
            MM_YAMAHA_OPL3SA_MIDIIN           : Result.Product := 'OPL3SA_MIDIIN    ';
            MM_YAMAHA_OPL3SA_MIXER            : Result.Product := 'OPL3SA_MIXER     ';
            MM_YAMAHA_OPL3SA_JOYSTICK         : Result.Product := 'OPL3SA_JOYSTICK  ';
            MM_YAMAHA_YMF724LEG_MIDIOUT       : Result.Product := 'YMF724LEG_MIDIOUT';
            MM_YAMAHA_YMF724LEG_MIDIIN        : Result.Product := 'YMF724LEG_MIDIIN ';
            MM_YAMAHA_YMF724_WAVEOUT          : Result.Product := 'YMF724_WAVEOUT   ';
            MM_YAMAHA_YMF724_WAVEIN           : Result.Product := 'YMF724_WAVEIN    ';
            MM_YAMAHA_YMF724_MIDIOUT          : Result.Product := 'YMF724_MIDIOUT   ';
            MM_YAMAHA_YMF724_AUX              : Result.Product := 'YMF724_AUX       ';
            MM_YAMAHA_YMF724_MIXER            : Result.Product := 'YMF724_MIXER     ';
            MM_YAMAHA_YMF724LEG_FMSYNTH       : Result.Product := 'YMF724LEG_FMSYNTH';
            MM_YAMAHA_YMF724LEG_MIXER         : Result.Product := 'YMF724LEG_MIXER  ';
            MM_YAMAHA_SXG_MIDIOUT             : Result.Product := 'SXG_MIDIOUT      ';
            MM_YAMAHA_SXG_WAVEOUT             : Result.Product := 'SXG_WAVEOUT      ';
            MM_YAMAHA_SXG_MIXER               : Result.Product := 'SXG_MIXER        ';
            MM_YAMAHA_ACXG_WAVEIN             : Result.Product := 'ACXG_WAVEIN      ';
            MM_YAMAHA_ACXG_WAVEOUT            : Result.Product := 'ACXG_WAVEOUT     ';
            MM_YAMAHA_ACXG_MIDIOUT            : Result.Product := 'ACXG_MIDIOUT     ';
            MM_YAMAHA_ACXG_MIXER              : Result.Product := 'ACXG_MIXER       ';
            MM_YAMAHA_ACXG_AUX                : Result.Product := 'ACXG_AUX         ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_EVEREX                    :
        begin
            Result.Manufacturer := 'Everex Systems, Inc.';
            case AMixerCaps.wPid of
            MM_EVEREX_CARRIER                 :Result.Product := 'CARRIER';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ECHO                      :
        begin
            Result.Manufacturer := 'Echo Speech Corporation';
            case AMixerCaps.wPid of
            MM_ECHO_SYNTH                     :Result.Product := 'SYNTH  ';
            MM_ECHO_WAVEOUT                   :Result.Product := 'WAVEOUT';
            MM_ECHO_WAVEIN                    :Result.Product := 'WAVEIN ';
            MM_ECHO_MIDIOUT                   :Result.Product := 'MIDIOUT';
            MM_ECHO_MIDIIN                    :Result.Product := 'MIDIIN ';
            MM_ECHO_AUX                       :Result.Product := 'AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SIERRA                    :
        begin
            Result.Manufacturer := 'Sierra Semiconductor Corp';
            case AMixerCaps.wPid of
            MM_SIERRA_ARIA_MIDIOUT            : Result.Product := 'ARIA_MIDIOUT     ';
            MM_SIERRA_ARIA_MIDIIN             : Result.Product := 'ARIA_MIDIIN      ';
            MM_SIERRA_ARIA_SYNTH              : Result.Product := 'ARIA_SYNTH       ';
            MM_SIERRA_ARIA_WAVEOUT            : Result.Product := 'ARIA_WAVEOUT     ';
            MM_SIERRA_ARIA_WAVEIN             : Result.Product := 'ARIA_WAVEIN      ';
            MM_SIERRA_ARIA_AUX                : Result.Product := 'ARIA_AUX         ';
            MM_SIERRA_ARIA_AUX2               : Result.Product := 'ARIA_AUX2        ';
            MM_SIERRA_QUARTET_WAVEIN          : Result.Product := 'QUARTET_WAVEIN   ';
            MM_SIERRA_QUARTET_WAVEOUT         : Result.Product := 'QUARTET_WAVEOUT  ';
            MM_SIERRA_QUARTET_MIDIIN          : Result.Product := 'QUARTET_MIDIIN   ';
            MM_SIERRA_QUARTET_MIDIOUT         : Result.Product := 'QUARTET_MIDIOUT  ';
            MM_SIERRA_QUARTET_SYNTH           : Result.Product := 'QUARTET_SYNTH    ';
            MM_SIERRA_QUARTET_AUX_CD          : Result.Product := 'QUARTET_AUX_CD   ';
            MM_SIERRA_QUARTET_AUX_LINE        : Result.Product := 'QUARTET_AUX_LINE ';
            MM_SIERRA_QUARTET_AUX_MODEM       : Result.Product := 'QUARTET_AUX_MODEM';
            MM_SIERRA_QUARTET_MIXER           : Result.Product := 'QUARTET_MIXER    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CAT                       :
        begin
            Result.Manufacturer := 'Computer Aided Technologies';
            case AMixerCaps.wPid of
            MM_CAT_WAVEOUT                    :Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_APPS                      :
        begin
            Result.Manufacturer := 'APPS Software International';
            Result.Product := 'Unmapped Product';
        end;
        MM_DSP_GROUP                 :
        begin
            Result.Manufacturer := 'DSP Group, Inc.';
            case AMixerCaps.wPid of
            MM_DSP_GROUP_TRUESPEECH           :Result.Product := 'GROUP_TRUESPEECH';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MELABS                    :
        begin
            Result.Manufacturer := 'microEngineering Labs';
            case AMixerCaps.wPid of
            MM_MELABS_MIDI2GO                 :Result.Product := 'MIDI2GO';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_COMPUTER_FRIENDS          :
        begin
            Result.Manufacturer := 'Computer Friends, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_ESS                       :
        begin
            Result.Manufacturer := 'ESS Technology';
            case AMixerCaps.wPid of
            MM_ESS_AMWAVEOUT                  : Result.Product := 'AMWAVEOUT     ';
            MM_ESS_AMWAVEIN                   : Result.Product := 'AMWAVEIN      ';
            MM_ESS_AMAUX                      : Result.Product := 'AMAUX         ';
            MM_ESS_AMSYNTH                    : Result.Product := 'AMSYNTH       ';
            MM_ESS_AMMIDIOUT                  : Result.Product := 'AMMIDIOUT     ';
            MM_ESS_AMMIDIIN                   : Result.Product := 'AMMIDIIN      ';
            MM_ESS_MIXER                      : Result.Product := 'MIXER         ';
            MM_ESS_AUX_CD                     : Result.Product := 'AUX_CD        ';
            MM_ESS_MPU401_MIDIOUT             : Result.Product := 'MPU401_MIDIOUT';
            MM_ESS_MPU401_MIDIIN              : Result.Product := 'MPU401_MIDIIN';
            MM_ESS_ES488_WAVEOUT              : Result.Product := 'ES488_WAVEOUT ';
            MM_ESS_ES488_WAVEIN               : Result.Product := 'ES488_WAVEIN  ';
            MM_ESS_ES488_MIXER                : Result.Product := 'ES488_MIXER   ';
            MM_ESS_ES688_WAVEOUT              : Result.Product := 'ES688_WAVEOUT ';
            MM_ESS_ES688_WAVEIN               : Result.Product := 'ES688_WAVEIN  ';
            MM_ESS_ES688_MIXER                : Result.Product := 'ES688_MIXER   ';
            MM_ESS_ES1488_WAVEOUT             : Result.Product := 'ES1488_WAVEOUT';
            MM_ESS_ES1488_WAVEIN              : Result.Product := 'ES1488_WAVEIN ';
            MM_ESS_ES1488_MIXER               : Result.Product := 'ES1488_MIXER  ';
            MM_ESS_ES1688_WAVEOUT             : Result.Product := 'ES1688_WAVEOUT';
            MM_ESS_ES1688_WAVEIN              : Result.Product := 'ES1688_WAVEIN ';
            MM_ESS_ES1688_MIXER               : Result.Product := 'ES1688_MIXER  ';
            MM_ESS_ES1788_WAVEOUT             : Result.Product := 'ES1788_WAVEOUT';
            MM_ESS_ES1788_WAVEIN              : Result.Product := 'ES1788_WAVEIN ';
            MM_ESS_ES1788_MIXER               : Result.Product := 'ES1788_MIXER  ';
            MM_ESS_ES1888_WAVEOUT             : Result.Product := 'ES1888_WAVEOUT';
            MM_ESS_ES1888_WAVEIN              : Result.Product := 'ES1888_WAVEIN ';
            MM_ESS_ES1888_MIXER               : Result.Product := 'ES1888_MIXER  ';
            MM_ESS_ES1868_WAVEOUT             : Result.Product := 'ES1868_WAVEOUT';
            MM_ESS_ES1868_WAVEIN              : Result.Product := 'ES1868_WAVEIN ';
            MM_ESS_ES1868_MIXER               : Result.Product := 'ES1868_MIXER  ';
            MM_ESS_ES1878_WAVEOUT             : Result.Product := 'ES1878_WAVEOUT';
            MM_ESS_ES1878_WAVEIN              : Result.Product := 'ES1878_WAVEIN ';
            MM_ESS_ES1878_MIXER               : Result.Product := 'ES1878_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_AUDIOFILE                 :
        begin
            Result.Manufacturer := 'Audio, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_MOTOROLA                  :
        begin
            Result.Manufacturer := 'Motorola, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_CANOPUS                   :
        begin
            Result.Manufacturer := 'Canopus, co., Ltd.';
            case AMixerCaps.wPid of
            MM_CANOPUS_ACM_DVREX              :Result.Product := 'ACM_DVREX';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_EPSON                     :
        begin
            Result.Manufacturer := 'Seiko Epson Corporation';
            case AMixerCaps.wPid of
            MM_EPS_FMSND                      :Result.Product := 'FMSND';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TRUEVISION                :
        begin
            Result.Manufacturer := 'Truevision';
            case AMixerCaps.wPid of
            MM_TRUEVISION_WAVEIN1             :Result.Product := 'WAVEIN1 ';
            MM_TRUEVISION_WAVEOUT1            :Result.Product := 'WAVEOUT1';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_AZTECH                    :
        begin
            Result.Manufacturer := 'Aztech Labs, Inc.';
            case AMixerCaps.wPid of
            MM_AZTECH_MIDIOUT                 :Result.Product := 'MIDIOUT        ';
            MM_AZTECH_MIDIIN                  :Result.Product := 'MIDIIN         ';
            MM_AZTECH_WAVEIN                  :Result.Product := 'WAVEIN         ';
            MM_AZTECH_WAVEOUT                 :Result.Product := 'WAVEOUT        ';
            MM_AZTECH_FMSYNTH                 :Result.Product := 'FMSYNTH        ';
            MM_AZTECH_MIXER                   :Result.Product := 'MIXER          ';
            MM_AZTECH_PRO16_WAVEIN            :Result.Product := 'PRO16_WAVEIN   ';
            MM_AZTECH_PRO16_WAVEOUT           :Result.Product := 'PRO16_WAVEOUT  ';
            MM_AZTECH_PRO16_FMSYNTH           :Result.Product := 'PRO16_FMSYNTH  ';
            MM_AZTECH_DSP16_WAVEIN            :Result.Product := 'DSP16_WAVEIN   ';
            MM_AZTECH_DSP16_WAVEOUT           :Result.Product := 'DSP16_WAVEOUT  ';
            MM_AZTECH_DSP16_FMSYNTH           :Result.Product := 'DSP16_FMSYNTH  ';
            MM_AZTECH_DSP16_WAVESYNTH         :Result.Product := 'DSP16_WAVESYNTH';
            MM_AZTECH_NOVA16_WAVEIN           :Result.Product := 'NOVA16_WAVEIN  ';
            MM_AZTECH_NOVA16_WAVEOUT          :Result.Product := 'NOVA16_WAVEOUT ';
            MM_AZTECH_NOVA16_MIXER            :Result.Product := 'NOVA16_MIXER   ';
            MM_AZTECH_WASH16_WAVEIN           :Result.Product := 'WASH16_WAVEIN  ';
            MM_AZTECH_WASH16_WAVEOUT          :Result.Product := 'WASH16_WAVEOUT ';
            MM_AZTECH_WASH16_MIXER            :Result.Product := 'WASH16_MIXER   ';
            MM_AZTECH_AUX_CD                  :Result.Product := 'AUX_CD         ';
            MM_AZTECH_AUX_LINE                :Result.Product := 'AUX_LINE       ';
            MM_AZTECH_AUX_MIC                 :Result.Product := 'AUX_MIC        ';
            MM_AZTECH_AUX                     :Result.Product := 'AUX            ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VIDEOLOGIC                :
        begin
            Result.Manufacturer := 'Videologic';
            case AMixerCaps.wPid of
            MM_VIDEOLOGIC_MSWAVEIN            :Result.Product := 'MSWAVEIN ';
            MM_VIDEOLOGIC_MSWAVEOUT           :Result.Product := 'MSWAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SCALACS                   :
        begin
            Result.Manufacturer := 'SCALACS';
            Result.Product := 'Unmapped Product';
        end;
        MM_KORG                      :
        begin
            Result.Manufacturer := 'Korg Inc.';
            case AMixerCaps.wPid of
            MM_KORG_PCIF_MIDIOUT              :Result.Product := 'PCIF_MIDIOUT    ';
            MM_KORG_PCIF_MIDIIN               :Result.Product := 'PCIF_MIDIIN     ';
            MM_KORG_1212IO_MSWAVEIN           :Result.Product := '1212IO_MSWAVEIN ';
            MM_KORG_1212IO_MSWAVEOUT          :Result.Product := '1212IO_MSWAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_APT                       :
        begin
            Result.Manufacturer := 'Audio Processing Technology';
            case AMixerCaps.wPid of
            MM_APT_ACE100CD                   :Result.Product := 'ACE100CD';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ICS                       :
        begin
            Result.Manufacturer := 'Integrated Circuit Systems, Inc.';
            case AMixerCaps.wPid of
            MM_ICS_WAVEDECK_WAVEOUT           :Result.Product := 'MS WSS compatible card and driver';
            MM_ICS_WAVEDECK_WAVEIN            :Result.Product := 'WAVEDECK_WAVEIN          ';
            MM_ICS_WAVEDECK_MIXER             :Result.Product := 'WAVEDECK_MIXER           ';
            MM_ICS_WAVEDECK_AUX               :Result.Product := 'WAVEDECK_AUX             ';
            MM_ICS_WAVEDECK_SYNTH             :Result.Product := 'WAVEDECK_SYNTH           ';
            MM_ICS_WAVEDEC_SB_WAVEOUT         :Result.Product := 'WAVEDEC_SB_WAVEOUT       ';
            MM_ICS_WAVEDEC_SB_WAVEIN          :Result.Product := 'WAVEDEC_SB_WAVEIN        ';
            MM_ICS_WAVEDEC_SB_FM_MIDIOUT      :Result.Product := 'WAVEDEC_SB_FM_MIDIOUT    ';
            MM_ICS_WAVEDEC_SB_MPU401_MIDIOUT  :Result.Product := 'WAVEDEC_SB_MPU401_MIDIOUT';
            MM_ICS_WAVEDEC_SB_MPU401_MIDIIN   :Result.Product := 'WAVEDEC_SB_MPU401_MIDIIN ';
            MM_ICS_WAVEDEC_SB_MIXER           :Result.Product := 'WAVEDEC_SB_MIXER         ';
            MM_ICS_WAVEDEC_SB_AUX             :Result.Product := 'WAVEDEC_SB_AUX           ';
            MM_ICS_2115_LITE_MIDIOUT          :Result.Product := '2115_LITE_MIDIOUT        ';
            MM_ICS_2120_LITE_MIDIOUT          :Result.Product := '2120_LITE_MIDIOUT        ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ITERATEDSYS               :
        begin
            Result.Manufacturer := 'Iterated Systems, Inc.';
            case AMixerCaps.wPid of
            MM_ITERATEDSYS_FUFCODEC           :Result.Product := 'FUFCODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_METHEUS                   :
        begin
            Result.Manufacturer := 'Metheus';
            case AMixerCaps.wPid of
            MM_METHEUS_ZIPPER                 :Result.Product := 'ZIPPER';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LOGITECH                  :
        begin
            Result.Manufacturer := 'Logitech, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_WINNOV                    :
        begin
            Result.Manufacturer := 'Winnov, Inc.';
            case AMixerCaps.wPid of
            MM_WINNOV_CAVIAR_WAVEIN           :Result.Product := 'CAVIAR_WAVEIN ';
            MM_WINNOV_CAVIAR_WAVEOUT          :Result.Product := 'CAVIAR_WAVEOUT';
            MM_WINNOV_CAVIAR_VIDC             :Result.Product := 'CAVIAR_VIDC   ';
            MM_WINNOV_CAVIAR_CHAMPAGNE        :Result.Product := 'Fourcc is CHAM';
            MM_WINNOV_CAVIAR_YUV8             :Result.Product := 'Fourcc is YUV8';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NCR                       :
        begin
            Result.Manufacturer := 'NCR Corporation';
            case AMixerCaps.wPid of
            MM_NCR_BA_WAVEIN                  :Result.Product := 'BA_WAVEIN ';
            MM_NCR_BA_WAVEOUT                 :Result.Product := 'BA_WAVEOUT';
            MM_NCR_BA_SYNTH                   :Result.Product := 'BA_SYNTH  ';
            MM_NCR_BA_AUX                     :Result.Product := 'BA_AUX    ';
            MM_NCR_BA_MIXER                   :Result.Product := 'BA_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_EXAN                      :
        begin
            Result.Manufacturer := 'EXAN';
            Result.Product := 'Unmapped Product';
        end;
        MM_AST                       :
        begin
            Result.Manufacturer := 'AST Research Inc.';
            case AMixerCaps.wPid of
            MM_AST_MODEMWAVE_WAVEIN           :Result.Product := 'MODEMWAVE_WAVEIN ';
            MM_AST_MODEMWAVE_WAVEOUT          :Result.Product := 'MODEMWAVE_WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_WILLOWPOND                :
        begin
            Result.Manufacturer := 'Willow Pond Corporation';
            case AMixerCaps.wPid of
            MM_WILLOWPOND_FMSYNTH_STEREO      :Result.Product := 'FMSYNTH_STEREO ';
            MM_WILLOWPOND_MPU401              :Result.Product := 'MPU401         ';
            MM_WILLOWPOND_SNDPORT_WAVEIN      :Result.Product := 'SNDPORT_WAVEIN ';
            MM_WILLOWPOND_SNDPORT_WAVEOUT     :Result.Product := 'SNDPORT_WAVEOUT';
            MM_WILLOWPOND_SNDPORT_MIXER       :Result.Product := 'SNDPORT_MIXER  ';
            MM_WILLOWPOND_SNDPORT_AUX         :Result.Product := 'SNDPORT_AUX    ';
            MM_WILLOWPOND_PH_WAVEIN           :Result.Product := 'PH_WAVEIN      ';
            MM_WILLOWPOND_PH_WAVEOUT          :Result.Product := 'PH_WAVEOUT     ';
            MM_WILLOWPOND_PH_MIXER            :Result.Product := 'PH_MIXER       ';
            MM_WILLOWPOND_PH_AUX              :Result.Product := 'PH_AUX         ';
            MM_WILLOPOND_SNDCOMM_WAVEIN       :Result.Product := 'SNDCOMM_WAVEIN';
            MM_WILLOWPOND_SNDCOMM_WAVEOUT     :Result.Product := 'SNDCOMM_WAVEOUT';
            MM_WILLOWPOND_SNDCOMM_MIXER       :Result.Product := 'SNDCOMM_MIXER  ';
            MM_WILLOWPOND_SNDCOMM_AUX         :Result.Product := 'SNDCOMM_AUX    ';
            MM_WILLOWPOND_GENERIC_WAVEIN      :Result.Product := 'GENERIC_WAVEIN ';
            MM_WILLOWPOND_GENERIC_WAVEOUT     :Result.Product := 'GENERIC_WAVEOUT';
            MM_WILLOWPOND_GENERIC_MIXER       :Result.Product := 'GENERIC_MIXER  ';
            MM_WILLOWPOND_GENERIC_AUX         :Result.Product := 'GENERIC_AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SONICFOUNDRY              :
        begin
            Result.Manufacturer := 'Sonic Foundry';
            Result.Product := 'Unmapped Product';
        end;
        MM_VITEC                     :
        begin
            Result.Manufacturer := 'Vitec Multimedia';
            case AMixerCaps.wPid of
            MM_VITEC_VMAKER                   :Result.Product := 'VMAKER';
            MM_VITEC_VMPRO                    :Result.Product := 'VMPRO ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MOSCOM                    :
        begin
            Result.Manufacturer := 'MOSCOM Corporation';
            case AMixerCaps.wPid of
            MM_MOSCOM_VPC2400_IN              :Result.Product := 'Four Port Voice Processing / Voice Recognition Board';
            MM_MOSCOM_VPC2400_OUT             :Result.Product := 'VPC2400';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SILICONSOFT               :
        begin
            Result.Manufacturer := 'Silicon Soft, Inc.';
            case AMixerCaps.wPid of
            MM_SILICONSOFT_SC1_WAVEIN         :Result.Product := 'Waveform in , high sample rate';
            MM_SILICONSOFT_SC1_WAVEOUT        :Result.Product := 'Waveform out , high sample rate';
            MM_SILICONSOFT_SC2_WAVEIN         :Result.Product := 'Waveform in 2 channels, high sample rate';
            MM_SILICONSOFT_SC2_WAVEOUT        :Result.Product := 'Waveform out 2 channels, high sample rate';
            MM_SILICONSOFT_SOUNDJR2_WAVEOUT   :Result.Product := 'Waveform out, self powered, efficient';
            MM_SILICONSOFT_SOUNDJR2PR_WAVEIN  :Result.Product := 'Waveform in, self powered, efficient';
            MM_SILICONSOFT_SOUNDJR2PR_WAVEOUT :Result.Product := 'Waveform out 2 channels, self powered, efficient';
            MM_SILICONSOFT_SOUNDJR3_WAVEOUT   :Result.Product := 'Waveform in 2 channels, self powered, efficient';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TERRATEC                  :
        begin
            Result.Manufacturer := 'TerraTec Electronic GmbH';
            case AMixerCaps.wPid of
            MM_TTEWS_WAVEIN                   :Result.Product := 'WAVEIN     ';
            MM_TTEWS_WAVEOUT                  :Result.Product := 'WAVEOUT    ';
            MM_TTEWS_MIDIIN                   :Result.Product := 'MIDIIN     ';
            MM_TTEWS_MIDIOUT                  :Result.Product := 'MIDIOUT    ';
            MM_TTEWS_MIDISYNTH                :Result.Product := 'MIDISYNTH  ';
            MM_TTEWS_MIDIMONITOR              :Result.Product := 'MIDIMONITOR';
            MM_TTEWS_VMIDIIN                  :Result.Product := 'VMIDIIN    ';
            MM_TTEWS_VMIDIOUT                 :Result.Product := 'VMIDIOUT   ';
            MM_TTEWS_AUX                      :Result.Product := 'AUX        ';
            MM_TTEWS_MIXER                    :Result.Product := 'MIXER      ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MEDIASONIC                :
        begin
            Result.Manufacturer := 'MediaSonic Ltd.';
            case AMixerCaps.wPid of
            MM_MEDIASONIC_ACM_G723            :Result.Product := 'ACM_G723';
            MM_MEDIASONIC_ICOM                :Result.Product := 'ICOM    ';
            MM_ICOM_WAVEIN                    :Result.Product := 'ICOM_WAVEIN ';
            MM_ICOM_WAVEOUT                   :Result.Product := 'ICOM_WAVEOUT';
            MM_ICOM_MIXER                     :Result.Product := 'ICOM_MIXER  ';
            MM_ICOM_AUX                       :Result.Product := 'ICOM_AUX    ';
            MM_ICOM_LINE                      :Result.Product := 'ICOM_LINE   ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SANYO                     :
        begin
            Result.Manufacturer := 'SANYO Electric Co., Ltd.';
            case AMixerCaps.wPid of
            MM_SANYO_ACM_LD_ADPCM             :Result.Product := 'ACM_LD_ADPCM';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SUPERMAC                  :
        begin
            Result.Manufacturer := 'Supermac';
            Result.Product := 'Unmapped Product';
        end;
        MM_AUDIOPT                   :
        begin
            Result.Manufacturer := 'Audio Processing Technology';
            Result.Product := 'Unmapped Product';
        end;
        MM_NOGATECH                  :
        begin
            Result.Manufacturer := 'NOGATECH Ltd.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SPEECHCOMP                :
        begin
            Result.Manufacturer := 'Speech Compression';
            Result.Product := 'Unmapped Product';
        end;
        MM_AHEAD                     :
        begin
            Result.Manufacturer := 'Ahead, Inc.';
            case AMixerCaps.wPid of
            MM_AHEAD_MULTISOUND               :Result.Product := 'MULTISOUND  ';
            MM_AHEAD_SOUNDBLASTER             :Result.Product := 'SOUNDBLASTER';
            MM_AHEAD_PROAUDIO                 :Result.Product := 'PROAUDIO    ';
            MM_AHEAD_GENERIC                  :Result.Product := 'GENERIC     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DOLBY                     :
        begin
            Result.Manufacturer := 'Dolby Laboratories';
            Result.Product := 'Unmapped Product';
        end;
        MM_OKI                       :
        begin
            Result.Manufacturer := 'OKI';
            Result.Product := 'Unmapped Product';
        end;
        MM_AURAVISION                :
        begin
            Result.Manufacturer := 'AuraVision Corporation';
            Result.Product := 'Unmapped Product';
        end;
        MM_OLIVETTI                  :
        begin
            Result.Manufacturer := 'Ing C. Olivetti & C., S.p.A.';
            case AMixerCaps.wPid of
            MM_OLIVETTI_WAVEIN                :Result.Product := 'WAVEIN   ';
            MM_OLIVETTI_WAVEOUT               :Result.Product := 'WAVEOUT  ';
            MM_OLIVETTI_MIXER                 :Result.Product := 'MIXER    ';
            MM_OLIVETTI_AUX                   :Result.Product := 'AUX      ';
            MM_OLIVETTI_MIDIIN                :Result.Product := 'MIDIIN   ';
            MM_OLIVETTI_MIDIOUT               :Result.Product := 'MIDIOUT  ';
            MM_OLIVETTI_SYNTH                 :Result.Product := 'SYNTH    ';
            MM_OLIVETTI_JOYSTICK              :Result.Product := 'JOYSTICK ';
            MM_OLIVETTI_ACM_GSM               :Result.Product := 'ACM_GSM  ';
            MM_OLIVETTI_ACM_ADPCM             :Result.Product := 'ACM_ADPCM';
            MM_OLIVETTI_ACM_CELP              :Result.Product := 'ACM_CELP ';
            MM_OLIVETTI_ACM_SBC               :Result.Product := 'ACM_SBC  ';
            MM_OLIVETTI_ACM_OPR               :Result.Product := 'ACM_OPR  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_IOMAGIC                   :
        begin
            Result.Manufacturer := 'I/O Magic Corporation';
            case AMixerCaps.wPid of
            MM_IOMAGIC_TEMPO_WAVEOUT          :Result.Product := 'TEMPO_WAVEOUT';
            MM_IOMAGIC_TEMPO_WAVEIN           :Result.Product := 'TEMPO_WAVEIN ';
            MM_IOMAGIC_TEMPO_SYNTH            :Result.Product := 'TEMPO_SYNTH  ';
            MM_IOMAGIC_TEMPO_MIDIOUT          :Result.Product := 'TEMPO_MIDIOUT';
            MM_IOMAGIC_TEMPO_MXDOUT           :Result.Product := 'TEMPO_MXDOUT ';
            MM_IOMAGIC_TEMPO_AUXOUT           :Result.Product := 'TEMPO_AUXOUT ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MATSUSHITA                :
        begin
            Result.Manufacturer := 'Matsushita Electric Industrial Co., Ltd.';
            case AMixerCaps.wPid of
            MM_MATSUSHITA_WAVEIN              :Result.Product := 'WAVEIN        ';
            MM_MATSUSHITA_WAVEOUT             :Result.Product := 'WAVEOUT       ';
            MM_MATSUSHITA_FMSYNTH_STEREO      :Result.Product := 'FMSYNTH_STEREO';
            MM_MATSUSHITA_MIXER               :Result.Product := 'MIXER         ';
            MM_MATSUSHITA_AUX                 :Result.Product := 'AUX           ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CONTROLRES                :
        begin
            Result.Manufacturer := 'Control Resources Limited';
            Result.Product := 'Unmapped Product';
        end;
        MM_XEBEC                     :
        begin
            Result.Manufacturer := 'Xebec Multimedia Solutions Limited';
            Result.Product := 'Unmapped Product';
        end;
        MM_NEWMEDIA                  :
        begin
            Result.Manufacturer := 'New Media Corporation';
            case AMixerCaps.wPid of
            MM_NEWMEDIA_WAVJAMMER             :Result.Product := 'WSS Compatible sound card.';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NMS                       :
        begin
            Result.Manufacturer := 'Natural MicroSystems';
            Result.Product := 'Unmapped Product';
        end;
        MM_LYRRUS                    :
        begin
            Result.Manufacturer := 'Lyrrus Inc.';
            case AMixerCaps.wPid of
            MM_LYRRUS_BRIDGE_GUITAR           :Result.Product := 'BRIDGE_GUITAR';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_COMPUSIC                  :
        begin
            Result.Manufacturer := 'Compusic';
            Result.Product := 'Unmapped Product';
        end;
        MM_OPTI                      :
        begin
            Result.Manufacturer := 'OPTi Computers Inc.';
            case AMixerCaps.wPid of
            MM_OPTI_M16_FMSYNTH_STEREO        : Result.Product := 'M16_FMSYNTH_STEREO';
            MM_OPTI_M16_MIDIIN                : Result.Product := 'M16_MIDIIN        ';
            MM_OPTI_M16_MIDIOUT               : Result.Product := 'M16_MIDIOUT       ';
            MM_OPTI_M16_WAVEIN                : Result.Product := 'M16_WAVEIN        ';
            MM_OPTI_M16_WAVEOUT               : Result.Product := 'M16_WAVEOUT       ';
            MM_OPTI_M16_MIXER                 : Result.Product := 'M16_MIXER         ';
            MM_OPTI_M16_AUX                   : Result.Product := 'M16_AUX           ';
            MM_OPTI_P16_FMSYNTH_STEREO        : Result.Product := 'P16_FMSYNTH_STEREO';
            MM_OPTI_P16_MIDIIN                : Result.Product := 'P16_MIDIIN        ';
            MM_OPTI_P16_MIDIOUT               : Result.Product := 'P16_MIDIOUT       ';
            MM_OPTI_P16_WAVEIN                : Result.Product := 'P16_WAVEIN        ';
            MM_OPTI_P16_WAVEOUT               : Result.Product := 'P16_WAVEOUT       ';
            MM_OPTI_P16_MIXER                 : Result.Product := 'P16_MIXER         ';
            MM_OPTI_P16_AUX                   : Result.Product := 'P16_AUX           ';
            MM_OPTI_M32_WAVEIN                : Result.Product := 'M32_WAVEIN        ';
            MM_OPTI_M32_WAVEOUT               : Result.Product := 'M32_WAVEOUT       ';
            MM_OPTI_M32_MIDIIN                : Result.Product := 'M32_MIDIIN        ';
            MM_OPTI_M32_MIDIOUT               : Result.Product := 'M32_MIDIOUT       ';
            MM_OPTI_M32_SYNTH_STEREO          : Result.Product := 'M32_SYNTH_STEREO  ';
            MM_OPTI_M32_MIXER                 : Result.Product := 'M32_MIXER         ';
            MM_OPTI_M32_AUX                   : Result.Product := 'M32_AUX           ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ADLACC                    :
        begin
            Result.Manufacturer := 'Adlib Accessories Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_COMPAQ                    :
        begin
            Result.Manufacturer := 'Compaq Computer Corp.';
            case AMixerCaps.wPid of
            MM_COMPAQ_BB_WAVEIN               :Result.Product := 'BB_WAVEIN ';
            MM_COMPAQ_BB_WAVEOUT              :Result.Product := 'BB_WAVEOUT';
            MM_COMPAQ_BB_WAVEAUX              :Result.Product := 'BB_WAVEAUX';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DIALOGIC                  :
        begin
            Result.Manufacturer := 'Dialogic Corporation';
            Result.Product := 'Unmapped Product';
        end;
        MM_INSOFT                    :
        begin
            Result.Manufacturer := 'InSoft, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_MPTUS                     :
        begin
            Result.Manufacturer := 'M.P. Technologies, Inc.';
            case AMixerCaps.wPid of
            MM_MPTUS_SPWAVEOUT                :Result.Product := 'Sound Pallette';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_WEITEK                    :
        begin
            Result.Manufacturer := 'Weitek';
            Result.Product := 'Unmapped Product';
        end;
        MM_LERNOUT_AND_HAUSPIE       :
        begin
            Result.Manufacturer := 'Lernout & Hauspie';
            case AMixerCaps.wPid of
            MM_LERNOUT_ANDHAUSPIE_LHCODECACM  :Result.Product := 'ANDHAUSPIE_LHCODECACM';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QCIAR                     :
        begin
            Result.Manufacturer := 'Quanta Computer Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_APPLE                     :
        begin
            Result.Manufacturer := 'Apple Computer, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_DIGITAL                   :
        begin
            Result.Manufacturer := 'Digital Equipment Corporation';
            case AMixerCaps.wPid of
            MM_DIGITAL_AV320_WAVEIN           :Result.Product := 'Digital Audio Video Compression Board';
            MM_DIGITAL_AV320_WAVEOUT          :Result.Product := 'Digital Audio Video Compression Board';
            MM_DIGITAL_ACM_G723               :Result.Product := 'ACM_G723';
            MM_DIGITAL_ICM_H263               :Result.Product := 'ICM_H263';
            MM_DIGITAL_ICM_H261               :Result.Product := 'ICM_H261';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MOTU                      :
        begin
            Result.Manufacturer := 'Mark of the Unicorn';
            case AMixerCaps.wPid of
            MM_MOTU_MTP_MIDIOUT_ALL           :Result.Product := 'MTP_MIDIOUT_ALL  ';
            MM_MOTU_MTP_MIDIIN_1              :Result.Product := 'MTP_MIDIIN/OUT_1     ';
            //MM_MOTU_MTP_MIDIOUT_1             :Result.Product := 'MTP_MIDIOUT_1    ';
            MM_MOTU_MTP_MIDIIN_2              :Result.Product := 'MTP_MIDIIN/OUT_2     ';
            //MM_MOTU_MTP_MIDIOUT_2             :Result.Product := 'MTP_MIDIOUT_2    ';
            MM_MOTU_MTP_MIDIIN_3              :Result.Product := 'MTP_MIDIIN/OUT_3     ';
            //MM_MOTU_MTP_MIDIOUT_3             :Result.Product := 'MTP_MIDIOUT_3    ';
            MM_MOTU_MTP_MIDIIN_4              :Result.Product := 'MTP_MIDIIN/OUT_4     ';
            //MM_MOTU_MTP_MIDIOUT_4             :Result.Product := 'MTP_MIDIOUT_4    ';
            MM_MOTU_MTP_MIDIIN_5              :Result.Product := 'MTP_MIDIIN/OUT_5     ';
            //MM_MOTU_MTP_MIDIOUT_5             :Result.Product := 'MTP_MIDIOUT_5    ';
            MM_MOTU_MTP_MIDIIN_6              :Result.Product := 'MTP_MIDIIN/OUT_6     ';
            //MM_MOTU_MTP_MIDIOUT_6             :Result.Product := 'MTP_MIDIOUT_6    ';
            MM_MOTU_MTP_MIDIIN_7              :Result.Product := 'MTP_MIDIIN/OUT_7     ';
            //MM_MOTU_MTP_MIDIOUT_7             :Result.Product := 'MTP_MIDIOUT_7    ';
            MM_MOTU_MTP_MIDIIN_8              :Result.Product := 'MTP_MIDIIN/OUT_8     ';
            //MM_MOTU_MTP_MIDIOUT_8             :Result.Product := 'MTP_MIDIOUT_8    ';

            MM_MOTU_MTPII_MIDIOUT_ALL         :Result.Product := 'MTPII_MIDIOUT_ALL/IN_SYNC';
            //MM_MOTU_MTPII_MIDIIN_SYNC         :Result.Product := 'MTPII_MIDIIN_SYNC';
            MM_MOTU_MTPII_MIDIIN_1            :Result.Product := 'MTPII_MIDIIN/OUT_1   ';
            //MM_MOTU_MTPII_MIDIOUT_1           :Result.Product := 'MTPII_MIDIOUT_1  ';
            MM_MOTU_MTPII_MIDIIN_2            :Result.Product := 'MTPII_MIDIIN/OUT_2   ';
            //MM_MOTU_MTPII_MIDIOUT_2           :Result.Product := 'MTPII_MIDIOUT_2    ';
            MM_MOTU_MTPII_MIDIIN_3            :Result.Product := 'MTPII_MIDIIN/OUT_3     ';
            //MM_MOTU_MTPII_MIDIOUT_3           :Result.Product := 'MTPII_MIDIOUT_3    ';
            MM_MOTU_MTPII_MIDIIN_4            :Result.Product := 'MTPII_MIDIIN/OUT_4     ';
            //MM_MOTU_MTPII_MIDIOUT_4           :Result.Product := 'MTPII_MIDIOUT_4    ';
            MM_MOTU_MTPII_MIDIIN_5            :Result.Product := 'MTPII_MIDIIN/OUT_5     ';
            //MM_MOTU_MTPII_MIDIOUT_5           :Result.Product := 'MTPII_MIDIOUT_5    ';
            MM_MOTU_MTPII_MIDIIN_6            :Result.Product := 'MTPII_MIDIIN/OUT_6     ';
            //MM_MOTU_MTPII_MIDIOUT_6           :Result.Product := 'MTPII_MIDIOUT_6    ';
            MM_MOTU_MTPII_MIDIIN_7            :Result.Product := 'MTPII_MIDIIN/OUT_7     ';
            //MM_MOTU_MTPII_MIDIOUT_7           :Result.Product := 'MTPII_MIDIOUT_7    ';
            MM_MOTU_MTPII_MIDIIN_8            :Result.Product := 'MTPII_MIDIIN/OUT_8     ';
            //MM_MOTU_MTPII_MIDIOUT_8           :Result.Product := 'MTPII_MIDIOUT_8    ';
            MM_MOTU_MTPII_NET_MIDIIN_1        :Result.Product := 'MTPII_NET_MIDIIN/OUT_1 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_1       :Result.Product := 'MTPII_NET_MIDIOUT_1';
            MM_MOTU_MTPII_NET_MIDIIN_2        :Result.Product := 'MTPII_NET_MIDIIN/OUT_2 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_2       :Result.Product := 'MTPII_NET_MIDIOUT_2';
            MM_MOTU_MTPII_NET_MIDIIN_3        :Result.Product := 'MTPII_NET_MIDIIN/OUT_3 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_3       :Result.Product := 'MTPII_NET_MIDIOUT_3';
            MM_MOTU_MTPII_NET_MIDIIN_4        :Result.Product := 'MTPII_NET_MIDIIN/OUT_4 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_4       :Result.Product := 'MTPII_NET_MIDIOUT_4';
            MM_MOTU_MTPII_NET_MIDIIN_5        :Result.Product := 'MTPII_NET_MIDIIN/OUT_5 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_5       :Result.Product := 'MTPII_NET_MIDIOUT_5';
            MM_MOTU_MTPII_NET_MIDIIN_6        :Result.Product := 'MTPII_NET_MIDIIN/OUT_6 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_6       :Result.Product := 'MTPII_NET_MIDIOUT_6';
            MM_MOTU_MTPII_NET_MIDIIN_7        :Result.Product := 'MTPII_NET_MIDIIN/OUT_7 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_7       :Result.Product := 'MTPII_NET_MIDIOUT_7';
            MM_MOTU_MTPII_NET_MIDIIN_8        :Result.Product := 'MTPII_NET_MIDIIN/OUT_8 ';
            //MM_MOTU_MTPII_NET_MIDIOUT_8       :Result.Product := 'MTPII_NET_MIDIOUT_8';

            MM_MOTU_MXP_MIDIIN_MIDIOUT_ALL    :Result.Product := 'MXP_MIDIIN_MIDIOUT_ALL/SYNC';
            //MM_MOTU_MXP_MIDIIN_SYNC           :Result.Product := 'MXP_MIDIIN_SYNC       ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_1       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_1   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_1      :Result.Product := 'MXP_MIDIIN_MIDIOUT_1  ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_2       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_2   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_2      :Result.Product := 'MXP_MIDIIN_MIDIOUT_2  ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_3       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_3   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_3      :Result.Product := 'MXP_MIDIIN_MIDIOUT_3  ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_4       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_4   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_4      :Result.Product := 'MXP_MIDIIN_MIDIOUT_4  ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_5       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_5   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_5      :Result.Product := 'MXP_MIDIIN_MIDIOUT_5  ';
            MM_MOTU_MXP_MIDIIN_MIDIIN_6       :Result.Product := 'MXP_MIDIIN_MIDIIN/OUT_6   ';
            //MM_MOTU_MXP_MIDIIN_MIDIOUT_6      :Result.Product := 'MXP_MIDIIN_MIDIOUT_6  ';

            MM_MOTU_MXPMPU_MIDIOUT_ALL        :Result.Product := 'MXPMPU_MIDIOUT_ALL/IN_SYNC';
            //MM_MOTU_MXPMPU_MIDIIN_SYNC        :Result.Product := 'MXPMPU_MIDIIN_SYNC';
            MM_MOTU_MXPMPU_MIDIIN_1           :Result.Product := 'MXPMPU_MIDIIN_1   ';
            //MM_MOTU_MXPMPU_MIDIOUT_1          :Result.Product := 'MXPMPU_MIDIOUT_1  ';
            MM_MOTU_MXPMPU_MIDIIN_2           :Result.Product := 'MXPMPU_MIDIIN_2   ';
            //MM_MOTU_MXPMPU_MIDIOUT_2          :Result.Product := 'MXPMPU_MIDIOUT_2  ';
            MM_MOTU_MXPMPU_MIDIIN_3           :Result.Product := 'MXPMPU_MIDIIN_3   ';
            //MM_MOTU_MXPMPU_MIDIOUT_3          :Result.Product := 'MXPMPU_MIDIOUT_3  ';
            MM_MOTU_MXPMPU_MIDIIN_4           :Result.Product := 'MXPMPU_MIDIIN_4   ';
            //MM_MOTU_MXPMPU_MIDIOUT_4          :Result.Product := 'MXPMPU_MIDIOUT_4  ';
            MM_MOTU_MXPMPU_MIDIIN_5           :Result.Product := 'MXPMPU_MIDIIN_5   ';
            //MM_MOTU_MXPMPU_MIDIOUT_5          :Result.Product := 'MXPMPU_MIDIOUT_5  ';
            MM_MOTU_MXPMPU_MIDIIN_6           :Result.Product := 'MXPMPU_MIDIIN_6   ';
            //MM_MOTU_MXPMPU_MIDIOUT_6          :Result.Product := 'MXPMPU_MIDIOUT_6  ';

            MM_MOTU_MXN_MIDIOUT_ALL           :Result.Product := 'MXN_MIDIOUT_ALL/IN_SYNC';
            //MM_MOTU_MXN_MIDIIN_SYNC           :Result.Product := 'MXN_MIDIIN_SYNC   ';
            MM_MOTU_MXN_MIDIIN_1              :Result.Product := 'MXN_MIDIIN_1      ';
            //MM_MOTU_MXN_MIDIOUT_1             :Result.Product := 'MXN_MIDIOUT_1     ';
            MM_MOTU_MXN_MIDIIN_2              :Result.Product := 'MXN_MIDIIN_2      ';
            //MM_MOTU_MXN_MIDIOUT_2             :Result.Product := 'MXN_MIDIOUT_2     ';
            MM_MOTU_MXN_MIDIIN_3              :Result.Product := 'MXN_MIDIIN_3      ';
            //MM_MOTU_MXN_MIDIOUT_3             :Result.Product := 'MXN_MIDIOUT_3     ';
            MM_MOTU_MXN_MIDIIN_4              :Result.Product := 'MXN_MIDIIN_4      ';
            //MM_MOTU_MXN_MIDIOUT_4             :Result.Product := 'MXN_MIDIOUT_4     ';

            MM_MOTU_FLYER_MIDI_IN_SYNC        :Result.Product := 'FLYER_MIDI_IN_SYNC';
            MM_MOTU_FLYER_MIDI_IN_A           :Result.Product := 'FLYER_MIDI_IN_A   ';
            //MM_MOTU_FLYER_MIDI_OUT_A          :Result.Product := 'FLYER_MIDI_OUT_A  ';
            MM_MOTU_FLYER_MIDI_IN_B           :Result.Product := 'FLYER_MIDI_IN_B   ';
            //MM_MOTU_FLYER_MIDI_OUT_B          :Result.Product := 'FLYER_MIDI_OUT_B  ';

            MM_MOTU_PKX_MIDI_IN_SYNC          :Result.Product := 'PKX_MIDI_IN_SYNC  ';
            MM_MOTU_PKX_MIDI_IN_A             :Result.Product := 'PKX_MIDI_IN_A     ';
            //MM_MOTU_PKX_MIDI_OUT_A            :Result.Product := 'PKX_MIDI_OUT_A    ';
            MM_MOTU_PKX_MIDI_IN_B             :Result.Product := 'PKX_MIDI_IN_B     ';
            //MM_MOTU_PKX_MIDI_OUT_B            :Result.Product := 'PKX_MIDI_OUT_B    ';

            MM_MOTU_DTX_MIDI_IN_SYNC          :Result.Product := 'DTX_MIDI_IN_SYNC  ';
            MM_MOTU_DTX_MIDI_IN_A             :Result.Product := 'DTX_MIDI_IN_A     ';
            //MM_MOTU_DTX_MIDI_OUT_A            :Result.Product := 'DTX_MIDI_OUT_A    ';
            MM_MOTU_DTX_MIDI_IN_B             :Result.Product := 'DTX_MIDI_IN_B     ';
            //MM_MOTU_DTX_MIDI_OUT_B            :Result.Product := 'DTX_MIDI_OUT_B    ';

            MM_MOTU_MTPAV_MIDIOUT_ALL         :Result.Product := 'MTPAV_MIDIOUT_ALL/IN_SYNC';
            //MM_MOTU_MTPAV_MIDIIN_SYNC         :Result.Product := 'MTPAV_MIDIIN_SYNC ';
            MM_MOTU_MTPAV_MIDIIN_1            :Result.Product := 'MTPAV_MIDIIN_1    ';
            //MM_MOTU_MTPAV_MIDIOUT_1           :Result.Product := 'MTPAV_MIDIOUT_1   ';
            MM_MOTU_MTPAV_MIDIIN_2            :Result.Product := 'MTPAV_MIDIIN_2    ';
            //MM_MOTU_MTPAV_MIDIOUT_2           :Result.Product := 'MTPAV_MIDIOUT_2   ';
            MM_MOTU_MTPAV_MIDIIN_3            :Result.Product := 'MTPAV_MIDIIN_3    ';
            //MM_MOTU_MTPAV_MIDIOUT_3           :Result.Product := 'MTPAV_MIDIOUT_3   ';
            MM_MOTU_MTPAV_MIDIIN_4            :Result.Product := 'MTPAV_MIDIIN_4    ';
            //MM_MOTU_MTPAV_MIDIOUT_4           :Result.Product := 'MTPAV_MIDIOUT_4   ';
            MM_MOTU_MTPAV_MIDIIN_5            :Result.Product := 'MTPAV_MIDIIN_5    ';
            //MM_MOTU_MTPAV_MIDIOUT_5           :Result.Product := 'MTPAV_MIDIOUT_5   ';
            MM_MOTU_MTPAV_MIDIIN_6            :Result.Product := 'MTPAV_MIDIIN_6    ';
            //MM_MOTU_MTPAV_MIDIOUT_6           :Result.Product := 'MTPAV_MIDIOUT_6   ';
            MM_MOTU_MTPAV_MIDIIN_7            :Result.Product := 'MTPAV_MIDIIN_7    ';
            //MM_MOTU_MTPAV_MIDIOUT_7           :Result.Product := 'MTPAV_MIDIOUT_7   ';
            MM_MOTU_MTPAV_MIDIIN_8            :Result.Product := 'MTPAV_MIDIIN_8    ';
            //MM_MOTU_MTPAV_MIDIOUT_8           :Result.Product := 'MTPAV_MIDIOUT_8   ';
            MM_MOTU_MTPAV_NET_MIDIIN_1        :Result.Product := 'MTPAV_NET_MIDIIN_1';
            //MM_MOTU_MTPAV_NET_MIDIOUT_1       :Result.Product := 'MTPAV_NET_MIDIOUT_1';
            MM_MOTU_MTPAV_NET_MIDIIN_2        :Result.Product := 'MTPAV_NET_MIDIIN_2 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_2       :Result.Product := 'MTPAV_NET_MIDIOUT_2';
            MM_MOTU_MTPAV_NET_MIDIIN_3        :Result.Product := 'MTPAV_NET_MIDIIN_3 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_3       :Result.Product := 'MTPAV_NET_MIDIOUT_3';
            MM_MOTU_MTPAV_NET_MIDIIN_4        :Result.Product := 'MTPAV_NET_MIDIIN_4 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_4       :Result.Product := 'MTPAV_NET_MIDIOUT_4';
            MM_MOTU_MTPAV_NET_MIDIIN_5        :Result.Product := 'MTPAV_NET_MIDIIN_5 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_5       :Result.Product := 'MTPAV_NET_MIDIOUT_5';
            MM_MOTU_MTPAV_NET_MIDIIN_6        :Result.Product := 'MTPAV_NET_MIDIIN_6 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_6       :Result.Product := 'MTPAV_NET_MIDIOUT_6';
            MM_MOTU_MTPAV_NET_MIDIIN_7        :Result.Product := 'MTPAV_NET_MIDIIN_7 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_7       :Result.Product := 'MTPAV_NET_MIDIOUT_7';
            MM_MOTU_MTPAV_NET_MIDIIN_8        :Result.Product := 'MTPAV_NET_MIDIIN_8 ';
            //MM_MOTU_MTPAV_NET_MIDIOUT_8       :Result.Product := 'MTPAV_NET_MIDIOUT_8';
            MM_MOTU_MTPAV_MIDIIN_ADAT         :Result.Product := 'MTPAV_MIDIIN/OUT_ADAT  ';
            //MM_MOTU_MTPAV_MIDIOUT_ADAT        :Result.Product := 'MTPAV_MIDIOUT_ADAT ';
            MM_MOTU_MXPXT_MIDIIN_SYNC         :Result.Product := 'MXPXT_MIDIIN_SYNC/OUT_ALL  ';
            //MM_MOTU_MXPXT_MIDIOUT_ALL         :Result.Product := 'MXPXT_MIDIOUT_ALL  ';
            MM_MOTU_MXPXT_MIDIIN_1            :Result.Product := 'MXPXT_MIDIIN/OUT_1     ';
            //MM_MOTU_MXPXT_MIDIOUT_1           :Result.Product := 'MXPXT_MIDIOUT_1    ';
            //MM_MOTU_MXPXT_MIDIOUT_2           :Result.Product := 'MXPXT_MIDIOUT_2    ';
            MM_MOTU_MXPXT_MIDIIN_2            :Result.Product := 'MXPXT_MIDIIN/OUT_2     ';
            MM_MOTU_MXPXT_MIDIIN_3            :Result.Product := 'MXPXT_MIDIIN/OUT_3     ';
            //MM_MOTU_MXPXT_MIDIOUT_3           :Result.Product := 'MXPXT_MIDIOUT_3    ';
            MM_MOTU_MXPXT_MIDIIN_4            :Result.Product := 'MXPXT_MIDIIN/OUT_4     ';
            //MM_MOTU_MXPXT_MIDIOUT_4           :Result.Product := 'MXPXT_MIDIOUT_4    ';
            MM_MOTU_MXPXT_MIDIIN_5            :Result.Product := 'MXPXT_MIDIIN/OUT_5     ';
            //MM_MOTU_MXPXT_MIDIOUT_5           :Result.Product := 'MXPXT_MIDIOUT_5    ';
            //MM_MOTU_MXPXT_MIDIOUT_6           :Result.Product := 'MXPXT_MIDIOUT_6    ';
            MM_MOTU_MXPXT_MIDIIN_6            :Result.Product := 'MXPXT_MIDIIN/OUT_6     ';
            //MM_MOTU_MXPXT_MIDIOUT_7           :Result.Product := 'MXPXT_MIDIOUT_7    ';
            MM_MOTU_MXPXT_MIDIIN_7            :Result.Product := 'MXPXT_MIDIIN/OUT_7     ';
            //MM_MOTU_MXPXT_MIDIOUT_8           :Result.Product := 'MXPXT_MIDIOUT_8    ';
            MM_MOTU_MXPXT_MIDIIN_8            :Result.Product := 'MXPXT_MIDIIN/OUT_8     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_WORKBIT                   :
        begin
            Result.Manufacturer := 'Workbit Corporation';
            case AMixerCaps.wPid of
            MM_WORKBIT_MIXER                  : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_WAVEOUT                : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_WAVEIN                 : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_MIDIIN                 : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_MIDIOUT                : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_FMSYNTH                : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_AUX                    : Result.Product := 'Harmony Mixer';
            MM_WORKBIT_JOYSTICK               :Result.Product := 'JOYSTICK';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_OSITECH                   :
        begin
            Result.Manufacturer := 'Ositech Communications Inc.';
            case AMixerCaps.wPid of
            MM_OSITECH_TRUMPCARD              :Result.Product := 'Trumpcard';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MIRO                      :
        begin
            Result.Manufacturer := 'miro Computer Products AG';
            case AMixerCaps.wPid of
            MM_MIRO_MOVIEPRO                  : Result.Product := 'miroMOVIE pro';
            MM_MIRO_VIDEOD1                   : Result.Product := 'miroVIDEO D1';
            MM_MIRO_VIDEODC1TV                : Result.Product := 'miroVIDEO DC1 tv';
            MM_MIRO_VIDEOTD                   : Result.Product := 'miroVIDEO 10/20 TD';
            MM_MIRO_DC30_WAVEOUT              :Result.Product := 'DC30_WAVEOUT';
            MM_MIRO_DC30_WAVEIN               :Result.Product := 'DC30_WAVEIN ';
            MM_MIRO_DC30_MIX                  :Result.Product := 'DC30_MIX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CIRRUSLOGIC               :
        begin
            Result.Manufacturer := 'Cirrus Logic';
            Result.Product := 'Unmapped Product';
        end;
        MM_ISOLUTION                 :
        begin
            Result.Manufacturer := 'ISOLUTION  B.V.';
            case AMixerCaps.wPid of
            MM_ISOLUTION_PASCAL               :Result.Product := 'PASCAL';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_HORIZONS                  :
        begin
            Result.Manufacturer := 'Horizons Technology, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_CONCEPTS                  :
        begin
            Result.Manufacturer := 'Computer Concepts Ltd.';
            Result.Product := 'Unmapped Product';
        end;
        MM_VTG                       :
        begin
            Result.Manufacturer := 'Voice Technologies Group, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_RADIUS                    :
        begin
            Result.Manufacturer := 'Radius';
            Result.Product := 'Unmapped Product';
        end;
        MM_ROCKWELL                  :
        begin
            Result.Manufacturer := 'Rockwell International';
            case AMixerCaps.wPid of
            MM_VOICEMIXER                 :Result.Product := 'VOICEMIXER';
            ROCKWELL_WA1_WAVEIN           :Result.Product := 'WA1_WAVEIN    ';
            ROCKWELL_WA1_WAVEOUT          :Result.Product := 'WA1_WAVEOUT   ';
            ROCKWELL_WA1_SYNTH            :Result.Product := 'WA1_SYNTH     ';
            ROCKWELL_WA1_MIXER            :Result.Product := 'WA1_MIXER     ';
            ROCKWELL_WA1_MPU401_IN        :Result.Product := 'WA1_MPU401_IN ';
            ROCKWELL_WA1_MPU401_OUT       :Result.Product := 'WA1_MPU401_OUT';
            ROCKWELL_WA2_WAVEIN           :Result.Product := 'WA2_WAVEIN    ';
            ROCKWELL_WA2_WAVEOUT          :Result.Product := 'WA2_WAVEOUT   ';
            ROCKWELL_WA2_SYNTH            :Result.Product := 'WA2_SYNTH     ';
            ROCKWELL_WA2_MIXER            :Result.Product := 'WA2_MIXER     ';
            ROCKWELL_WA2_MPU401_IN        :Result.Product := 'WA2_MPU401_IN ';
            ROCKWELL_WA2_MPU401_OUT       :Result.Product := 'WA2_MPU401_OUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_XYZ                       :
        begin
            Result.Manufacturer := 'Co. XYZ for testing';
            Result.Product := 'Unmapped Product';
        end;
        MM_OPCODE                    :
        begin
            Result.Manufacturer := 'Opcode Systems';
            Result.Product := 'Unmapped Product';
        end;
        MM_VOXWARE                   :
        begin
            Result.Manufacturer := 'Voxware Inc.';
            case AMixerCaps.wPid of
            MM_VOXWARE_CODEC                  :Result.Product := 'CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NORTHERN_TELECOM          :
        begin
            Result.Manufacturer := 'Northern Telecom Limited';
            case AMixerCaps.wPid of
            MM_NORTEL_MPXAC_WAVEIN            : Result.Product := 'MPX Audio Card Wave Input Device';
            MM_NORTEL_MPXAC_WAVEOUT           : Result.Product := 'MPX Audio Card Wave Output Device';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_APICOM                    :
        begin
            Result.Manufacturer := 'APICOM';
            Result.Product := 'Unmapped Product';
        end;
        MM_GRANDE                    :
        begin
            Result.Manufacturer := 'Grande Software';
            Result.Product := 'Unmapped Product';
        end;
        MM_ADDX                      :
        begin
            Result.Manufacturer := 'ADDX';
            case AMixerCaps.wPid of
            MM_ADDX_PCTV_DIGITALMIX           : Result.Product := 'MM_ADDX_PCTV_DIGITALMIX';
            MM_ADDX_PCTV_WAVEIN               : Result.Product := 'MM_ADDX_PCTV_WAVEIN';
            MM_ADDX_PCTV_WAVEOUT              : Result.Product := 'MM_ADDX_PCTV_WAVEOUT';
            MM_ADDX_PCTV_MIXER                : Result.Product := 'MM_ADDX_PCTV_MIXER';
            MM_ADDX_PCTV_AUX_CD               : Result.Product := 'MM_ADDX_PCTV_AUX_CD';
            MM_ADDX_PCTV_AUX_LINE             : Result.Product := 'MM_ADDX_PCTV_AUX_LINE';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_WILDCAT                   :
        begin
            Result.Manufacturer := 'Wildcat Canyon Software';
            case AMixerCaps.wPid of
            MM_WILDCAT_AUTOSCOREMIDIIN        :Result.Product := 'Autoscore';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_RHETOREX                  :
        begin
            Result.Manufacturer := 'Rhetorex Inc.';
            case AMixerCaps.wPid of
            MM_RHETOREX_WAVEIN                :Result.Product := 'WAVEIN ';
            MM_RHETOREX_WAVEOUT               :Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_BROOKTREE                 :
        begin
            Result.Manufacturer := 'Brooktree Corporation';
            case AMixerCaps.wPid of
            MM_BTV_WAVEIN                     : Result.Product := 'Brooktree PCM Wave Audio In';
            MM_BTV_WAVEOUT                    : Result.Product := 'Brooktree PCM Wave Audio Out';
            MM_BTV_MIDIIN                     : Result.Product := 'Brooktree MIDI In';
            MM_BTV_MIDIOUT                    : Result.Product := 'Brooktree MIDI out';
            MM_BTV_MIDISYNTH                  : Result.Product := 'Brooktree MIDI FM synth';
            MM_BTV_AUX_LINE                   : Result.Product := 'Brooktree Line Input';
            MM_BTV_AUX_MIC                    : Result.Product := 'Brooktree Microphone Input';
            MM_BTV_AUX_CD                     : Result.Product := 'Brooktree CD Input';
            MM_BTV_DIGITALIN                  : Result.Product := 'Brooktree PCM Wave in with subcode information';
            MM_BTV_DIGITALOUT                 : Result.Product := 'Brooktree PCM Wave out with subcode information';
            MM_BTV_MIDIWAVESTREAM             : Result.Product := 'Brooktree WaveStream';
            MM_BTV_MIXER                      : Result.Product := 'Brooktree WSS Mixer driver';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ENSONIQ                   :
        begin
            Result.Manufacturer := 'ENSONIQ Corporation';
            case AMixerCaps.wPid of
            MM_ENSONIQ_SOUNDSCAPE             : Result.Product := 'ENSONIQ Soundscape';
            MM_SOUNDSCAPE_WAVEOUT             : Result.Product := 'SOUNDSCAPE_WAVEOUT    ';
            MM_SOUNDSCAPE_WAVEOUT_AUX         : Result.Product := 'SOUNDSCAPE_WAVEOUT_AUX';
            MM_SOUNDSCAPE_WAVEIN              : Result.Product := 'SOUNDSCAPE_WAVEIN     ';
            MM_SOUNDSCAPE_MIDIOUT             : Result.Product := 'SOUNDSCAPE_MIDIOUT    ';
            MM_SOUNDSCAPE_MIDIIN              : Result.Product := 'SOUNDSCAPE_MIDIIN     ';
            MM_SOUNDSCAPE_SYNTH               : Result.Product := 'SOUNDSCAPE_SYNTH      ';
            MM_SOUNDSCAPE_MIXER               : Result.Product := 'SOUNDSCAPE_MIXER      ';
            MM_SOUNDSCAPE_AUX                 : Result.Product := 'SOUNDSCAPE_AUX        ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_FAST                      :
        begin
            Result.Manufacturer := 'FAST Multimedia AG';
            Result.Product := 'Unmapped Product';
        end;
        MM_NVIDIA                    :
        begin
            Result.Manufacturer := 'NVidia Corporation';
            case AMixerCaps.wPid of
            MM_NVIDIA_WAVEOUT                 :Result.Product := 'WAVEOUT ';
            MM_NVIDIA_WAVEIN                  :Result.Product := 'WAVEIN  ';
            MM_NVIDIA_MIDIOUT                 :Result.Product := 'MIDIOUT ';
            MM_NVIDIA_MIDIIN                  :Result.Product := 'MIDIIN  ';
            MM_NVIDIA_GAMEPORT                :Result.Product := 'GAMEPORT';
            MM_NVIDIA_MIXER                   :Result.Product := 'MIXER   ';
            MM_NVIDIA_AUX                     :Result.Product := 'AUX     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_OKSORI                    :
        begin
            Result.Manufacturer := 'OKSORI Co., Ltd.';
            case AMixerCaps.wPid of
            MM_OKSORI_BASE                    : Result.Product := 'Oksori Base';
            MM_OKSORI_OSR8_WAVEOUT            : Result.Product := 'Oksori 8bit Wave out';
            MM_OKSORI_OSR8_WAVEIN             : Result.Product := 'Oksori 8bit Wave in';
            MM_OKSORI_OSR16_WAVEOUT           : Result.Product := 'Oksori 16 bit Wave out';
            MM_OKSORI_OSR16_WAVEIN            : Result.Product := 'Oksori 16 bit Wave in';
            MM_OKSORI_FM_OPL4                 : Result.Product := 'Oksori FM Synth Yamaha OPL4';
            MM_OKSORI_MIX_MASTER              : Result.Product := 'Oksori DSP Mixer - Master Volume';
            MM_OKSORI_MIX_WAVE                : Result.Product := 'Oksori DSP Mixer - Wave Volume';
            MM_OKSORI_MIX_FM                  : Result.Product := 'Oksori DSP Mixer - FM Volume';
            MM_OKSORI_MIX_LINE                : Result.Product := 'Oksori DSP Mixer - Line Volume';
            MM_OKSORI_MIX_CD                  : Result.Product := 'Oksori DSP Mixer - CD Volume';
            MM_OKSORI_MIX_MIC                 : Result.Product := 'Oksori DSP Mixer - MIC Volume';
            MM_OKSORI_MIX_ECHO                : Result.Product := 'Oksori DSP Mixer - Echo Volume';
            MM_OKSORI_MIX_AUX1                : Result.Product := 'Oksori AD1848 - AUX1 Volume';
            MM_OKSORI_MIX_LINE1               : Result.Product := 'Oksori AD1848 - LINE1 Volume';
            MM_OKSORI_EXT_MIC1                : Result.Product := 'Oksori External - One Mic Connect';
            MM_OKSORI_EXT_MIC2                : Result.Product := 'Oksori External - Two Mic Connect';
            MM_OKSORI_MIDIOUT                 : Result.Product := 'Oksori MIDI Out Device';
            MM_OKSORI_MIDIIN                  : Result.Product := 'Oksori MIDI In Device';
            MM_OKSORI_MPEG_CDVISION           : Result.Product := 'Oksori CD-Vision MPEG Decoder';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DIACOUSTICS               :
        begin
            Result.Manufacturer := 'DiAcoustics, Inc.';
            case AMixerCaps.wPid of
            MM_DIACOUSTICS_DRUM_ACTION        : Result.Product := 'Drum Action';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_GULBRANSEN                :
        begin
            Result.Manufacturer := 'Gulbransen, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_KAY_ELEMETRICS            :
        begin
            Result.Manufacturer := 'Kay Elemetrics, Inc.';
            case AMixerCaps.wPid of
            MM_KAY_ELEMETRICS_CSL             : Result.Product := 'CSL         ';
            MM_KAY_ELEMETRICS_CSL_DAT         : Result.Product := 'CSL_DAT     ';
            MM_KAY_ELEMETRICS_CSL_4CHANNEL    : Result.Product := 'CSL_4CHANNEL';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CRYSTAL                   :
        begin
            Result.Manufacturer := 'Crystal Semiconductor Corporation';
            case AMixerCaps.wPid of
            MM_CRYSTAL_CS4232_WAVEIN          :Result.Product := 'CS4232_WAVEIN        ';
            MM_CRYSTAL_CS4232_WAVEOUT         :Result.Product := 'CS4232_WAVEOUT       ';
            MM_CRYSTAL_CS4232_WAVEMIXER       :Result.Product := 'CS4232_WAVEMIXER     ';
            MM_CRYSTAL_CS4232_WAVEAUX_AUX1    :Result.Product := 'CS4232_WAVEAUX_AUX1  ';
            MM_CRYSTAL_CS4232_WAVEAUX_AUX2    :Result.Product := 'CS4232_WAVEAUX_AUX2  ';
            MM_CRYSTAL_CS4232_WAVEAUX_LINE    :Result.Product := 'CS4232_WAVEAUX_LINE  ';
            MM_CRYSTAL_CS4232_WAVEAUX_MONO    :Result.Product := 'CS4232_WAVEAUX_MONO  ';
            MM_CRYSTAL_CS4232_WAVEAUX_MASTER  :Result.Product := 'CS4232_WAVEAUX_MASTER';
            MM_CRYSTAL_CS4232_MIDIIN          :Result.Product := 'CS4232_MIDIIN        ';
            MM_CRYSTAL_CS4232_MIDIOUT         :Result.Product := 'CS4232_MIDIOUT       ';
            MM_CRYSTAL_CS4232_INPUTGAIN_AUX1  :Result.Product := 'CS4232_INPUTGAIN_AUX1';
            MM_CRYSTAL_CS4232_INPUTGAIN_LOOP  :Result.Product := 'CS4232_INPUTGAIN_LOOP';
            MM_CRYSTAL_SOUND_FUSION_WAVEIN    :Result.Product := 'SOUND_FUSION_WAVEIN  ';
            MM_CRYSTAL_SOUND_FUSION_WAVEOUT   :Result.Product := 'SOUND_FUSION_WAVEOUT ';
            MM_CRYSTAL_SOUND_FUSION_MIXER     :Result.Product := 'SOUND_FUSION_MIXER   ';
            MM_CRYSTAL_SOUND_FUSION_MIDIIN    :Result.Product := 'SOUND_FUSION_MIDIIN  ';
            MM_CRYSTAL_SOUND_FUSION_MIDIOUT   :Result.Product := 'SOUND_FUSION_MIDIOUT ';
            MM_CRYSTAL_SOUND_FUSION_JOYSTICK  :Result.Product := 'SOUND_FUSION_JOYSTICK';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SPLASH_STUDIOS            :
        begin
            Result.Manufacturer := 'Splash Studios';
            Result.Product := 'Unmapped Product';
        end;
        MM_QUARTERDECK               :
        begin
            Result.Manufacturer := 'Quarterdeck Corporation';
            case AMixerCaps.wPid of
            MM_QUARTERDECK_LHWAVEIN           : Result.Product := 'Quarterdeck L&H Codec Wave In';
            MM_QUARTERDECK_LHWAVEOUT          : Result.Product := 'Quarterdeck L&H Codec Wave Out';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TDK                       :
        begin
            Result.Manufacturer := 'TDK Corporation';
            case AMixerCaps.wPid of
            MM_TDK_MW_MIDI_SYNTH              :Result.Product := 'MW_MIDI_SYNTH  ';
            MM_TDK_MW_MIDI_IN                 :Result.Product := 'MW_MIDI_IN     ';
            MM_TDK_MW_MIDI_OUT                :Result.Product := 'MW_MIDI_OUT    ';
            MM_TDK_MW_WAVE_IN                 :Result.Product := 'MW_WAVE_IN     ';
            MM_TDK_MW_WAVE_OUT                :Result.Product := 'MW_WAVE_OUT    ';
            MM_TDK_MW_AUX                     :Result.Product := 'MW_AUX         ';
            MM_TDK_MW_MIXER                   :Result.Product := 'MW_MIXER       ';
            MM_TDK_MW_AUX_MASTER              :Result.Product := 'MW_AUX_MASTER  ';
            MM_TDK_MW_AUX_BASS                :Result.Product := 'MW_AUX_BASS    ';
            MM_TDK_MW_AUX_TREBLE              :Result.Product := 'MW_AUX_TREBLE  ';
            MM_TDK_MW_AUX_MIDI_VOL            :Result.Product := 'MW_AUX_MIDI_VOL';
            MM_TDK_MW_AUX_WAVE_VOL            :Result.Product := 'MW_AUX_WAVE_VOL';
            MM_TDK_MW_AUX_WAVE_RVB            :Result.Product := 'MW_AUX_WAVE_RVB';
            MM_TDK_MW_AUX_WAVE_CHR            :Result.Product := 'MW_AUX_WAVE_CHR';
            MM_TDK_MW_AUX_VOL                 :Result.Product := 'MW_AUX_VOL     ';
            MM_TDK_MW_AUX_RVB                 :Result.Product := 'MW_AUX_RVB     ';
            MM_TDK_MW_AUX_CHR                 :Result.Product := 'MW_AUX_CHR     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DIGITAL_AUDIO_LABS        :
        begin
            Result.Manufacturer := 'Digital Audio Labs, Inc.';
            case AMixerCaps.wPid of
            MM_DIGITAL_AUDIO_LABS_TC          : Result.Product := 'AUDIO_LABS_TC   ';
            MM_DIGITAL_AUDIO_LABS_DOC         : Result.Product := 'AUDIO_LABS_DOC  ';
            MM_DIGITAL_AUDIO_LABS_V8          : Result.Product := 'AUDIO_LABS_V8   ';
            MM_DIGITAL_AUDIO_LABS_CPRO        : Result.Product := 'AUDIO_LABS_CPRO ';
            MM_DIGITAL_AUDIO_LABS_VP          : Result.Product := 'AUDIO_LABS_VP   ';
            MM_DIGITAL_AUDIO_LABS_CDLX        : Result.Product := 'AUDIO_LABS_CDLX ';
            MM_DIGITAL_AUDIO_LABS_CTDIF       : Result.Product := 'AUDIO_LABS_CTDIF';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SEERSYS                   :
        begin
            Result.Manufacturer := 'Seer Systems, Inc.';
            case AMixerCaps.wPid of
            MM_SEERSYS_SEERSYNTH              :Result.Product := 'SEERSYNTH   ';
            MM_SEERSYS_SEERWAVE               :Result.Product := 'SEERWAVE    ';
            MM_SEERSYS_SEERMIX                :Result.Product := 'SEERMIX     ';
            MM_SEERSYS_WAVESYNTH              :Result.Product := 'WAVESYNTH   ';
            MM_SEERSYS_WAVESYNTH_WG           :Result.Product := 'WAVESYNTH_WG';
            MM_SEERSYS_REALITY                :Result.Product := 'REALITY     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_PICTURETEL                :
        begin
            Result.Manufacturer := 'PictureTel Corporation';
            Result.Product := 'Unmapped Product';
        end;
        MM_ATT_MICROELECTRONICS      :
        begin
            Result.Manufacturer := 'AT&T Microelectronics';
            Result.Product := 'Unmapped Product';
        end;
        MM_OSPREY                    :
        begin
            Result.Manufacturer := 'Osprey Technologies, Inc.';
            case AMixerCaps.wPid of
            MM_OSPREY_1000WAVEIN              :Result.Product := '1000WAVEIN ';
            MM_OSPREY_1000WAVEOUT             :Result.Product := '1000WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MEDIATRIX                 :
        begin
            Result.Manufacturer := 'Mediatrix Peripherals';
            Result.Product := 'Unmapped Product';
        end;
        MM_SOUNDESIGNS               :
        begin
            Result.Manufacturer := 'SounDesignS M.C.S. Ltd.';
            case AMixerCaps.wPid of
            MM_SOUNDESIGNS_WAVEIN             :Result.Product := 'WAVEIN ';
            MM_SOUNDESIGNS_WAVEOUT            :Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ALDIGITAL                 :
        begin
            Result.Manufacturer := 'A.L. Digital Ltd.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SPECTRUM_SIGNAL_PROCESSING:
        begin
            Result.Manufacturer := 'Spectrum Signal Processing, Inc.';
            case AMixerCaps.wPid of
            MM_SSP_SNDFESWAVEIN               : Result.Product := 'Sound Festa Wave In Device';
            MM_SSP_SNDFESWAVEOUT              : Result.Product := 'Sound Festa Wave Out Device';
            MM_SSP_SNDFESMIDIIN               : Result.Product := 'Sound Festa MIDI In Device';
            MM_SSP_SNDFESMIDIOUT              : Result.Product := 'Sound Festa MIDI Out Device';
            MM_SSP_SNDFESSYNTH                : Result.Product := 'Sound Festa MIDI Synth Device';
            MM_SSP_SNDFESMIX                  : Result.Product := 'Sound Festa Mixer Device';
            MM_SSP_SNDFESAUX                  : Result.Product := 'Sound Festa Auxilliary Device';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ECS                       :
        begin
            Result.Manufacturer := 'Electronic Courseware Systems, Inc.';
            case AMixerCaps.wPid of
            MM_ECS_AADF_MIDI_IN               :Result.Product := 'AADF_MIDI_IN     ';
            MM_ECS_AADF_MIDI_OUT              :Result.Product := 'AADF_MIDI_OUT    ';
            MM_ECS_AADF_WAVE2MIDI_IN          :Result.Product := 'AADF_WAVE2MIDI_IN';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_AMD                       :
        begin
            Result.Manufacturer := 'AMD';
            case AMixerCaps.wPid of
            MM_AMD_INTERWAVE_WAVEIN           :Result.Product := 'INTERWAVE_WAVEIN         ';
            MM_AMD_INTERWAVE_WAVEOUT          :Result.Product := 'INTERWAVE_WAVEOUT        ';
            MM_AMD_INTERWAVE_SYNTH            :Result.Product := 'INTERWAVE_SYNTH          ';
            MM_AMD_INTERWAVE_MIXER1           :Result.Product := 'INTERWAVE_MIXER1         ';
            MM_AMD_INTERWAVE_MIXER2           :Result.Product := 'INTERWAVE_MIXER2         ';
            MM_AMD_INTERWAVE_JOYSTICK         :Result.Product := 'INTERWAVE_JOYSTICK       ';
            MM_AMD_INTERWAVE_EX_CD            :Result.Product := 'INTERWAVE_EX_CD          ';
            MM_AMD_INTERWAVE_MIDIIN           :Result.Product := 'INTERWAVE_MIDIIN         ';
            MM_AMD_INTERWAVE_MIDIOUT          :Result.Product := 'INTERWAVE_MIDIOUT        ';
            MM_AMD_INTERWAVE_AUX1             :Result.Product := 'INTERWAVE_AUX1           ';
            MM_AMD_INTERWAVE_AUX2             :Result.Product := 'INTERWAVE_AUX2           ';
            MM_AMD_INTERWAVE_AUX_MIC          :Result.Product := 'INTERWAVE_AUX_MIC        ';
            MM_AMD_INTERWAVE_AUX_CD           :Result.Product := 'INTERWAVE_AUX_CD         ';
            MM_AMD_INTERWAVE_MONO_IN          :Result.Product := 'INTERWAVE_MONO_IN        ';
            MM_AMD_INTERWAVE_MONO_OUT         :Result.Product := 'INTERWAVE_MONO_OUT       ';
            MM_AMD_INTERWAVE_EX_TELEPHONY     :Result.Product := 'INTERWAVE_EX_TELEPHONY   ';
            MM_AMD_INTERWAVE_WAVEOUT_BASE     :Result.Product := 'INTERWAVE_WAVEOUT_BASE   ';
            MM_AMD_INTERWAVE_WAVEOUT_TREBLE   :Result.Product := 'INTERWAVE_WAVEOUT_TREBLE ';
            MM_AMD_INTERWAVE_STEREO_ENHANCED  :Result.Product := 'INTERWAVE_STEREO_ENHANCED';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_COREDYNAMICS              :
        begin
            Result.Manufacturer := 'Core Dynamics';
            case AMixerCaps.wPid of
            MM_COREDYNAMICS_DYNAMIXHR           :Result.Product := 'DynaMax Hi-Rez';
            MM_COREDYNAMICS_DYNASONIX_SYNTH     :Result.Product := 'DynaSonix';
            MM_COREDYNAMICS_DYNASONIX_MIDI_IN   :Result.Product := 'DYNASONIX_MIDI_IN  ';
            MM_COREDYNAMICS_DYNASONIX_MIDI_OUT  :Result.Product := 'DYNASONIX_MIDI_OUT ';
            MM_COREDYNAMICS_DYNASONIX_WAVE_IN   :Result.Product := 'DYNASONIX_WAVE_IN  ';
            MM_COREDYNAMICS_DYNASONIX_WAVE_OUT  :Result.Product := 'DYNASONIX_WAVE_OUT ';
            MM_COREDYNAMICS_DYNASONIX_AUDIO_IN  :Result.Product := 'DYNASONIX_AUDIO_IN ';
            MM_COREDYNAMICS_DYNASONIX_AUDIO_OUT :Result.Product := 'DYNASONIX_AUDIO_OUT';
            MM_COREDYNAMICS_DYNAGRAFX_VGA       :Result.Product := 'DynaGrfx';
            MM_COREDYNAMICS_DYNAGRAFX_WAVE_IN   :Result.Product := 'DYNAGRAFX_WAVE_IN ';
            MM_COREDYNAMICS_DYNAGRAFX_WAVE_OUT  :Result.Product := 'DYNAGRAFX_WAVE_OUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CANAM                     :
        begin
            Result.Manufacturer := 'CANAM Computers';
            case AMixerCaps.wPid of
            MM_CANAM_CBXWAVEOUT               :Result.Product := 'CBXWAVEOUT';
            MM_CANAM_CBXWAVEIN                :Result.Product := 'CBXWAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SOFTSOUND                 :
        begin
            Result.Manufacturer := 'Softsound, Ltd.';
            case AMixerCaps.wPid of
            MM_SOFTSOUND_CODEC                :Result.Product := 'CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NORRIS                    :
        begin
            Result.Manufacturer := 'Norris Communications, Inc.';
            case AMixerCaps.wPid of
            MM_NORRIS_VOICELINK               :Result.Product := 'VOICELINK';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DDD                       :
        begin
            Result.Manufacturer := 'Danka Data Devices';
            case AMixerCaps.wPid of
            MM_DDD_MIDILINK_MIDIIN            :Result.Product := 'MIDILINK_MIDIIN ';
            MM_DDD_MIDILINK_MIDIOUT           :Result.Product := 'MIDILINK_MIDIOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_EUPHONICS                 :
        begin
            Result.Manufacturer := 'EuPhonics';
            case AMixerCaps.wPid of
            MM_EUPHONICS_AUX_CD               :Result.Product := 'AUX_CD        ';
            MM_EUPHONICS_AUX_LINE             :Result.Product := 'AUX_LINE      ';
            MM_EUPHONICS_AUX_MASTER           :Result.Product := 'AUX_MASTER    ';
            MM_EUPHONICS_AUX_MIC              :Result.Product := 'AUX_MIC       ';
            MM_EUPHONICS_AUX_MIDI             :Result.Product := 'AUX_MIDI      ';
            MM_EUPHONICS_AUX_WAVE             :Result.Product := 'AUX_WAVE      ';
            MM_EUPHONICS_FMSYNTH_MONO         :Result.Product := 'FMSYNTH_MONO  ';
            MM_EUPHONICS_FMSYNTH_STEREO       :Result.Product := 'FMSYNTH_STEREO';
            MM_EUPHONICS_MIDIIN               :Result.Product := 'MIDIIN        ';
            MM_EUPHONICS_MIDIOUT              :Result.Product := 'MIDIOUT       ';
            MM_EUPHONICS_MIXER                :Result.Product := 'MIXER         ';
            MM_EUPHONICS_WAVEIN               :Result.Product := 'WAVEIN        ';
            MM_EUPHONICS_WAVEOUT              :Result.Product := 'WAVEOUT       ';
            MM_EUPHONICS_EUSYNTH              :Result.Product := 'EUSYNTH       ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_PRECEPT                   :
        begin
            Result.Manufacturer := 'Precept Software, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_CRYSTAL_NET               :
        begin
            Result.Manufacturer := 'Crystal Net Corporation';
            case AMixerCaps.wPid of
            CRYSTAL_NET_SFM_CODEC             :Result.Product := 'SFM_CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CHROMATIC                 :
        begin
            Result.Manufacturer := 'Chromatic Research, Inc.';
            case AMixerCaps.wPid of
            MM_CHROMATIC_M1                   : Result.Product := 'M1            ';
            MM_CHROMATIC_M1_WAVEIN            : Result.Product := 'M1_WAVEIN     ';
            MM_CHROMATIC_M1_WAVEOUT           : Result.Product := 'M1_WAVEOUT    ';
            MM_CHROMATIC_M1_FMSYNTH           : Result.Product := 'M1_FMSYNTH    ';
            MM_CHROMATIC_M1_MIXER             : Result.Product := 'M1_MIXER      ';
            MM_CHROMATIC_M1_AUX               : Result.Product := 'M1_AUX        ';
            MM_CHROMATIC_M1_AUX_CD            : Result.Product := 'M1_AUX_CD     ';
            MM_CHROMATIC_M1_MIDIIN            : Result.Product := 'M1_MIDIIN     ';
            MM_CHROMATIC_M1_MIDIOUT           : Result.Product := 'M1_MIDIOUT    ';
            MM_CHROMATIC_M1_WTSYNTH           : Result.Product := 'M1_WTSYNTH    ';
            MM_CHROMATIC_M1_MPEGWAVEIN        : Result.Product := 'M1_MPEGWAVEIN ';
            MM_CHROMATIC_M1_MPEGWAVEOUT       : Result.Product := 'M1_MPEGWAVEOUT';
            MM_CHROMATIC_M2                   : Result.Product := 'M2            ';
            MM_CHROMATIC_M2_WAVEIN            : Result.Product := 'M2_WAVEIN     ';
            MM_CHROMATIC_M2_WAVEOUT           : Result.Product := 'M2_WAVEOUT    ';
            MM_CHROMATIC_M2_FMSYNTH           : Result.Product := 'M2_FMSYNTH    ';
            MM_CHROMATIC_M2_MIXER             : Result.Product := 'M2_MIXER      ';
            MM_CHROMATIC_M2_AUX               : Result.Product := 'M2_AUX        ';
            MM_CHROMATIC_M2_AUX_CD            : Result.Product := 'M2_AUX_CD     ';
            MM_CHROMATIC_M2_MIDIIN            : Result.Product := 'M2_MIDIIN     ';
            MM_CHROMATIC_M2_MIDIOUT           : Result.Product := 'M2_MIDIOUT    ';
            MM_CHROMATIC_M2_WTSYNTH           : Result.Product := 'M2_WTSYNTH    ';
            MM_CHROMATIC_M2_MPEGWAVEIN        : Result.Product := 'M2_MPEGWAVEIN ';
            MM_CHROMATIC_M2_MPEGWAVEOUT       : Result.Product := 'M2_MPEGWAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VOICEINFO                 :
        begin
            Result.Manufacturer := 'Voice Information Systems, Inc.';
        end;
        MM_VIENNASYS                 :
        begin
            Result.Manufacturer := 'Vienna Systems';
            case AMixerCaps.wPid of
            MM_VIENNASYS_TSP_WAVE_DRIVER      :Result.Product := 'TSP_WAVE_DRIVER';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CONNECTIX                 :
        begin
            Result.Manufacturer := 'Connectix Corporation';
            case AMixerCaps.wPid of
            MM_CONNECTIX_VIDEC_CODEC          :Result.Product := 'VIDEC_CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_GADGETLABS                :
        begin
            Result.Manufacturer := 'Gadget Labs LLC';
            case AMixerCaps.wPid of
            MM_GADGETLABS_WAVE44_WAVEIN       :Result.Product := 'WAVE44_WAVEIN ';
            MM_GADGETLABS_WAVE44_WAVEOUT      :Result.Product := 'WAVE44_WAVEOUT';
            MM_GADGETLABS_WAVE42_WAVEIN       :Result.Product := 'WAVE42_WAVEIN ';
            MM_GADGETLABS_WAVE42_WAVEOUT      :Result.Product := 'WAVE42_WAVEOUT';
            MM_GADGETLABS_WAVE4_MIDIIN        :Result.Product := 'WAVE4_MIDIIN  ';
            MM_GADGETLABS_WAVE4_MIDIOUT       :Result.Product := 'WAVE4_MIDIOUT ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_FRONTIER                  :
        begin
            Result.Manufacturer := 'Frontier Design Group LLC';
            case AMixerCaps.wPid of
            MM_FRONTIER_WAVECENTER_MIDIIN     :Result.Product := 'WaveCenter';
            MM_FRONTIER_WAVECENTER_MIDIOUT    :Result.Product := 'WAVECENTER_MIDIOUT';
            MM_FRONTIER_WAVECENTER_WAVEIN     :Result.Product := 'WAVECENTER_WAVEIN ';
            MM_FRONTIER_WAVECENTER_WAVEOUT    :Result.Product := 'WAVECENTER_WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VIONA                     :
        begin
            Result.Manufacturer := 'Viona Development GmbH';
            case AMixerCaps.wPid of
            MM_VIONA_QVINPCI_MIXER            : Result.Product := 'Q-Motion PCI II/Bravado 2000';
            MM_VIONA_QVINPCI_WAVEIN           : Result.Product := 'QVINPCI_WAVEIN';
            MM_VIONAQVINPCI_WAVEOUT           : Result.Product := 'QVINPCI_WAVEOUT';
            MM_VIONA_BUSTER_MIXER             : Result.Product := 'Buster';
            MM_VIONA_CINEMASTER_MIXER         : Result.Product := 'Cinemaster';
            MM_VIONA_CONCERTO_MIXER           : Result.Product := 'Concerto';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CASIO                     :
        begin
            Result.Manufacturer := 'Casio Computer Co., LTD';
            case AMixerCaps.wPid of
            MM_CASIO_WP150_MIDIOUT            :Result.Product := 'wp150';
            MM_CASIO_WP150_MIDIIN             :Result.Product := 'WP150_MIDIIN';
            MM_CASIO_LSG_MIDIOUT              :Result.Product := 'LSG_MIDIOUT ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DIAMONDMM                 :
        begin
            Result.Manufacturer := 'Diamond Multimedia';
            case AMixerCaps.wPid of
            MM_DIMD_PLATFORM                  :Result.Product := 'Freedom Audio';
            MM_DIMD_DIRSOUND                  :Result.Product := 'DIRSOUND   ';
            MM_DIMD_VIRTMPU                   :Result.Product := 'VIRTMPU    ';
            MM_DIMD_VIRTSB                    :Result.Product := 'VIRTSB     ';
            MM_DIMD_VIRTJOY                   :Result.Product := 'VIRTJOY    ';
            MM_DIMD_WAVEIN                    :Result.Product := 'WAVEIN     ';
            MM_DIMD_WAVEOUT                   :Result.Product := 'WAVEOUT    ';
            MM_DIMD_MIDIIN                    :Result.Product := 'MIDIIN     ';
            MM_DIMD_MIDIOUT                   :Result.Product := 'MIDIOUT    ';
            MM_DIMD_AUX_LINE                  :Result.Product := 'AUX_LINE   ';
            MM_DIMD_MIXER                     :Result.Product := 'MIXER      ';
            MM_DIMD_WSS_WAVEIN                :Result.Product := 'WSS_WAVEIN ';
            MM_DIMD_WSS_WAVEOUT               :Result.Product := 'WSS_WAVEOUT';
            MM_DIMD_WSS_MIXER                 :Result.Product := 'WSS_MIXER  ';
            MM_DIMD_WSS_AUX                   :Result.Product := 'WSS_AUX    ';
            MM_DIMD_WSS_SYNTH                 :Result.Product := 'WSS_SYNTH';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_S3                        :
        begin
            Result.Manufacturer := 'S3';
            case AMixerCaps.wPid of
            MM_S3_WAVEOUT                     :Result.Product := 'WAVEOUT';
            MM_S3_WAVEIN                      :Result.Product := 'WAVEIN ';
            MM_S3_MIDIOUT                     :Result.Product := 'MIDIOUT';
            MM_S3_MIDIIN                      :Result.Product := 'MIDIIN ';
            MM_S3_FMSYNTH                     :Result.Product := 'FMSYNTH';
            MM_S3_MIXER                       :Result.Product := 'MIXER  ';
            MM_S3_AUX                         :Result.Product := 'AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DVISION                   :
        begin
            Result.Manufacturer := 'D-Vision Systems, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_NETSCAPE                  :
        begin
            Result.Manufacturer := 'Netscape Communications';
            Result.Product := 'Unmapped Product';
        end;
        MM_SOUNDSPACE                :
        begin
            Result.Manufacturer := 'Soundspace Audio';
            Result.Product := 'Unmapped Product';
        end;
        MM_VANKOEVERING              :
        begin
            Result.Manufacturer := 'VanKoevering Company';
            case AMixerCaps.wPid of
            MM_VKC_MPU401_MIDIIN              : Result.Product := 'MPU401_MIDIIN ';
            MM_VKC_SERIAL_MIDIIN              : Result.Product := 'SERIAL_MIDIIN ';
            MM_VKC_MPU401_MIDIOUT             : Result.Product := 'MPU401_MIDIOUT';
            MM_VKC_SERIAL_MIDIOUT             : Result.Product := 'SERIAL_MIDIOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QTEAM                     :
        begin
            Result.Manufacturer := 'Q-Team';
            Result.Product := 'Unmapped Product';
        end;
        MM_ZEFIRO                    :
        begin
            Result.Manufacturer := 'Zefiro Acoustics';
            case AMixerCaps.wPid of
            MM_ZEFIRO_ZA2                     :Result.Product := 'ZA2';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_STUDER                    :
        begin
            Result.Manufacturer := 'Studer Professional Audio AG';
            Result.Product := 'Unmapped Product';
        end;
        MM_FRAUNHOFER_IIS            :
        begin
            Result.Manufacturer := 'Fraunhofer IIS';
            case AMixerCaps.wPid of
            MM_FHGIIS_MPEGLAYER3              :Result.Product := 'MPEGLAYER3';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QUICKNET                  :
        begin
            Result.Manufacturer := 'Quicknet Technologies';
            case AMixerCaps.wPid of
            MM_QUICKNET_PJWAVEIN              :Result.Product := 'PJWAVEIN ';
            MM_QUICKNET_PJWAVEOUT             :Result.Product := 'PJWAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ALARIS                    :
        begin
            Result.Manufacturer := 'Alaris, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SICRESOURCE               :
        begin
            Result.Manufacturer := 'SIC Resource Inc.';
            case AMixerCaps.wPid of
            MM_SICRESOURCE_SSO3D              :Result.Product := 'SSO3D  ';
            MM_SICRESOURCE_SSOW3DI            :Result.Product := 'SSOW3DI';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NEOMAGIC                  :
        begin
            Result.Manufacturer := 'NeoMagic Corporation';
            case AMixerCaps.wPid of
            MM_NEOMAGIC_SYNTH                 :Result.Product := 'SYNTH        ';
            MM_NEOMAGIC_WAVEOUT               :Result.Product := 'WAVEOUT      ';
            MM_NEOMAGIC_WAVEIN                :Result.Product := 'WAVEIN       ';
            MM_NEOMAGIC_MIDIOUT               :Result.Product := 'MIDIOUT      ';
            MM_NEOMAGIC_MIDIIN                :Result.Product := 'MIDIIN       ';
            MM_NEOMAGIC_AUX                   :Result.Product := 'AUX          ';
            MM_NEOMAGIC_MW3DX_WAVEOUT         :Result.Product := 'MW3DX_WAVEOUT';
            MM_NEOMAGIC_MW3DX_WAVEIN          :Result.Product := 'MW3DX_WAVEIN ';
            MM_NEOMAGIC_MW3DX_MIDIOUT         :Result.Product := 'MW3DX_MIDIOUT';
            MM_NEOMAGIC_MW3DX_MIDIIN          :Result.Product := 'MW3DX_MIDIIN ';
            MM_NEOMAGIC_MW3DX_FMSYNTH         :Result.Product := 'MW3DX_FMSYNTH';
            MM_NEOMAGIC_MW3DX_GMSYNTH         :Result.Product := 'MW3DX_GMSYNTH';
            MM_NEOMAGIC_MW3DX_MIXER           :Result.Product := 'MW3DX_MIXER  ';
            MM_NEOMAGIC_MW3DX_AUX             :Result.Product := 'MW3DX_AUX    ';
            MM_NEOMAGIC_MWAVE_WAVEOUT         :Result.Product := 'MWAVE_WAVEOUT';
            MM_NEOMAGIC_MWAVE_WAVEIN          :Result.Product := 'MWAVE_WAVEIN ';
            MM_NEOMAGIC_MWAVE_MIDIOUT         :Result.Product := 'MWAVE_MIDIOUT';
            MM_NEOMAGIC_MWAVE_MIDIIN          :Result.Product := 'MWAVE_MIDIIN ';
            MM_NEOMAGIC_MWAVE_MIXER           :Result.Product := 'MWAVE_MIXER  ';
            MM_NEOMAGIC_MWAVE_AUX             :Result.Product := 'MWAVE_AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MERGING_TECHNOLOGIES      :
        begin
            Result.Manufacturer := 'Merging Technologies S.A.';
            case AMixerCaps.wPid of
            MM_MERGING_MPEGL3                 :Result.Product := 'MPEGL3';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_XIRLINK                   :
        begin
            Result.Manufacturer := 'Xirlink, Inc.';
            case AMixerCaps.wPid of
            MM_XIRLINK_VISIONLINK             :Result.Product := 'VISIONLINK';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_COLORGRAPH                :
        begin
            Result.Manufacturer := 'Colorgraph (UK) Ltd';
            Result.Product := 'Unmapped Product';
        end;
        MM_OTI                       :
        begin
            Result.Manufacturer := 'Oak Technology, Inc.';
            case AMixerCaps.wPid of
            MM_OTI_611WAVEIN                  :Result.Product := '611WAVEIN ';
            MM_OTI_611WAVEOUT                 :Result.Product := '611WAVEOUT';
            MM_OTI_611MIXER                   :Result.Product := '611MIXER  ';
            MM_OTI_611MIDIN                   :Result.Product := '611MIDIN  ';
            MM_OTI_611MIDIOUT                 :Result.Product := '611MIDIOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_AUREAL                    :
        begin
            Result.Manufacturer := 'Aureal Semiconductor';
            case AMixerCaps.wPid of
            MM_AUREAL_AU8820                  :Result.Product := 'AU8820 ';
            MM_AU8820_SYNTH                   :Result.Product := 'SYNTH  ';
            MM_AU8820_WAVEOUT                 :Result.Product := 'WAVEOUT';
            MM_AU8820_WAVEIN                  :Result.Product := 'WAVEIN ';
            MM_AU8820_MIXER                   :Result.Product := 'MIXER  ';
            MM_AU8820_AUX                     :Result.Product := 'AUX    ';
            MM_AU8820_MIDIOUT                 :Result.Product := 'MIDIOUT';
            MM_AU8820_MIDIIN                  :Result.Product := 'MIDIIN ';
            MM_AUREAL_AU8830                  :Result.Product := 'AU8830 ';
            MM_AU8830_SYNTH                   :Result.Product := 'SYNTH  ';
            MM_AU8830_WAVEOUT                 :Result.Product := 'WAVEOUT';
            MM_AU8830_WAVEIN                  :Result.Product := 'WAVEIN ';
            MM_AU8830_MIXER                   :Result.Product := 'MIXER  ';
            MM_AU8830_AUX                     :Result.Product := 'AUX    ';
            MM_AU8830_MIDIOUT                 :Result.Product := 'MIDIOUT';
            MM_AU8830_MIDIIN                  :Result.Product := 'MIDIIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VIVO                      :
        begin
            Result.Manufacturer := 'Vivo Software';
            case AMixerCaps.wPid of
            MM_VIVO_AUDIO_CODEC               :Result.Product := 'AUDIO_CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SHARP                     :
        begin
            Result.Manufacturer := 'Sharp';
            case AMixerCaps.wPid of
            MM_SHARP_MDC_MIDI_SYNTH           :Result.Product := 'MDC_MIDI_SYNTH  ';
            MM_SHARP_MDC_MIDI_IN              :Result.Product := 'MDC_MIDI_IN     ';
            MM_SHARP_MDC_MIDI_OUT             :Result.Product := 'MDC_MIDI_OUT    ';
            MM_SHARP_MDC_WAVE_IN              :Result.Product := 'MDC_WAVE_IN     ';
            MM_SHARP_MDC_WAVE_OUT             :Result.Product := 'MDC_WAVE_OUT    ';
            MM_SHARP_MDC_AUX                  :Result.Product := 'MDC_AUX         ';
            MM_SHARP_MDC_MIXER                :Result.Product := 'MDC_MIXER       ';
            MM_SHARP_MDC_AUX_MASTER           :Result.Product := 'MDC_AUX_MASTER  ';
            MM_SHARP_MDC_AUX_BASS             :Result.Product := 'MDC_AUX_BASS    ';
            MM_SHARP_MDC_AUX_TREBLE           :Result.Product := 'MDC_AUX_TREBLE  ';
            MM_SHARP_MDC_AUX_MIDI_VOL         :Result.Product := 'MDC_AUX_MIDI_VOL';
            MM_SHARP_MDC_AUX_WAVE_VOL         :Result.Product := 'MDC_AUX_WAVE_VOL';
            MM_SHARP_MDC_AUX_WAVE_RVB         :Result.Product := 'MDC_AUX_WAVE_RVB';
            MM_SHARP_MDC_AUX_WAVE_CHR         :Result.Product := 'MDC_AUX_WAVE_CHR';
            MM_SHARP_MDC_AUX_VOL              :Result.Product := 'MDC_AUX_VOL     ';
            MM_SHARP_MDC_AUX_RVB              :Result.Product := 'MDC_AUX_RVB     ';
            MM_SHARP_MDC_AUX_CHR              :Result.Product := 'MDC_AUX_CHR     ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LUCENT                    :
        begin
            Result.Manufacturer := 'Lucent Technologies';
            case AMixerCaps.wPid of
            MM_LUCENT_ACM_G723                :Result.Product := 'ACM_G723';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ATT                       :
        begin
            Result.Manufacturer := 'AT&T Labs, Inc.';
            case AMixerCaps.wPid of
            MM_ATT_G729A                      :Result.Product := 'G729A';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SUNCOM                    :
        begin
            Result.Manufacturer := 'Sun Communications, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SORVIS                    :
        begin
            Result.Manufacturer := 'Sorenson Vision';
            Result.Product := 'Unmapped Product';
        end;
        MM_INVISION                  :
        begin
            Result.Manufacturer := 'InVision Interactive';
            Result.Product := 'Unmapped Product';
        end;
        MM_BERKOM                    :
        begin
            Result.Manufacturer := 'Deutsche Telekom Berkom GmbH';
            Result.Product := 'Unmapped Product';
        end;
        MM_MARIAN                    :
        begin
            Result.Manufacturer := 'Marian GbR Leipzig';
            case AMixerCaps.wPid of
            MM_MARIAN_ARC44WAVEIN             :Result.Product := 'ARC44WAVEIN    ';
            MM_MARIAN_ARC44WAVEOUT            :Result.Product := 'ARC44WAVEOUT   ';
            MM_MARIAN_PRODIF24WAVEIN          :Result.Product := 'PRODIF24WAVEIN ';
            MM_MARIAN_PRODIF24WAVEOUT         :Result.Product := 'PRODIF24WAVEOUT';
            MM_MARIAN_ARC88WAVEIN             :Result.Product := 'ARC88WAVEIN    ';
            MM_MARIAN_ARC88WAVEOUT            :Result.Product := 'ARC88WAVEOUT   ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DPSINC                    :
        begin
            Result.Manufacturer := 'Digital Processing Systems, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_BCB                       :
        begin
            Result.Manufacturer := 'BCB Holdings Inc.';
            case AMixerCaps.wPid of
            MM_BCB_NETBOARD_10                :Result.Product := 'NETBOARD_10';
            MM_BCB_TT75_10                    :Result.Product := 'TT75_10    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MOTIONPIXELS              :
        begin
            Result.Manufacturer := 'Motion Pixels';
            case AMixerCaps.wPid of
            MM_MOTIONPIXELS_MVI2              :Result.Product := 'MVI2';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QDESIGN                   :
        begin
            Result.Manufacturer := 'QDesign Corporation';
            case AMixerCaps.wPid of
            MM_QDESIGN_ACM_MPEG               :Result.Product := 'ACM_MPEG         ';
            MM_QDESIGN_ACM_QDESIGN_MUSIC      :Result.Product := 'ACM_QDESIGN_MUSIC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_NMP                       :
        begin
            Result.Manufacturer := 'Nokia Mobile Phones';
            case AMixerCaps.wPid of
            MM_NMP_CCP_WAVEIN                 :Result.Product := 'CCP_WAVEIN ';
            MM_NMP_CCP_WAVEOUT                :Result.Product := 'CCP_WAVEOUT';
            MM_NMP_ACM_AMR                    :Result.Product := 'ACM_AMR    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DATAFUSION                :
        begin
            Result.Manufacturer := 'DataFusion Systems (Pty) (Ltd)';
            case AMixerCaps.wPid of
            MM_DF_ACM_G726                    :Result.Product := 'ACM_G726  ';
            MM_DF_ACM_GSM610                  :Result.Product := 'ACM_GSM610';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DUCK                      :
        begin
            Result.Manufacturer := 'The Duck Corporation';
            Result.Product := 'Unmapped Product';
        end;
        MM_FTR                       :
        begin
            Result.Manufacturer := 'Future Technology Resources Pty Ltd';
            case AMixerCaps.wPid of
            MM_FTR_ENCODER_WAVEIN             :Result.Product := 'ENCODER_WAVEIN';
            MM_FTR_ACM                        :Result.Product := 'ACM           ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_BERCOS                    :
        begin
            Result.Manufacturer := 'BERCOS GmbH';
            case AMixerCaps.wPid of
            MM_BERCOS_WAVEIN                  :Result.Product := 'WAVEIN ';
            MM_BERCOS_MIXER                   :Result.Product := 'MIXER  ';
            MM_BERCOS_WAVEOUT                 :Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ONLIVE                    :
        begin
            Result.Manufacturer := 'OnLive! Technologies, Inc.';
            case AMixerCaps.wPid of
            MM_ONLIVE_MPCODEC                 :Result.Product := 'MPCODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SIEMENS_SBC               :
        begin
            Result.Manufacturer := 'Siemens Business Communications Systems';
            Result.Product := 'Unmapped Product';
        end;
        MM_TERALOGIC                 :
        begin
            Result.Manufacturer := 'TeraLogic, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_PHONET                    :
        begin
            Result.Manufacturer := 'PhoNet Communications Ltd.';
            case AMixerCaps.wPid of
            MM_PHONET_PP_WAVEOUT              :Result.Product := 'PP_WAVEOUT';
            MM_PHONET_PP_WAVEIN               :Result.Product := 'PP_WAVEIN ';
            MM_PHONET_PP_MIXER                :Result.Product := 'PP_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_WINBOND                   :
        begin
            Result.Manufacturer := 'Winbond Electronics Corp';
            Result.Product := 'Unmapped Product';
        end;
        MM_VIRTUALMUSIC              :
        begin
            Result.Manufacturer := 'Virtual Music, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_ENET                      :
        begin
            Result.Manufacturer := 'e-Net, Inc.';
            case AMixerCaps.wPid of
            MM_ENET_T2000_LINEIN              :Result.Product := 'LINEIN    ';
            MM_ENET_T2000_LINEOUT             :Result.Product := 'LINEOUT   ';
            MM_ENET_T2000_HANDSETIN           :Result.Product := 'HANDSETIN ';
            MM_ENET_T2000_HANDSETOUT          :Result.Product := 'HANDSETOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_GUILLEMOT                 :
        begin
            Result.Manufacturer := 'Guillemot International';
            Result.Product := 'Unmapped Product';
        end;
        MM_EMAGIC                    :
        begin
            Result.Manufacturer := 'Emagic Soft- und Hardware GmbH';
            case AMixerCaps.wPid of
            MM_EMAGIC_UNITOR8                 :Result.Product := 'UNITOR8';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MWM                       :
        begin
            Result.Manufacturer := 'MWM Acoustics LLC';
            Result.Product := 'Unmapped Product';
        end;
        MM_PACIFICRESEARCH           :
        begin
            Result.Manufacturer := 'Pacific Research and Engineering Corporation';
            Result.Product := 'Unmapped Product';
        end;
        MM_SIPROLAB                  :
        begin
            Result.Manufacturer := 'Sipro Lab Telecom Inc.';
            case AMixerCaps.wPid of
            MM_SIPROLAB_ACELPNET              :Result.Product := 'ACELPNET';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LYNX                      :
        begin
            Result.Manufacturer := 'Lynx Studio Technology, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_SPECTRUM_PRODUCTIONS      :
        begin
            Result.Manufacturer := 'Spectrum Productions';
            Result.Product := 'Unmapped Product';
        end;
        MM_DICTAPHONE                :
        begin
            Result.Manufacturer := 'Dictaphone Corporation';
            case AMixerCaps.wPid of
            MM_DICTAPHONE_G726                :Result.Product := 'G726 ACM codec (g726pcm.acm)';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_QUALCOMM                  :
        begin
            Result.Manufacturer := 'QUALCOMM, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_RZS                       :
        begin
            Result.Manufacturer := 'Ring Zero Systems, Inc';
            case AMixerCaps.wPid of
            MM_RZS_ACM_TUBGSM                 :Result.Product := 'GSM 06.10 CODEC';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_AUDIOSCIENCE              :
        begin
            Result.Manufacturer := 'AudioScience Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_PINNACLE                  :
        begin
            Result.Manufacturer := 'Pinnacle Systems, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_EES                       :
        begin
            Result.Manufacturer := 'EES Technik fuer Musik GmbH';
            case AMixerCaps.wPid of
            MM_EES_PCMIDI14                   :Result.Product := 'PCMIDI14     ';
            MM_EES_PCMIDI14_IN                :Result.Product := 'PCMIDI14_IN  ';
            MM_EES_PCMIDI14_OUT1              :Result.Product := 'PCMIDI14_OUT1';
            MM_EES_PCMIDI14_OUT2              :Result.Product := 'PCMIDI14_OUT2';
            MM_EES_PCMIDI14_OUT3              :Result.Product := 'PCMIDI14_OUT3';
            MM_EES_PCMIDI14_OUT4              :Result.Product := 'PCMIDI14_OUT4';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_HAFTMANN                  :
        begin
            Result.Manufacturer := 'haftmann#software';
            case AMixerCaps.wPid of
            MM_HAFTMANN_LPTDAC2               :Result.Product := 'LPTDAC2';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LUCID                     :
        begin
            Result.Manufacturer := 'Lucid Technology, Symetrix Inc.';
            case AMixerCaps.wPid of
            MM_LUCID_PCI24WAVEIN              :Result.Product := 'PCI24WAVEIN ';
            MM_LUCID_PCI24WAVEOUT             :Result.Product := 'PCI24WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_HEADSPACE                 :
        begin
            Result.Manufacturer := 'Headspace, Inc';
            case AMixerCaps.wPid of
            MM_HEADSPACE_HAESYNTH             :Result.Product := 'HAESYNTH  ';
            MM_HEADSPACE_HAEWAVEOUT           :Result.Product := 'HAEWAVEOUT';
            MM_HEADSPACE_HAEWAVEIN            :Result.Product := 'HAEWAVEIN ';
            MM_HEADSPACE_HAEMIXER             :Result.Product := 'HAEMIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_UNISYS                    :
        begin
            Result.Manufacturer := 'UNISYS CORPORATION';
            case AMixerCaps.wPid of
            MM_UNISYS_ACM_NAP                 :Result.Product := 'ACM_NAP';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LUMINOSITI                :
        begin
            Result.Manufacturer := 'Luminositi, Inc.';
            case AMixerCaps.wPid of
            MM_LUMINOSITI_SCWAVEIN            :Result.Product := 'SCWAVEIN ';
            MM_LUMINOSITI_SCWAVEOUT           :Result.Product := 'SCWAVEOUT';
            MM_LUMINOSITI_SCWAVEMIX           :Result.Product := 'SCWAVEMIX';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ACTIVEVOICE               :
        begin
            Result.Manufacturer := 'ACTIVE VOICE CORPORATION';
            case AMixerCaps.wPid of
            MM_ACTIVEVOICE_ACM_VOXADPCM       :Result.Product := 'ACM_VOXADPCM';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DTS                       :
        begin
            Result.Manufacturer := 'Digital Theater Systems, Inc.';
            case AMixerCaps.wPid of
            MM_DTS_DS                         :Result.Product := 'DS';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_DIGIGRAM                  :
        begin
            Result.Manufacturer := 'DIGIGRAM';
            Result.Product := 'Unmapped Product';
        end;
        MM_SOFTLAB_NSK               :
        begin
            Result.Manufacturer := 'Softlab-Nsk';
            case AMixerCaps.wPid of
            MM_SOFTLAB_NSK_FRW_WAVEIN         :Result.Product := 'FRW_WAVEIN ';
            MM_SOFTLAB_NSK_FRW_WAVEOUT        :Result.Product := 'FRW_WAVEOUT';
            MM_SOFTLAB_NSK_FRW_MIXER          :Result.Product := 'FRW_MIXER  ';
            MM_SOFTLAB_NSK_FRW_AUX            :Result.Product := 'FRW_AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_FORTEMEDIA                :
        begin
            Result.Manufacturer := 'ForteMedia, Inc';
            case AMixerCaps.wPid of
            MM_FORTEMEDIA_WAVEIN              :Result.Product := 'WAVEIN ';
            MM_FORTEMEDIA_WAVEOUT             :Result.Product := 'WAVEOUT';
            MM_FORTEMEDIA_FMSYNC              :Result.Product := 'FMSYNC ';
            MM_FORTEMEDIA_MIXER               :Result.Product := 'MIXER  ';
            MM_FORTEMEDIA_AUX                 :Result.Product := 'AUX    ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SONORUS                   :
        begin
            Result.Manufacturer := 'Sonorus, Inc.';
            case AMixerCaps.wPid of
            MM_SONORUS_STUDIO                 :Result.Product := 'STUDIO';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ARRAY                     :
        begin
            Result.Manufacturer := 'Array Microsystems, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_DATARAN                   :
        begin
            Result.Manufacturer := 'Data Translation, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_I_LINK                    :
        begin
            Result.Manufacturer := 'I-link Worldwide';
            case AMixerCaps.wPid of
            MM_I_LINK_VOICE_CODER             :Result.Product := 'VOICE_CODER';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SELSIUS_SYSTEMS           :
        begin
            Result.Manufacturer := 'Selsius Systems Inc.';
            case AMixerCaps.wPid of
            MM_SELSIUS_SYSTEMS_RTPWAVEOUT     :Result.Product := 'RTPWAVEOUT';
            MM_SELSIUS_SYSTEMS_RTPWAVEIN      :Result.Product := 'RTPWAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ADMOS                     :
        begin
            Result.Manufacturer := 'AdMOS Technology, Inc.';
            case AMixerCaps.wPid of
            MM_ADMOS_FM_SYNTH                 :Result.Product := 'FM_SYNTH   ';
            MM_ADMOS_QS3AMIDIOUT              :Result.Product := 'QS3AMIDIOUT';
            MM_ADMOS_QS3AMIDIIN               :Result.Product := 'QS3AMIDIIN ';
            MM_ADMOS_QS3AWAVEOUT              :Result.Product := 'QS3AWAVEOUT';
            MM_ADMOS_QS3AWAVEIN               :Result.Product := 'QS3AWAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_LEXICON                   :
        begin
            Result.Manufacturer := 'Lexicon Inc.';
            case AMixerCaps.wPid of
            MM_LEXICON_STUDIO_WAVE_OUT        :Result.Product := 'STUDIO_WAVE_OUT';
            MM_LEXICON_STUDIO_WAVE_IN         :Result.Product := 'STUDIO_WAVE_IN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SGI                       :
        begin
            Result.Manufacturer := 'Silicon Graphics Inc.';
            case AMixerCaps.wPid of
            MM_SGI_320_WAVEIN                 :Result.Product := '320_WAVEIN ';
            MM_SGI_320_WAVEOUT                :Result.Product := '320_WAVEOUT';
            MM_SGI_320_MIXER                  :Result.Product := '320_MIXER  ';
            MM_SGI_540_WAVEIN                 :Result.Product := '540_WAVEIN ';
            MM_SGI_540_WAVEOUT                :Result.Product := '540_WAVEOUT';
            MM_SGI_540_MIXER                  :Result.Product := '540_MIXER  ';
            MM_SGI_RAD_ADATMONO1_WAVEIN       :Result.Product := 'RAD_ADATMONO1_WAVEIN';
            MM_SGI_RAD_ADATMONO2_WAVEIN       :Result.Product := 'RAD_ADATMONO2_WAVEIN';
            MM_SGI_RAD_ADATMONO3_WAVEIN       :Result.Product := 'RAD_ADATMONO3_WAVEIN';
            MM_SGI_RAD_ADATMONO4_WAVEIN       :Result.Product := 'RAD_ADATMONO4_WAVEIN';
            MM_SGI_RAD_ADATMONO5_WAVEIN       :Result.Product := 'RAD_ADATMONO5_WAVEIN';
            MM_SGI_RAD_ADATMONO6_WAVEIN       :Result.Product := 'RAD_ADATMONO6_WAVEIN';
            MM_SGI_RAD_ADATMONO7_WAVEIN       :Result.Product := 'RAD_ADATMONO7_WAVEIN';
            MM_SGI_RAD_ADATMONO8_WAVEIN       :Result.Product := 'RAD_ADATMONO8_WAVEIN';
            MM_SGI_RAD_ADATSTEREO12_WAVEIN    :Result.Product := 'RAD_ADATSTEREO12_WAVEIN';
            MM_SGI_RAD_ADATSTEREO34_WAVEIN    :Result.Product := 'RAD_ADATSTEREO34_WAVEIN';
            MM_SGI_RAD_ADATSTEREO56_WAVEIN    :Result.Product := 'RAD_ADATSTEREO56_WAVEIN';
            MM_SGI_RAD_ADATSTEREO78_WAVEIN    :Result.Product := 'RAD_ADATSTEREO78_WAVEIN';
            MM_SGI_RAD_ADAT8CHAN_WAVEIN       :Result.Product := 'RAD_ADAT8CHAN_WAVEIN ';
            MM_SGI_RAD_ADATMONO1_WAVEOUT      :Result.Product := 'RAD_ADATMONO1_WAVEOUT';
            MM_SGI_RAD_ADATMONO2_WAVEOUT      :Result.Product := 'RAD_ADATMONO2_WAVEOUT';
            MM_SGI_RAD_ADATMONO3_WAVEOUT      :Result.Product := 'RAD_ADATMONO3_WAVEOUT';
            MM_SGI_RAD_ADATMONO4_WAVEOUT      :Result.Product := 'RAD_ADATMONO4_WAVEOUT';
            MM_SGI_RAD_ADATMONO5_WAVEOUT      :Result.Product := 'RAD_ADATMONO5_WAVEOUT';
            MM_SGI_RAD_ADATMONO6_WAVEOUT      :Result.Product := 'RAD_ADATMONO6_WAVEOUT';
            MM_SGI_RAD_ADATMONO7_WAVEOUT      :Result.Product := 'RAD_ADATMONO7_WAVEOUT';
            MM_SGI_RAD_ADATMONO8_WAVEOUT      :Result.Product := 'RAD_ADATMONO8_WAVEOUT';
            MM_SGI_RAD_ADATSTEREO12_WAVEOUT   :Result.Product := 'RAD_ADATSTEREO12_WAVEOUT';
            MM_SGI_RAD_ADATSTEREO32_WAVEOUT   :Result.Product := 'RAD_ADATSTEREO32_WAVEOUT';
            MM_SGI_RAD_ADATSTEREO56_WAVEOUT   :Result.Product := 'RAD_ADATSTEREO56_WAVEOUT';
            MM_SGI_RAD_ADATSTEREO78_WAVEOUT   :Result.Product := 'RAD_ADATSTEREO78_WAVEOUT';
            MM_SGI_RAD_ADAT8CHAN_WAVEOUT      :Result.Product := 'RAD_ADAT8CHAN_WAVEOUT';
            MM_SGI_RAD_AESMONO1_WAVEIN        :Result.Product := 'RAD_AESMONO1_WAVEIN  ';
            MM_SGI_RAD_AESMONO2_WAVEIN        :Result.Product := 'RAD_AESMONO2_WAVEIN  ';
            MM_SGI_RAD_AESSTEREO_WAVEIN       :Result.Product := 'RAD_AESSTEREO_WAVEIN ';
            MM_SGI_RAD_AESMONO1_WAVEOUT       :Result.Product := 'RAD_AESMONO1_WAVEOUT ';
            MM_SGI_RAD_AESMONO2_WAVEOUT       :Result.Product := 'RAD_AESMONO2_WAVEOUT ';
            MM_SGI_RAD_AESSTEREO_WAVEOUT      :Result.Product := 'RAD_AESSTEREO_WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_IPI                       :
        begin
            Result.Manufacturer := 'Interactive Product Inc.';
            case AMixerCaps.wPid of
            MM_IPI_ACM_HSX                    :Result.Product := 'ACM_HSX   ';
            MM_IPI_ACM_RPELP                  :Result.Product := 'ACM_RPELP ';
            MM_IPI_WF_ASSS                    :Result.Product := 'WF_ASSS   ';
            MM_IPI_AT_WAVEOUT                 :Result.Product := 'AT_WAVEOUT';
            MM_IPI_AT_WAVEIN                  :Result.Product := 'AT_WAVEIN ';
            MM_IPI_AT_MIXER                   :Result.Product := 'AT_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ICE                       :
        begin
            Result.Manufacturer := 'IC Ensemble, Inc.';
            case AMixerCaps.wPid of
            MM_ICE_WAVEOUT                    :Result.Product := 'WAVEOUT  ';
            MM_ICE_WAVEIN                     :Result.Product := 'WAVEIN   ';
            MM_ICE_MTWAVEOUT                  :Result.Product := 'MTWAVEOUT';
            MM_ICE_MTWAVEIN                   :Result.Product := 'MTWAVEIN ';
            MM_ICE_MIDIOUT1                   :Result.Product := 'MIDIOUT1 ';
            MM_ICE_MIDIIN1                    :Result.Product := 'MIDIIN1  ';
            MM_ICE_MIDIOUT2                   :Result.Product := 'MIDIOUT2 ';
            MM_ICE_MIDIIN2                    :Result.Product := 'MIDIIN2  ';
            MM_ICE_SYNTH                      :Result.Product := 'SYNTH    ';
            MM_ICE_MIXER                      :Result.Product := 'MIXER    ';
            MM_ICE_AUX                        :Result.Product := 'AUX      ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VQST                      :
        begin
            Result.Manufacturer := 'ViewQuest Technologies Inc.';
            case AMixerCaps.wPid of
            MM_VQST_VQC1                      :Result.Product := 'VQC1';
            MM_VQST_VQC2                      :Result.Product := 'VQC2';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ETEK                      :
        begin
            Result.Manufacturer := 'eTEK Labs Inc.';
            case AMixerCaps.wPid of
            MM_ETEK_KWIKMIDI_MIDIIN           :Result.Product := 'MIDIIN ';
            MM_ETEK_KWIKMIDI_MIDIOUT          :Result.Product := 'MIDIOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_CS                        :
        begin
            Result.Manufacturer := 'Consistent Software';
            Result.Product := 'Unmapped Product';
        end;
        MM_ALESIS                    :
        begin
            Result.Manufacturer := 'Alesis Studio Electronics';
            Result.Product := 'Unmapped Product';
        end;
        MM_INTERNET                  :
        begin
            Result.Manufacturer := 'INTERNET Corporation';
            case AMixerCaps.wPid of
            MM_INTERNET_SSW_MIDIOUT           :Result.Product := 'SSW_MIDIOUT';
            MM_INTERNET_SSW_MIDIIN            :Result.Product := 'SSW_MIDIIN ';
            MM_INTERNET_SSW_WAVEOUT           :Result.Product := 'SSW_WAVEOUT';
            MM_INTERNET_SSW_WAVEIN            :Result.Product := 'SSW_WAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SONY                      :
        begin
            Result.Manufacturer := 'Sony Corporation';
            case AMixerCaps.wPid of
            MM_SONY_ACM_SCX                   : Result.Product := 'ACM_SCX';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_HYPERACTIVE               :
        begin
            Result.Manufacturer := 'Hyperactive Audio Systems, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_UHER_INFORMATIC           :
        begin
            Result.Manufacturer := 'UHER informatic GmbH';
            case AMixerCaps.wPid of
            MM_UH_ACM_ADPCM                   : Result.Product := 'ACM_ADPCM';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_SYDEC_NV                  :
        begin
            Result.Manufacturer := 'Sydec NV';
            case AMixerCaps.wPid of
            MM_SYDEC_NV_WAVEIN                : Result.Product := 'WAVEIN ';
            MM_SYDEC_NV_WAVEOUT               : Result.Product := 'WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_FLEXION                   :
        begin
            Result.Manufacturer := 'Flexion Systems Ltd.';
            case AMixerCaps.wPid of
            MM_FLEXION_X300_WAVEIN            : Result.Product := 'X300_WAVEIN ';
            MM_FLEXION_X300_WAVEOUT           : Result.Product := 'X300_WAVEOUT';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_VIA                       :
        begin
            Result.Manufacturer := 'Via Technologies, Inc.';
            case AMixerCaps.wPid of
            MM_VIA_WAVEOUT                    : Result.Product := 'WAVEOUT           ';
            MM_VIA_WAVEIN                     : Result.Product := 'WAVEIN            ';
            MM_VIA_MIXER                      : Result.Product := 'MIXER             ';
            MM_VIA_AUX                        : Result.Product := 'AUX               ';
            MM_VIA_MPU401_MIDIOUT             : Result.Product := 'MPU401_MIDIOUT    ';
            MM_VIA_MPU401_MIDIIN              : Result.Product := 'MPU401_MIDIIN     ';
            MM_VIA_SWFM_SYNTH                 : Result.Product := 'SWFM_SYNTH        ';
            MM_VIA_WDM_WAVEOUT                : Result.Product := 'WDM_WAVEOUT       ';
            MM_VIA_WDM_WAVEIN                 : Result.Product := 'WDM_WAVEIN        ';
            MM_VIA_WDM_MIXER                  : Result.Product := 'WDM_MIXER         ';
            MM_VIA_WDM_MPU401_MIDIOUT         : Result.Product := 'WDM_MPU401_MIDIOUT';
            MM_VIA_WDM_MPU401_MIDIIN          : Result.Product := 'WDM_MPU401_MIDIIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MICRONAS                  :
        begin
            Result.Manufacturer := 'Micronas Semiconductors, Inc.';
            case AMixerCaps.wPid of
            MM_MICRONAS_SC4                   : Result.Product := 'SC4   ';
            MM_MICRONAS_CLP833                : Result.Product := 'CLP833';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ANALOGDEVICES             :
        begin
            Result.Manufacturer := 'Analog Devices, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_HP                        :
        begin
            Result.Manufacturer := 'Hewlett Packard Company';
            case AMixerCaps.wPid of
            MM_HP_WAVEOUT                     : Result.Product := '';
            MM_HP_WAVEIN                      : Result.Product := '';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MATROX_DIV                :
        begin
            Result.Manufacturer := 'Matrox';
            Result.Product := 'Unmapped Product';
        end;
        MM_QUICKAUDIO                :
        begin
            Result.Manufacturer := 'Quick Audio, GbR';
            case AMixerCaps.wPid of
            MM_QUICKAUDIO_MINIMIDI            : Result.Product := 'MINIMIDI';
            MM_QUICKAUDIO_MAXIMIDI            : Result.Product := 'MAXIMIDI';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_YOUCOM                    :
        begin
            Result.Manufacturer := 'You/Com Audiocommunicatie BV';
            Result.Product := 'Unmapped Product';
        end;
        MM_RICHMOND                  :
        begin
            Result.Manufacturer := 'Richmond Sound Design Ltd.';
            Result.Product := 'Unmapped Product';
        end;
        MM_IODD                      :
        begin
            Result.Manufacturer := 'I-O Data Device, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_ICCC                      :
        begin
            Result.Manufacturer := 'ICCC A/S';
            case AMixerCaps.wPid of
            MM_ICCC_UNA3_WAVEIN               : Result.Product := 'UNA3_WAVEIN ';
            MM_ICCC_UNA3_WAVEOUT              : Result.Product := 'UNA3_WAVEOUT';
            MM_ICCC_UNA3_AUX                  : Result.Product := 'UNA3_AUX    ';
            MM_ICCC_UNA3_MIXER                : Result.Product := 'UNA3_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_3COM                      :
        begin
            Result.Manufacturer := '3COM Corporation';
            case AMixerCaps.wPid of
            MM_3COM_CB_MIXER                  : Result.Product := 'MIXER ';
            MM_3COM_CB_WAVEIN                 : Result.Product := 'WAVEIN';
            MM_3COM_CB_WAVEOUT                : Result.Product := 'WAVEOU';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_MALDEN                    :
        begin
            Result.Manufacturer := 'Malden Electronics Ltd.';
            Result.Product := 'Unmapped Product';
        end;
        MM_3DFX                      :
        begin
            Result.Manufacturer := '3Dfx Interactive, Inc.';
            Result.Product := 'Unmapped Product';
        end;
        MM_MINDMAKER                 :
        begin
            Result.Manufacturer := 'Mindmaker, Inc.';
            case AMixerCaps.wPid of
            MM_MINDMAKER_GC_WAVEIN            : Result.Product := 'GC_WAVEIN ';
            MM_MINDMAKER_GC_WAVEOUT           : Result.Product := 'GC_WAVEOUT';
            MM_MINDMAKER_GC_MIXER             : Result.Product := 'GC_MIXER  ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_TELEKOL                   :
        begin
            Result.Manufacturer := 'Telekol Corp.';
            case AMixerCaps.wPid of
            MM_TELEKOL_WAVEOUT                : Result.Product := 'WAVEOUT';
            MM_TELEKOL_WAVEIN                 : Result.Product := 'WAVEIN ';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        MM_ST_MICROELECTRONICS       :
        begin
            Result.Manufacturer := 'ST Microelectronics';
            Result.Product := 'Unmapped Product';
        end;
        MM_ALGOVISION                :
        begin
            Result.Manufacturer := 'Algo Vision Systems GmbH';
            case AMixerCaps.wPid of
            MM_ALGOVISION_VB80WAVEOUT : Result.Product := 'VB80WAVEOUT';
            MM_ALGOVISION_VB80WAVEIN  : Result.Product := 'VB80WAVEIN';
            MM_ALGOVISION_VB80MIXER   : Result.Product := 'VB80MIXER';
            MM_ALGOVISION_VB80AUX     : Result.Product := 'VB80AUX';
            MM_ALGOVISION_VB80AUX2    : Result.Product := 'VB80AUX2';
            else Result.Product := 'Unmapped Product';
            end;
        end;
        else
        begin
            Result.Manufacturer := 'Unmapped Manufacturer';
            Result.Product := 'Unmapped Product';
        end;
    end;
end;

end.


        
